/* serializer.c generated by valac 0.44.5, the Vala compiler
 * generated from serializer.vala, do not modify */

/*
 * Copyright (C) 2010 Robin Sonefors
 * Copyright (C) 2008-2012 Robert Ancell.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <langinfo.h>
#include <glib/gi18n-lib.h>

typedef enum  {
	DISPLAY_FORMAT_AUTOMATIC,
	DISPLAY_FORMAT_FIXED,
	DISPLAY_FORMAT_SCIENTIFIC,
	DISPLAY_FORMAT_ENGINEERING
} DisplayFormat;

#define TYPE_DISPLAY_FORMAT (display_format_get_type ())

#define TYPE_SERIALIZER (serializer_get_type ())
#define SERIALIZER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SERIALIZER, Serializer))
#define SERIALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SERIALIZER, SerializerClass))
#define IS_SERIALIZER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SERIALIZER))
#define IS_SERIALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SERIALIZER))
#define SERIALIZER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SERIALIZER, SerializerClass))

typedef struct _Serializer Serializer;
typedef struct _SerializerClass SerializerClass;
typedef struct _SerializerPrivate SerializerPrivate;
enum  {
	SERIALIZER_0_PROPERTY,
	SERIALIZER_ERROR_PROPERTY,
	SERIALIZER_NUM_PROPERTIES
};
static GParamSpec* serializer_properties[SERIALIZER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_NUMBER (number_get_type ())
#define NUMBER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER, Number))
#define NUMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER, NumberClass))
#define IS_NUMBER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER))
#define IS_NUMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER))
#define NUMBER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER, NumberClass))

typedef struct _Number Number;
typedef struct _NumberClass NumberClass;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _Serializer {
	GObject parent_instance;
	SerializerPrivate * priv;
};

struct _SerializerClass {
	GObjectClass parent_class;
};

struct _SerializerPrivate {
	gint leading_digits;
	gint trailing_digits;
	DisplayFormat format;
	gboolean show_tsep;
	gboolean show_zeroes;
	gint number_base;
	guint representation_base;
	gunichar radix;
	gunichar tsep;
	gint tsep_count;
	gchar* _error;
};

static gint Serializer_private_offset;
static gpointer serializer_parent_class = NULL;

GType display_format_get_type (void) G_GNUC_CONST;
GType serializer_get_type (void) G_GNUC_CONST;
Serializer* serializer_new (DisplayFormat format,
                            gint number_base,
                            gint trailing_digits);
Serializer* serializer_construct (GType object_type,
                                  DisplayFormat format,
                                  gint number_base,
                                  gint trailing_digits);
GType number_get_type (void) G_GNUC_CONST;
gchar* serializer_to_string (Serializer* self,
                             Number* x);
static gchar* serializer_cast_to_string (Serializer* self,
                                  Number* x,
                                  gint* n_digits);
gint serializer_get_base (Serializer* self);
static gchar* serializer_cast_to_exponential_string (Serializer* self,
                                              Number* x,
                                              gboolean eng_format,
                                              gint* n_digits);
Number* serializer_from_string (Serializer* self,
                                const gchar* str);
Number* mp_set_from_string (const gchar* str,
                            gint default_base);
void serializer_set_base (Serializer* self,
                          gint number_base);
void serializer_set_representation_base (Serializer* self,
                                         guint representation_base);
guint serializer_get_representation_base (Serializer* self);
void serializer_set_radix (Serializer* self,
                           gunichar radix);
gunichar serializer_get_radix (Serializer* self);
void serializer_set_thousands_separator (Serializer* self,
                                         gunichar separator);
gunichar serializer_get_thousands_separator (Serializer* self);
gint serializer_get_thousands_separator_count (Serializer* self);
void serializer_set_thousands_separator_count (Serializer* self,
                                               gint count);
void serializer_set_show_thousands_separators (Serializer* self,
                                               gboolean visible);
gboolean serializer_get_show_thousands_separators (Serializer* self);
void serializer_set_show_trailing_zeroes (Serializer* self,
                                          gboolean visible);
gboolean serializer_get_show_trailing_zeroes (Serializer* self);
gint serializer_get_leading_digits (Serializer* self);
void serializer_set_leading_digits (Serializer* self,
                                    gint leading_digits);
gint serializer_get_trailing_digits (Serializer* self);
void serializer_set_trailing_digits (Serializer* self,
                                     gint trailing_digits);
DisplayFormat serializer_get_number_format (Serializer* self);
void serializer_set_number_format (Serializer* self,
                                   DisplayFormat format);
Number* number_real_component (Number* self);
static void serializer_cast_to_string_real (Serializer* self,
                                     Number* x,
                                     gint number_base,
                                     gboolean force_sign,
                                     gint* n_digits,
                                     GString* string);
gboolean number_is_complex (Number* self);
Number* number_imaginary_component (Number* self);
gboolean number_is_negative (Number* self);
Number* number_abs (Number* self);
Number* number_new_integer (gint64 real,
                            gint64 imag);
Number* number_construct_integer (GType object_type,
                                  gint64 real,
                                  gint64 imag);
Number* number_xpowy_integer (Number* self,
                              gint64 n);
Number* number_multiply_integer (Number* self,
                                 gint64 y);
Number* number_divide_integer (Number* self,
                               gint64 y);
Number* number_add (Number* self,
                    Number* y);
Number* number_floor (Number* self);
gboolean number_is_zero (Number* self);
Number* number_subtract (Number* self,
                         Number* y);
gint64 number_to_integer (Number* self);
void serializer_set_error (Serializer* self,
                           const gchar* value);
Number* number_fractional_component (Number* self);
static gint serializer_cast_to_exponential_string_real (Serializer* self,
                                                 Number* x,
                                                 GString* string,
                                                 gboolean eng_format,
                                                 gint* n_digits);
Number* number_divide (Number* self,
                       Number* y);
gint number_compare (Number* self,
                     Number* y);
Number* number_multiply (Number* self,
                         Number* y);
static void serializer_append_exponent (Serializer* self,
                                 GString* string,
                                 gint exponent);
const gchar* serializer_get_error (Serializer* self);
static void serializer_finalize (GObject * obj);
static void _vala_serializer_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_serializer_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);

GType
display_format_get_type (void)
{
	static volatile gsize display_format_type_id__volatile = 0;
	if (g_once_init_enter (&display_format_type_id__volatile)) {
		static const GEnumValue values[] = {{DISPLAY_FORMAT_AUTOMATIC, "DISPLAY_FORMAT_AUTOMATIC", "automatic"}, {DISPLAY_FORMAT_FIXED, "DISPLAY_FORMAT_FIXED", "fixed"}, {DISPLAY_FORMAT_SCIENTIFIC, "DISPLAY_FORMAT_SCIENTIFIC", "scientific"}, {DISPLAY_FORMAT_ENGINEERING, "DISPLAY_FORMAT_ENGINEERING", "engineering"}, {0, NULL, NULL}};
		GType display_format_type_id;
		display_format_type_id = g_enum_register_static ("DisplayFormat", values);
		g_once_init_leave (&display_format_type_id__volatile, display_format_type_id);
	}
	return display_format_type_id__volatile;
}

static inline gpointer
serializer_get_instance_private (Serializer* self)
{
	return G_STRUCT_MEMBER_P (self, Serializer_private_offset);
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
#line 1210 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1211 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1211 "glib-2.0.vapi"
	return result;
#line 228 "serializer.c"
}

Serializer*
serializer_construct (GType object_type,
                      DisplayFormat format,
                      gint number_base,
                      gint trailing_digits)
{
	Serializer * self = NULL;
	gchar* radix_string = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gchar* tsep_string = NULL;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	const gchar* _tmp12_;
#line 38 "../lib/serializer.vala"
	self = (Serializer*) g_object_new (object_type, NULL);
#line 40 "../lib/serializer.vala"
	_tmp0_ = nl_langinfo (RADIXCHAR);
#line 40 "../lib/serializer.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 40 "../lib/serializer.vala"
	radix_string = _tmp1_;
#line 41 "../lib/serializer.vala"
	_tmp3_ = radix_string;
#line 41 "../lib/serializer.vala"
	if (_tmp3_ != NULL) {
#line 260 "serializer.c"
		const gchar* _tmp4_;
#line 41 "../lib/serializer.vala"
		_tmp4_ = radix_string;
#line 41 "../lib/serializer.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") != 0;
#line 266 "serializer.c"
	} else {
#line 41 "../lib/serializer.vala"
		_tmp2_ = FALSE;
#line 270 "serializer.c"
	}
#line 41 "../lib/serializer.vala"
	if (_tmp2_) {
#line 274 "serializer.c"
		gchar* radix_utf8 = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
#line 42 "../lib/serializer.vala"
		_tmp5_ = radix_string;
#line 42 "../lib/serializer.vala"
		_tmp6_ = g_locale_to_utf8 (_tmp5_, (gssize) -1, NULL, NULL, NULL);
#line 42 "../lib/serializer.vala"
		radix_utf8 = _tmp6_;
#line 43 "../lib/serializer.vala"
		_tmp7_ = radix_utf8;
#line 43 "../lib/serializer.vala"
		if (_tmp7_ != NULL) {
#line 289 "serializer.c"
			const gchar* _tmp8_;
#line 44 "../lib/serializer.vala"
			_tmp8_ = radix_utf8;
#line 44 "../lib/serializer.vala"
			self->priv->radix = string_get_char (_tmp8_, (glong) 0);
#line 295 "serializer.c"
		} else {
#line 46 "../lib/serializer.vala"
			self->priv->radix = (gunichar) '.';
#line 299 "serializer.c"
		}
#line 41 "../lib/serializer.vala"
		_g_free0 (radix_utf8);
#line 303 "serializer.c"
	} else {
#line 49 "../lib/serializer.vala"
		self->priv->radix = (gunichar) '.';
#line 307 "serializer.c"
	}
#line 50 "../lib/serializer.vala"
	_tmp9_ = nl_langinfo (THOUSEP);
#line 50 "../lib/serializer.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 50 "../lib/serializer.vala"
	tsep_string = _tmp10_;
#line 51 "../lib/serializer.vala"
	_tmp12_ = tsep_string;
#line 51 "../lib/serializer.vala"
	if (_tmp12_ != NULL) {
#line 319 "serializer.c"
		const gchar* _tmp13_;
#line 51 "../lib/serializer.vala"
		_tmp13_ = tsep_string;
#line 51 "../lib/serializer.vala"
		_tmp11_ = g_strcmp0 (_tmp13_, "") != 0;
#line 325 "serializer.c"
	} else {
#line 51 "../lib/serializer.vala"
		_tmp11_ = FALSE;
#line 329 "serializer.c"
	}
#line 51 "../lib/serializer.vala"
	if (_tmp11_) {
#line 333 "serializer.c"
		gchar* tsep_utf8 = NULL;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
#line 52 "../lib/serializer.vala"
		_tmp14_ = tsep_string;
#line 52 "../lib/serializer.vala"
		_tmp15_ = g_locale_to_utf8 (_tmp14_, (gssize) -1, NULL, NULL, NULL);
#line 52 "../lib/serializer.vala"
		tsep_utf8 = _tmp15_;
#line 53 "../lib/serializer.vala"
		_tmp16_ = tsep_utf8;
#line 53 "../lib/serializer.vala"
		if (_tmp16_ != NULL) {
#line 348 "serializer.c"
			const gchar* _tmp17_;
#line 54 "../lib/serializer.vala"
			_tmp17_ = tsep_utf8;
#line 54 "../lib/serializer.vala"
			self->priv->tsep = string_get_char (_tmp17_, (glong) 0);
#line 354 "serializer.c"
		} else {
#line 56 "../lib/serializer.vala"
			self->priv->tsep = (gunichar) ' ';
#line 358 "serializer.c"
		}
#line 51 "../lib/serializer.vala"
		_g_free0 (tsep_utf8);
#line 362 "serializer.c"
	} else {
#line 59 "../lib/serializer.vala"
		self->priv->tsep = (gunichar) ' ';
#line 366 "serializer.c"
	}
#line 60 "../lib/serializer.vala"
	self->priv->tsep_count = 3;
#line 62 "../lib/serializer.vala"
	self->priv->number_base = number_base;
#line 63 "../lib/serializer.vala"
	self->priv->representation_base = (guint) number_base;
#line 64 "../lib/serializer.vala"
	self->priv->leading_digits = 12;
#line 65 "../lib/serializer.vala"
	self->priv->trailing_digits = trailing_digits;
#line 66 "../lib/serializer.vala"
	self->priv->show_zeroes = FALSE;
#line 67 "../lib/serializer.vala"
	self->priv->show_tsep = FALSE;
#line 68 "../lib/serializer.vala"
	self->priv->format = format;
#line 38 "../lib/serializer.vala"
	_g_free0 (tsep_string);
#line 38 "../lib/serializer.vala"
	_g_free0 (radix_string);
#line 38 "../lib/serializer.vala"
	return self;
#line 390 "serializer.c"
}

Serializer*
serializer_new (DisplayFormat format,
                gint number_base,
                gint trailing_digits)
{
#line 38 "../lib/serializer.vala"
	return serializer_construct (TYPE_SERIALIZER, format, number_base, trailing_digits);
#line 400 "serializer.c"
}

gchar*
serializer_to_string (Serializer* self,
                      Number* x)
{
	gchar* result = NULL;
	DisplayFormat _tmp1_;
#line 71 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../lib/serializer.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 74 "../lib/serializer.vala"
	if (self->priv->representation_base != ((guint) self->priv->number_base)) {
#line 415 "serializer.c"
		gint n_digits = 0;
		gchar* _tmp0_;
#line 76 "../lib/serializer.vala"
		n_digits = 0;
#line 77 "../lib/serializer.vala"
		_tmp0_ = serializer_cast_to_string (self, x, &n_digits);
#line 77 "../lib/serializer.vala"
		result = _tmp0_;
#line 77 "../lib/serializer.vala"
		return result;
#line 426 "serializer.c"
	}
#line 79 "../lib/serializer.vala"
	_tmp1_ = self->priv->format;
#line 79 "../lib/serializer.vala"
	switch (_tmp1_) {
#line 432 "serializer.c"
		default:
#line 79 "../lib/serializer.vala"
		case DISPLAY_FORMAT_AUTOMATIC:
#line 436 "serializer.c"
		{
			gint n_digits = 0;
			gchar* s0 = NULL;
			gchar* _tmp2_;
#line 83 "../lib/serializer.vala"
			n_digits = 0;
#line 84 "../lib/serializer.vala"
			_tmp2_ = serializer_cast_to_string (self, x, &n_digits);
#line 84 "../lib/serializer.vala"
			s0 = _tmp2_;
#line 86 "../lib/serializer.vala"
			switch (serializer_get_base (self)) {
#line 86 "../lib/serializer.vala"
				case 2:
#line 451 "serializer.c"
				{
#line 90 "../lib/serializer.vala"
					if (n_digits <= 64) {
#line 91 "../lib/serializer.vala"
						result = s0;
#line 91 "../lib/serializer.vala"
						return result;
#line 459 "serializer.c"
					} else {
						gchar* _tmp3_;
#line 93 "../lib/serializer.vala"
						_tmp3_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 93 "../lib/serializer.vala"
						result = _tmp3_;
#line 93 "../lib/serializer.vala"
						_g_free0 (s0);
#line 93 "../lib/serializer.vala"
						return result;
#line 470 "serializer.c"
					}
				}
#line 86 "../lib/serializer.vala"
				case 8:
#line 475 "serializer.c"
				{
#line 96 "../lib/serializer.vala"
					if (n_digits <= 22) {
#line 97 "../lib/serializer.vala"
						result = s0;
#line 97 "../lib/serializer.vala"
						return result;
#line 483 "serializer.c"
					} else {
						gchar* _tmp4_;
#line 99 "../lib/serializer.vala"
						_tmp4_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 99 "../lib/serializer.vala"
						result = _tmp4_;
#line 99 "../lib/serializer.vala"
						_g_free0 (s0);
#line 99 "../lib/serializer.vala"
						return result;
#line 494 "serializer.c"
					}
				}
#line 86 "../lib/serializer.vala"
				case 16:
#line 499 "serializer.c"
				{
#line 102 "../lib/serializer.vala"
					if (n_digits <= 16) {
#line 103 "../lib/serializer.vala"
						result = s0;
#line 103 "../lib/serializer.vala"
						return result;
#line 507 "serializer.c"
					} else {
						gchar* _tmp5_;
#line 105 "../lib/serializer.vala"
						_tmp5_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 105 "../lib/serializer.vala"
						result = _tmp5_;
#line 105 "../lib/serializer.vala"
						_g_free0 (s0);
#line 105 "../lib/serializer.vala"
						return result;
#line 518 "serializer.c"
					}
				}
				default:
#line 86 "../lib/serializer.vala"
				case 10:
#line 524 "serializer.c"
				{
#line 109 "../lib/serializer.vala"
					if (n_digits <= self->priv->leading_digits) {
#line 110 "../lib/serializer.vala"
						result = s0;
#line 110 "../lib/serializer.vala"
						return result;
#line 532 "serializer.c"
					} else {
						gchar* _tmp6_;
#line 112 "../lib/serializer.vala"
						_tmp6_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 112 "../lib/serializer.vala"
						result = _tmp6_;
#line 112 "../lib/serializer.vala"
						_g_free0 (s0);
#line 112 "../lib/serializer.vala"
						return result;
#line 543 "serializer.c"
					}
				}
			}
#line 79 "../lib/serializer.vala"
			_g_free0 (s0);
#line 549 "serializer.c"
		}
#line 79 "../lib/serializer.vala"
		case DISPLAY_FORMAT_FIXED:
#line 553 "serializer.c"
		{
			gint n_digits = 0;
			gchar* _tmp7_;
#line 115 "../lib/serializer.vala"
			n_digits = 0;
#line 116 "../lib/serializer.vala"
			_tmp7_ = serializer_cast_to_string (self, x, &n_digits);
#line 116 "../lib/serializer.vala"
			result = _tmp7_;
#line 116 "../lib/serializer.vala"
			return result;
#line 565 "serializer.c"
		}
#line 79 "../lib/serializer.vala"
		case DISPLAY_FORMAT_SCIENTIFIC:
#line 569 "serializer.c"
		{
#line 118 "../lib/serializer.vala"
			if (self->priv->representation_base == ((guint) 10)) {
#line 573 "serializer.c"
				gint n_digits = 0;
				gchar* _tmp8_;
#line 120 "../lib/serializer.vala"
				n_digits = 0;
#line 121 "../lib/serializer.vala"
				_tmp8_ = serializer_cast_to_exponential_string (self, x, FALSE, &n_digits);
#line 121 "../lib/serializer.vala"
				result = _tmp8_;
#line 121 "../lib/serializer.vala"
				return result;
#line 584 "serializer.c"
			} else {
				gint n_digits = 0;
				gchar* _tmp9_;
#line 125 "../lib/serializer.vala"
				n_digits = 0;
#line 126 "../lib/serializer.vala"
				_tmp9_ = serializer_cast_to_string (self, x, &n_digits);
#line 126 "../lib/serializer.vala"
				result = _tmp9_;
#line 126 "../lib/serializer.vala"
				return result;
#line 596 "serializer.c"
			}
		}
#line 79 "../lib/serializer.vala"
		case DISPLAY_FORMAT_ENGINEERING:
#line 601 "serializer.c"
		{
#line 129 "../lib/serializer.vala"
			if (self->priv->representation_base == ((guint) 10)) {
#line 605 "serializer.c"
				gint n_digits = 0;
				gchar* _tmp10_;
#line 131 "../lib/serializer.vala"
				n_digits = 0;
#line 132 "../lib/serializer.vala"
				_tmp10_ = serializer_cast_to_exponential_string (self, x, TRUE, &n_digits);
#line 132 "../lib/serializer.vala"
				result = _tmp10_;
#line 132 "../lib/serializer.vala"
				return result;
#line 616 "serializer.c"
			} else {
				gint n_digits = 0;
				gchar* _tmp11_;
#line 136 "../lib/serializer.vala"
				n_digits = 0;
#line 137 "../lib/serializer.vala"
				_tmp11_ = serializer_cast_to_string (self, x, &n_digits);
#line 137 "../lib/serializer.vala"
				result = _tmp11_;
#line 137 "../lib/serializer.vala"
				return result;
#line 628 "serializer.c"
			}
		}
	}
}

Number*
serializer_from_string (Serializer* self,
                        const gchar* str)
{
	Number* result = NULL;
	Number* _tmp0_;
#line 142 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 142 "../lib/serializer.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 145 "../lib/serializer.vala"
	_tmp0_ = mp_set_from_string (str, self->priv->number_base);
#line 145 "../lib/serializer.vala"
	result = _tmp0_;
#line 145 "../lib/serializer.vala"
	return result;
#line 650 "serializer.c"
}

void
serializer_set_base (Serializer* self,
                     gint number_base)
{
#line 148 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 150 "../lib/serializer.vala"
	self->priv->number_base = number_base;
#line 661 "serializer.c"
}

gint
serializer_get_base (Serializer* self)
{
	gint result = 0;
#line 153 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 155 "../lib/serializer.vala"
	result = self->priv->number_base;
#line 155 "../lib/serializer.vala"
	return result;
#line 674 "serializer.c"
}

void
serializer_set_representation_base (Serializer* self,
                                    guint representation_base)
{
#line 158 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 160 "../lib/serializer.vala"
	self->priv->representation_base = representation_base;
#line 685 "serializer.c"
}

guint
serializer_get_representation_base (Serializer* self)
{
	guint result = 0U;
#line 163 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 165 "../lib/serializer.vala"
	result = self->priv->representation_base;
#line 165 "../lib/serializer.vala"
	return result;
#line 698 "serializer.c"
}

void
serializer_set_radix (Serializer* self,
                      gunichar radix)
{
#line 168 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 170 "../lib/serializer.vala"
	self->priv->radix = radix;
#line 709 "serializer.c"
}

gunichar
serializer_get_radix (Serializer* self)
{
	gunichar result = 0U;
#line 173 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 175 "../lib/serializer.vala"
	result = self->priv->radix;
#line 175 "../lib/serializer.vala"
	return result;
#line 722 "serializer.c"
}

void
serializer_set_thousands_separator (Serializer* self,
                                    gunichar separator)
{
#line 178 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 180 "../lib/serializer.vala"
	self->priv->tsep = separator;
#line 733 "serializer.c"
}

gunichar
serializer_get_thousands_separator (Serializer* self)
{
	gunichar result = 0U;
#line 183 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 185 "../lib/serializer.vala"
	result = self->priv->tsep;
#line 185 "../lib/serializer.vala"
	return result;
#line 746 "serializer.c"
}

gint
serializer_get_thousands_separator_count (Serializer* self)
{
	gint result = 0;
#line 188 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 190 "../lib/serializer.vala"
	result = self->priv->tsep_count;
#line 190 "../lib/serializer.vala"
	return result;
#line 759 "serializer.c"
}

void
serializer_set_thousands_separator_count (Serializer* self,
                                          gint count)
{
#line 193 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 195 "../lib/serializer.vala"
	self->priv->tsep_count = count;
#line 770 "serializer.c"
}

void
serializer_set_show_thousands_separators (Serializer* self,
                                          gboolean visible)
{
#line 198 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 200 "../lib/serializer.vala"
	self->priv->show_tsep = visible;
#line 781 "serializer.c"
}

gboolean
serializer_get_show_thousands_separators (Serializer* self)
{
	gboolean result = FALSE;
#line 203 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 205 "../lib/serializer.vala"
	result = self->priv->show_tsep;
#line 205 "../lib/serializer.vala"
	return result;
#line 794 "serializer.c"
}

void
serializer_set_show_trailing_zeroes (Serializer* self,
                                     gboolean visible)
{
#line 208 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 210 "../lib/serializer.vala"
	self->priv->show_zeroes = visible;
#line 805 "serializer.c"
}

gboolean
serializer_get_show_trailing_zeroes (Serializer* self)
{
	gboolean result = FALSE;
#line 213 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 215 "../lib/serializer.vala"
	result = self->priv->show_zeroes;
#line 215 "../lib/serializer.vala"
	return result;
#line 818 "serializer.c"
}

gint
serializer_get_leading_digits (Serializer* self)
{
	gint result = 0;
#line 218 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 220 "../lib/serializer.vala"
	result = self->priv->leading_digits;
#line 220 "../lib/serializer.vala"
	return result;
#line 831 "serializer.c"
}

void
serializer_set_leading_digits (Serializer* self,
                               gint leading_digits)
{
#line 223 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 225 "../lib/serializer.vala"
	self->priv->leading_digits = leading_digits;
#line 842 "serializer.c"
}

gint
serializer_get_trailing_digits (Serializer* self)
{
	gint result = 0;
#line 228 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 230 "../lib/serializer.vala"
	result = self->priv->trailing_digits;
#line 230 "../lib/serializer.vala"
	return result;
#line 855 "serializer.c"
}

void
serializer_set_trailing_digits (Serializer* self,
                                gint trailing_digits)
{
#line 233 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 235 "../lib/serializer.vala"
	self->priv->trailing_digits = trailing_digits;
#line 866 "serializer.c"
}

DisplayFormat
serializer_get_number_format (Serializer* self)
{
	DisplayFormat result = 0;
	DisplayFormat _tmp0_;
#line 238 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 240 "../lib/serializer.vala"
	_tmp0_ = self->priv->format;
#line 240 "../lib/serializer.vala"
	result = _tmp0_;
#line 240 "../lib/serializer.vala"
	return result;
#line 882 "serializer.c"
}

void
serializer_set_number_format (Serializer* self,
                              DisplayFormat format)
{
#line 243 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 245 "../lib/serializer.vala"
	self->priv->format = format;
#line 893 "serializer.c"
}

static gchar*
serializer_cast_to_string (Serializer* self,
                           Number* x,
                           gint* n_digits)
{
	gchar* result = NULL;
	GString* string = NULL;
	GString* _tmp0_;
	Number* x_real = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	GString* _tmp3_;
	GString* _tmp37_;
	const gchar* _tmp38_;
	gchar* _tmp39_;
#line 248 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 248 "../lib/serializer.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 250 "../lib/serializer.vala"
	_tmp0_ = g_string_sized_new ((gsize) 1024);
#line 250 "../lib/serializer.vala"
	string = _tmp0_;
#line 252 "../lib/serializer.vala"
	_tmp1_ = number_real_component (x);
#line 252 "../lib/serializer.vala"
	x_real = _tmp1_;
#line 253 "../lib/serializer.vala"
	_tmp2_ = x_real;
#line 253 "../lib/serializer.vala"
	_tmp3_ = string;
#line 253 "../lib/serializer.vala"
	serializer_cast_to_string_real (self, _tmp2_, (gint) self->priv->representation_base, FALSE, n_digits, _tmp3_);
#line 254 "../lib/serializer.vala"
	if (number_is_complex (x)) {
#line 931 "serializer.c"
		Number* x_im = NULL;
		Number* _tmp4_;
		gboolean force_sign = FALSE;
		GString* _tmp5_;
		const gchar* _tmp6_;
		GString* s = NULL;
		GString* _tmp8_;
		gint n_complex_digits = 0;
		Number* _tmp9_;
		GString* _tmp10_;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_ = FALSE;
		GString* _tmp13_;
		const gchar* _tmp14_;
#line 256 "../lib/serializer.vala"
		_tmp4_ = number_imaginary_component (x);
#line 256 "../lib/serializer.vala"
		x_im = _tmp4_;
#line 258 "../lib/serializer.vala"
		force_sign = TRUE;
#line 259 "../lib/serializer.vala"
		_tmp5_ = string;
#line 259 "../lib/serializer.vala"
		_tmp6_ = _tmp5_->str;
#line 259 "../lib/serializer.vala"
		if (g_strcmp0 (_tmp6_, "0") == 0) {
#line 958 "serializer.c"
			GString* _tmp7_;
#line 261 "../lib/serializer.vala"
			_tmp7_ = string;
#line 261 "../lib/serializer.vala"
			g_string_assign (_tmp7_, "");
#line 262 "../lib/serializer.vala"
			force_sign = FALSE;
#line 966 "serializer.c"
		}
#line 265 "../lib/serializer.vala"
		_tmp8_ = g_string_sized_new ((gsize) 1024);
#line 265 "../lib/serializer.vala"
		s = _tmp8_;
#line 266 "../lib/serializer.vala"
		n_complex_digits = 0;
#line 267 "../lib/serializer.vala"
		_tmp9_ = x_im;
#line 267 "../lib/serializer.vala"
		_tmp10_ = s;
#line 267 "../lib/serializer.vala"
		serializer_cast_to_string_real (self, _tmp9_, (gint) self->priv->representation_base, force_sign, &n_complex_digits, _tmp10_);
#line 268 "../lib/serializer.vala"
		if (n_complex_digits > (*n_digits)) {
#line 269 "../lib/serializer.vala"
			*n_digits = n_complex_digits;
#line 984 "serializer.c"
		}
#line 270 "../lib/serializer.vala"
		_tmp13_ = s;
#line 270 "../lib/serializer.vala"
		_tmp14_ = _tmp13_->str;
#line 270 "../lib/serializer.vala"
		if (g_strcmp0 (_tmp14_, "0") == 0) {
#line 270 "../lib/serializer.vala"
			_tmp12_ = TRUE;
#line 994 "serializer.c"
		} else {
			GString* _tmp15_;
			const gchar* _tmp16_;
#line 270 "../lib/serializer.vala"
			_tmp15_ = s;
#line 270 "../lib/serializer.vala"
			_tmp16_ = _tmp15_->str;
#line 270 "../lib/serializer.vala"
			_tmp12_ = g_strcmp0 (_tmp16_, "+0") == 0;
#line 1004 "serializer.c"
		}
#line 270 "../lib/serializer.vala"
		if (_tmp12_) {
#line 270 "../lib/serializer.vala"
			_tmp11_ = TRUE;
#line 1010 "serializer.c"
		} else {
			GString* _tmp17_;
			const gchar* _tmp18_;
#line 270 "../lib/serializer.vala"
			_tmp17_ = s;
#line 270 "../lib/serializer.vala"
			_tmp18_ = _tmp17_->str;
#line 270 "../lib/serializer.vala"
			_tmp11_ = g_strcmp0 (_tmp18_, "−0") == 0;
#line 1020 "serializer.c"
		}
#line 270 "../lib/serializer.vala"
		if (_tmp11_) {
#line 1024 "serializer.c"
		} else {
			GString* _tmp19_;
			const gchar* _tmp20_;
#line 274 "../lib/serializer.vala"
			_tmp19_ = s;
#line 274 "../lib/serializer.vala"
			_tmp20_ = _tmp19_->str;
#line 274 "../lib/serializer.vala"
			if (g_strcmp0 (_tmp20_, "1") == 0) {
#line 1034 "serializer.c"
				GString* _tmp21_;
#line 276 "../lib/serializer.vala"
				_tmp21_ = string;
#line 276 "../lib/serializer.vala"
				g_string_append (_tmp21_, "i");
#line 1040 "serializer.c"
			} else {
				GString* _tmp22_;
				const gchar* _tmp23_;
#line 278 "../lib/serializer.vala"
				_tmp22_ = s;
#line 278 "../lib/serializer.vala"
				_tmp23_ = _tmp22_->str;
#line 278 "../lib/serializer.vala"
				if (g_strcmp0 (_tmp23_, "+1") == 0) {
#line 1050 "serializer.c"
					GString* _tmp24_;
#line 280 "../lib/serializer.vala"
					_tmp24_ = string;
#line 280 "../lib/serializer.vala"
					g_string_append (_tmp24_, "+i");
#line 1056 "serializer.c"
				} else {
					GString* _tmp25_;
					const gchar* _tmp26_;
#line 282 "../lib/serializer.vala"
					_tmp25_ = s;
#line 282 "../lib/serializer.vala"
					_tmp26_ = _tmp25_->str;
#line 282 "../lib/serializer.vala"
					if (g_strcmp0 (_tmp26_, "−1") == 0) {
#line 1066 "serializer.c"
						GString* _tmp27_;
#line 284 "../lib/serializer.vala"
						_tmp27_ = string;
#line 284 "../lib/serializer.vala"
						g_string_append (_tmp27_, "−i");
#line 1072 "serializer.c"
					} else {
						GString* _tmp28_;
						const gchar* _tmp29_;
						GString* _tmp36_;
#line 288 "../lib/serializer.vala"
						_tmp28_ = s;
#line 288 "../lib/serializer.vala"
						_tmp29_ = _tmp28_->str;
#line 288 "../lib/serializer.vala"
						if (g_strcmp0 (_tmp29_, "+0") == 0) {
#line 1083 "serializer.c"
							GString* _tmp30_;
#line 289 "../lib/serializer.vala"
							_tmp30_ = string;
#line 289 "../lib/serializer.vala"
							g_string_append (_tmp30_, "+");
#line 1089 "serializer.c"
						} else {
							GString* _tmp31_;
							const gchar* _tmp32_;
#line 290 "../lib/serializer.vala"
							_tmp31_ = s;
#line 290 "../lib/serializer.vala"
							_tmp32_ = _tmp31_->str;
#line 290 "../lib/serializer.vala"
							if (g_strcmp0 (_tmp32_, "0") != 0) {
#line 1099 "serializer.c"
								GString* _tmp33_;
								GString* _tmp34_;
								const gchar* _tmp35_;
#line 291 "../lib/serializer.vala"
								_tmp33_ = string;
#line 291 "../lib/serializer.vala"
								_tmp34_ = s;
#line 291 "../lib/serializer.vala"
								_tmp35_ = _tmp34_->str;
#line 291 "../lib/serializer.vala"
								g_string_append (_tmp33_, _tmp35_);
#line 1111 "serializer.c"
							}
						}
#line 293 "../lib/serializer.vala"
						_tmp36_ = string;
#line 293 "../lib/serializer.vala"
						g_string_append (_tmp36_, "i");
#line 1118 "serializer.c"
					}
				}
			}
		}
#line 254 "../lib/serializer.vala"
		_g_string_free0 (s);
#line 254 "../lib/serializer.vala"
		_g_object_unref0 (x_im);
#line 1127 "serializer.c"
	}
#line 297 "../lib/serializer.vala"
	_tmp37_ = string;
#line 297 "../lib/serializer.vala"
	_tmp38_ = _tmp37_->str;
#line 297 "../lib/serializer.vala"
	_tmp39_ = g_strdup (_tmp38_);
#line 297 "../lib/serializer.vala"
	result = _tmp39_;
#line 297 "../lib/serializer.vala"
	_g_object_unref0 (x_real);
#line 297 "../lib/serializer.vala"
	_g_string_free0 (string);
#line 297 "../lib/serializer.vala"
	return result;
#line 1143 "serializer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 304 "../lib/serializer.vala"
	return self ? g_object_ref (self) : NULL;
#line 1151 "serializer.c"
}

static void
serializer_cast_to_string_real (Serializer* self,
                                Number* x,
                                gint number_base,
                                gboolean force_sign,
                                gint* n_digits,
                                GString* string)
{
#line 302 "../lib/serializer.vala"
	static const gchar digits[16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
#line 1164 "serializer.c"
	Number* number = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* temp = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* rounded_number = NULL;
	Number* _tmp11_;
	Number* _tmp12_;
	Number* _tmp13_;
	Number* _tmp14_;
	Number* _tmp15_;
	gint i = 0;
	gssize last_non_zero = 0L;
	Number* _tmp36_;
	Number* _tmp37_;
	gboolean _tmp50_ = FALSE;
	gboolean _tmp51_ = FALSE;
	const gchar* _tmp52_;
#line 300 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 300 "../lib/serializer.vala"
	g_return_if_fail (x != NULL);
#line 300 "../lib/serializer.vala"
	g_return_if_fail (string != NULL);
#line 304 "../lib/serializer.vala"
	_tmp0_ = _g_object_ref0 (x);
#line 304 "../lib/serializer.vala"
	number = _tmp0_;
#line 305 "../lib/serializer.vala"
	_tmp1_ = number;
#line 305 "../lib/serializer.vala"
	if (number_is_negative (_tmp1_)) {
#line 1203 "serializer.c"
		Number* _tmp2_;
		Number* _tmp3_;
#line 306 "../lib/serializer.vala"
		_tmp2_ = number;
#line 306 "../lib/serializer.vala"
		_tmp3_ = number_abs (_tmp2_);
#line 306 "../lib/serializer.vala"
		_g_object_unref0 (number);
#line 306 "../lib/serializer.vala"
		number = _tmp3_;
#line 1214 "serializer.c"
	}
#line 309 "../lib/serializer.vala"
	_tmp4_ = number_new_integer ((gint64) number_base, (gint64) 0);
#line 309 "../lib/serializer.vala"
	temp = _tmp4_;
#line 310 "../lib/serializer.vala"
	_tmp5_ = temp;
#line 310 "../lib/serializer.vala"
	_tmp6_ = number_xpowy_integer (_tmp5_, (gint64) (-(self->priv->trailing_digits + 1)));
#line 310 "../lib/serializer.vala"
	_g_object_unref0 (temp);
#line 310 "../lib/serializer.vala"
	temp = _tmp6_;
#line 311 "../lib/serializer.vala"
	_tmp7_ = temp;
#line 311 "../lib/serializer.vala"
	_tmp8_ = number_multiply_integer (_tmp7_, (gint64) number_base);
#line 311 "../lib/serializer.vala"
	_g_object_unref0 (temp);
#line 311 "../lib/serializer.vala"
	temp = _tmp8_;
#line 312 "../lib/serializer.vala"
	_tmp9_ = temp;
#line 312 "../lib/serializer.vala"
	_tmp10_ = number_divide_integer (_tmp9_, (gint64) 2);
#line 312 "../lib/serializer.vala"
	_g_object_unref0 (temp);
#line 312 "../lib/serializer.vala"
	temp = _tmp10_;
#line 313 "../lib/serializer.vala"
	_tmp11_ = number;
#line 313 "../lib/serializer.vala"
	_tmp12_ = temp;
#line 313 "../lib/serializer.vala"
	_tmp13_ = number_add (_tmp11_, _tmp12_);
#line 313 "../lib/serializer.vala"
	rounded_number = _tmp13_;
#line 316 "../lib/serializer.vala"
	_tmp14_ = rounded_number;
#line 316 "../lib/serializer.vala"
	_tmp15_ = number_floor (_tmp14_);
#line 316 "../lib/serializer.vala"
	_g_object_unref0 (temp);
#line 316 "../lib/serializer.vala"
	temp = _tmp15_;
#line 317 "../lib/serializer.vala"
	i = 0;
#line 1262 "serializer.c"
	{
		gboolean _tmp16_ = FALSE;
#line 318 "../lib/serializer.vala"
		_tmp16_ = TRUE;
#line 318 "../lib/serializer.vala"
		while (TRUE) {
#line 1269 "serializer.c"
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			gint _tmp20_;
			Number* t = NULL;
			Number* _tmp21_;
			Number* _tmp22_;
			Number* _tmp23_;
			Number* _tmp24_;
			Number* t2 = NULL;
			Number* _tmp25_;
			Number* _tmp26_;
			Number* t3 = NULL;
			Number* _tmp27_;
			Number* _tmp28_;
			Number* _tmp29_;
			gint64 d = 0LL;
			Number* _tmp30_;
			gboolean _tmp31_ = FALSE;
			gint _tmp33_;
			Number* _tmp34_;
			Number* _tmp35_;
#line 318 "../lib/serializer.vala"
			if (!_tmp16_) {
#line 1293 "serializer.c"
				Number* _tmp17_;
#line 349 "../lib/serializer.vala"
				_tmp17_ = temp;
#line 349 "../lib/serializer.vala"
				if (!(!number_is_zero (_tmp17_))) {
#line 349 "../lib/serializer.vala"
					break;
#line 1301 "serializer.c"
				}
			}
#line 318 "../lib/serializer.vala"
			_tmp16_ = FALSE;
#line 320 "../lib/serializer.vala"
			if (number_base == 10) {
#line 320 "../lib/serializer.vala"
				_tmp19_ = self->priv->show_tsep;
#line 1310 "serializer.c"
			} else {
#line 320 "../lib/serializer.vala"
				_tmp19_ = FALSE;
#line 1314 "serializer.c"
			}
#line 320 "../lib/serializer.vala"
			if (_tmp19_) {
#line 320 "../lib/serializer.vala"
				_tmp18_ = i == self->priv->tsep_count;
#line 1320 "serializer.c"
			} else {
#line 320 "../lib/serializer.vala"
				_tmp18_ = FALSE;
#line 1324 "serializer.c"
			}
#line 320 "../lib/serializer.vala"
			if (_tmp18_) {
#line 322 "../lib/serializer.vala"
				g_string_prepend_unichar (string, self->priv->tsep);
#line 323 "../lib/serializer.vala"
				i = 0;
#line 1332 "serializer.c"
			}
#line 325 "../lib/serializer.vala"
			_tmp20_ = i;
#line 325 "../lib/serializer.vala"
			i = _tmp20_ + 1;
#line 327 "../lib/serializer.vala"
			_tmp21_ = temp;
#line 327 "../lib/serializer.vala"
			_tmp22_ = number_divide_integer (_tmp21_, (gint64) number_base);
#line 327 "../lib/serializer.vala"
			t = _tmp22_;
#line 328 "../lib/serializer.vala"
			_tmp23_ = t;
#line 328 "../lib/serializer.vala"
			_tmp24_ = number_floor (_tmp23_);
#line 328 "../lib/serializer.vala"
			_g_object_unref0 (t);
#line 328 "../lib/serializer.vala"
			t = _tmp24_;
#line 329 "../lib/serializer.vala"
			_tmp25_ = t;
#line 329 "../lib/serializer.vala"
			_tmp26_ = number_multiply_integer (_tmp25_, (gint64) number_base);
#line 329 "../lib/serializer.vala"
			t2 = _tmp26_;
#line 331 "../lib/serializer.vala"
			_tmp27_ = temp;
#line 331 "../lib/serializer.vala"
			_tmp28_ = t2;
#line 331 "../lib/serializer.vala"
			_tmp29_ = number_subtract (_tmp27_, _tmp28_);
#line 331 "../lib/serializer.vala"
			t3 = _tmp29_;
#line 333 "../lib/serializer.vala"
			_tmp30_ = t3;
#line 333 "../lib/serializer.vala"
			d = number_to_integer (_tmp30_);
#line 335 "../lib/serializer.vala"
			if (d < ((gint64) 16)) {
#line 335 "../lib/serializer.vala"
				_tmp31_ = d >= ((gint64) 0);
#line 1374 "serializer.c"
			} else {
#line 335 "../lib/serializer.vala"
				_tmp31_ = FALSE;
#line 1378 "serializer.c"
			}
#line 335 "../lib/serializer.vala"
			if (_tmp31_) {
#line 1382 "serializer.c"
				gchar _tmp32_;
#line 337 "../lib/serializer.vala"
				_tmp32_ = digits[d];
#line 337 "../lib/serializer.vala"
				g_string_prepend_c (string, _tmp32_);
#line 1388 "serializer.c"
			} else {
#line 341 "../lib/serializer.vala"
				g_string_prepend_c (string, '?');
#line 342 "../lib/serializer.vala"
				serializer_set_error (self, _ ("Overflow: the result couldn’t be calculated"));
#line 343 "../lib/serializer.vala"
				g_string_assign (string, "0");
#line 344 "../lib/serializer.vala"
				_g_object_unref0 (t3);
#line 344 "../lib/serializer.vala"
				_g_object_unref0 (t2);
#line 344 "../lib/serializer.vala"
				_g_object_unref0 (t);
#line 344 "../lib/serializer.vala"
				break;
#line 1404 "serializer.c"
			}
#line 346 "../lib/serializer.vala"
			_tmp33_ = *n_digits;
#line 346 "../lib/serializer.vala"
			*n_digits = _tmp33_ + 1;
#line 348 "../lib/serializer.vala"
			_tmp34_ = t;
#line 348 "../lib/serializer.vala"
			_tmp35_ = _g_object_ref0 (_tmp34_);
#line 348 "../lib/serializer.vala"
			_g_object_unref0 (temp);
#line 348 "../lib/serializer.vala"
			temp = _tmp35_;
#line 318 "../lib/serializer.vala"
			_g_object_unref0 (t3);
#line 318 "../lib/serializer.vala"
			_g_object_unref0 (t2);
#line 318 "../lib/serializer.vala"
			_g_object_unref0 (t);
#line 1424 "serializer.c"
		}
	}
#line 351 "../lib/serializer.vala"
	last_non_zero = string->len;
#line 353 "../lib/serializer.vala"
	g_string_append_unichar (string, self->priv->radix);
#line 356 "../lib/serializer.vala"
	_tmp36_ = rounded_number;
#line 356 "../lib/serializer.vala"
	_tmp37_ = number_fractional_component (_tmp36_);
#line 356 "../lib/serializer.vala"
	_g_object_unref0 (temp);
#line 356 "../lib/serializer.vala"
	temp = _tmp37_;
#line 1439 "serializer.c"
	{
		gboolean _tmp38_ = FALSE;
#line 357 "../lib/serializer.vala"
		i = 0;
#line 357 "../lib/serializer.vala"
		_tmp38_ = TRUE;
#line 357 "../lib/serializer.vala"
		while (TRUE) {
#line 1448 "serializer.c"
			Number* _tmp40_;
			Number* _tmp41_;
			Number* _tmp42_;
			Number* digit = NULL;
			Number* _tmp43_;
			Number* _tmp44_;
			gint64 d = 0LL;
			Number* _tmp45_;
			gchar _tmp46_;
			Number* _tmp47_;
			Number* _tmp48_;
			Number* _tmp49_;
#line 357 "../lib/serializer.vala"
			if (!_tmp38_) {
#line 1463 "serializer.c"
				gint _tmp39_;
#line 357 "../lib/serializer.vala"
				_tmp39_ = i;
#line 357 "../lib/serializer.vala"
				i = _tmp39_ + 1;
#line 1469 "serializer.c"
			}
#line 357 "../lib/serializer.vala"
			_tmp38_ = FALSE;
#line 357 "../lib/serializer.vala"
			if (!(i < self->priv->trailing_digits)) {
#line 357 "../lib/serializer.vala"
				break;
#line 1477 "serializer.c"
			}
#line 359 "../lib/serializer.vala"
			_tmp40_ = temp;
#line 359 "../lib/serializer.vala"
			if (number_is_zero (_tmp40_)) {
#line 360 "../lib/serializer.vala"
				break;
#line 1485 "serializer.c"
			}
#line 362 "../lib/serializer.vala"
			_tmp41_ = temp;
#line 362 "../lib/serializer.vala"
			_tmp42_ = number_multiply_integer (_tmp41_, (gint64) number_base);
#line 362 "../lib/serializer.vala"
			_g_object_unref0 (temp);
#line 362 "../lib/serializer.vala"
			temp = _tmp42_;
#line 363 "../lib/serializer.vala"
			_tmp43_ = temp;
#line 363 "../lib/serializer.vala"
			_tmp44_ = number_floor (_tmp43_);
#line 363 "../lib/serializer.vala"
			digit = _tmp44_;
#line 364 "../lib/serializer.vala"
			_tmp45_ = digit;
#line 364 "../lib/serializer.vala"
			d = number_to_integer (_tmp45_);
#line 366 "../lib/serializer.vala"
			_tmp46_ = digits[d];
#line 366 "../lib/serializer.vala"
			g_string_append_c (string, _tmp46_);
#line 368 "../lib/serializer.vala"
			if (d != ((gint64) 0)) {
#line 369 "../lib/serializer.vala"
				last_non_zero = string->len;
#line 1513 "serializer.c"
			}
#line 370 "../lib/serializer.vala"
			_tmp47_ = temp;
#line 370 "../lib/serializer.vala"
			_tmp48_ = digit;
#line 370 "../lib/serializer.vala"
			_tmp49_ = number_subtract (_tmp47_, _tmp48_);
#line 370 "../lib/serializer.vala"
			_g_object_unref0 (temp);
#line 370 "../lib/serializer.vala"
			temp = _tmp49_;
#line 357 "../lib/serializer.vala"
			_g_object_unref0 (digit);
#line 1527 "serializer.c"
		}
	}
#line 374 "../lib/serializer.vala"
	if (!self->priv->show_zeroes) {
#line 374 "../lib/serializer.vala"
		_tmp50_ = TRUE;
#line 1534 "serializer.c"
	} else {
#line 374 "../lib/serializer.vala"
		_tmp50_ = self->priv->trailing_digits == 0;
#line 1538 "serializer.c"
	}
#line 374 "../lib/serializer.vala"
	if (_tmp50_) {
#line 375 "../lib/serializer.vala"
		g_string_truncate (string, (gsize) last_non_zero);
#line 1544 "serializer.c"
	}
#line 378 "../lib/serializer.vala"
	_tmp52_ = string->str;
#line 378 "../lib/serializer.vala"
	if (g_strcmp0 (_tmp52_, "0") != 0) {
#line 378 "../lib/serializer.vala"
		_tmp51_ = TRUE;
#line 1552 "serializer.c"
	} else {
#line 378 "../lib/serializer.vala"
		_tmp51_ = force_sign;
#line 1556 "serializer.c"
	}
#line 378 "../lib/serializer.vala"
	if (_tmp51_) {
#line 380 "../lib/serializer.vala"
		if (number_is_negative (x)) {
#line 381 "../lib/serializer.vala"
			g_string_prepend (string, "−");
#line 1564 "serializer.c"
		} else {
#line 382 "../lib/serializer.vala"
			if (force_sign) {
#line 383 "../lib/serializer.vala"
				g_string_prepend (string, "+");
#line 1570 "serializer.c"
			}
		}
	}
#line 387 "../lib/serializer.vala"
	if (number_base != self->priv->number_base) {
#line 389 "../lib/serializer.vala"
		static const gchar* sub_digits[10] = {"₀", "₁", "₂", "₃", "₄", "₅", "₆", "₇", "₈", "₉"};
#line 1578 "serializer.c"
		gint multiplier = 0;
		gint b = 0;
#line 390 "../lib/serializer.vala"
		multiplier = 1;
#line 391 "../lib/serializer.vala"
		b = number_base;
#line 393 "../lib/serializer.vala"
		while (TRUE) {
#line 393 "../lib/serializer.vala"
			if (!((number_base / multiplier) != 0)) {
#line 393 "../lib/serializer.vala"
				break;
#line 1591 "serializer.c"
			}
#line 394 "../lib/serializer.vala"
			multiplier = multiplier * 10;
#line 1595 "serializer.c"
		}
#line 395 "../lib/serializer.vala"
		while (TRUE) {
#line 1599 "serializer.c"
			gint d = 0;
			const gchar* _tmp53_;
#line 395 "../lib/serializer.vala"
			if (!(multiplier != 1)) {
#line 395 "../lib/serializer.vala"
				break;
#line 1606 "serializer.c"
			}
#line 398 "../lib/serializer.vala"
			multiplier = multiplier / 10;
#line 399 "../lib/serializer.vala"
			d = b / multiplier;
#line 400 "../lib/serializer.vala"
			_tmp53_ = sub_digits[d];
#line 400 "../lib/serializer.vala"
			g_string_append (string, _tmp53_);
#line 401 "../lib/serializer.vala"
			b = b - (d * multiplier);
#line 1618 "serializer.c"
		}
	}
#line 300 "../lib/serializer.vala"
	_g_object_unref0 (rounded_number);
#line 300 "../lib/serializer.vala"
	_g_object_unref0 (temp);
#line 300 "../lib/serializer.vala"
	_g_object_unref0 (number);
#line 1627 "serializer.c"
}

static gint
serializer_cast_to_exponential_string_real (Serializer* self,
                                            Number* x,
                                            GString* string,
                                            gboolean eng_format,
                                            gint* n_digits)
{
	gint result = 0;
	Number* mantissa = NULL;
	Number* _tmp0_;
	Number* base_ = NULL;
	Number* _tmp1_;
	Number* base3 = NULL;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* base10 = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* t = NULL;
	Number* _tmp6_;
	Number* base10inv = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	gint exponent = 0;
	Number* _tmp10_;
	Number* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
#line 406 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 406 "../lib/serializer.vala"
	g_return_val_if_fail (x != NULL, 0);
#line 406 "../lib/serializer.vala"
	g_return_val_if_fail (string != NULL, 0);
#line 408 "../lib/serializer.vala"
	if (number_is_negative (x)) {
#line 409 "../lib/serializer.vala"
		g_string_append (string, "−");
#line 1669 "serializer.c"
	}
#line 411 "../lib/serializer.vala"
	_tmp0_ = number_abs (x);
#line 411 "../lib/serializer.vala"
	mantissa = _tmp0_;
#line 413 "../lib/serializer.vala"
	_tmp1_ = number_new_integer ((gint64) self->priv->number_base, (gint64) 0);
#line 413 "../lib/serializer.vala"
	base_ = _tmp1_;
#line 414 "../lib/serializer.vala"
	_tmp2_ = base_;
#line 414 "../lib/serializer.vala"
	_tmp3_ = number_xpowy_integer (_tmp2_, (gint64) 3);
#line 414 "../lib/serializer.vala"
	base3 = _tmp3_;
#line 415 "../lib/serializer.vala"
	_tmp4_ = base_;
#line 415 "../lib/serializer.vala"
	_tmp5_ = number_xpowy_integer (_tmp4_, (gint64) 10);
#line 415 "../lib/serializer.vala"
	base10 = _tmp5_;
#line 416 "../lib/serializer.vala"
	_tmp6_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 416 "../lib/serializer.vala"
	t = _tmp6_;
#line 417 "../lib/serializer.vala"
	_tmp7_ = t;
#line 417 "../lib/serializer.vala"
	_tmp8_ = base10;
#line 417 "../lib/serializer.vala"
	_tmp9_ = number_divide (_tmp7_, _tmp8_);
#line 417 "../lib/serializer.vala"
	base10inv = _tmp9_;
#line 419 "../lib/serializer.vala"
	exponent = 0;
#line 420 "../lib/serializer.vala"
	_tmp10_ = mantissa;
#line 420 "../lib/serializer.vala"
	if (!number_is_zero (_tmp10_)) {
#line 1709 "serializer.c"
		Number* _tmp34_;
#line 422 "../lib/serializer.vala"
		while (TRUE) {
#line 1713 "serializer.c"
			gboolean _tmp11_ = FALSE;
			Number* _tmp14_;
			Number* _tmp15_;
			Number* _tmp16_;
#line 422 "../lib/serializer.vala"
			if (!eng_format) {
#line 1720 "serializer.c"
				Number* _tmp12_;
				Number* _tmp13_;
#line 422 "../lib/serializer.vala"
				_tmp12_ = mantissa;
#line 422 "../lib/serializer.vala"
				_tmp13_ = base10;
#line 422 "../lib/serializer.vala"
				_tmp11_ = number_compare (_tmp12_, _tmp13_) >= 0;
#line 1729 "serializer.c"
			} else {
#line 422 "../lib/serializer.vala"
				_tmp11_ = FALSE;
#line 1733 "serializer.c"
			}
#line 422 "../lib/serializer.vala"
			if (!_tmp11_) {
#line 422 "../lib/serializer.vala"
				break;
#line 1739 "serializer.c"
			}
#line 424 "../lib/serializer.vala"
			exponent = exponent + 10;
#line 425 "../lib/serializer.vala"
			_tmp14_ = mantissa;
#line 425 "../lib/serializer.vala"
			_tmp15_ = base10inv;
#line 425 "../lib/serializer.vala"
			_tmp16_ = number_multiply (_tmp14_, _tmp15_);
#line 425 "../lib/serializer.vala"
			_g_object_unref0 (mantissa);
#line 425 "../lib/serializer.vala"
			mantissa = _tmp16_;
#line 1753 "serializer.c"
		}
#line 428 "../lib/serializer.vala"
		while (TRUE) {
#line 1757 "serializer.c"
			gboolean _tmp17_ = FALSE;
			gboolean _tmp18_ = FALSE;
			Number* _tmp25_;
			Number* _tmp26_;
			Number* _tmp27_;
#line 428 "../lib/serializer.vala"
			if (!eng_format) {
#line 1765 "serializer.c"
				Number* _tmp19_;
				Number* _tmp20_;
#line 428 "../lib/serializer.vala"
				_tmp19_ = mantissa;
#line 428 "../lib/serializer.vala"
				_tmp20_ = base_;
#line 428 "../lib/serializer.vala"
				_tmp18_ = number_compare (_tmp19_, _tmp20_) >= 0;
#line 1774 "serializer.c"
			} else {
#line 428 "../lib/serializer.vala"
				_tmp18_ = FALSE;
#line 1778 "serializer.c"
			}
#line 428 "../lib/serializer.vala"
			if (_tmp18_) {
#line 428 "../lib/serializer.vala"
				_tmp17_ = TRUE;
#line 1784 "serializer.c"
			} else {
				gboolean _tmp21_ = FALSE;
#line 429 "../lib/serializer.vala"
				if (eng_format) {
#line 1789 "serializer.c"
					gboolean _tmp22_ = FALSE;
					Number* _tmp23_;
					Number* _tmp24_;
#line 429 "../lib/serializer.vala"
					_tmp23_ = mantissa;
#line 429 "../lib/serializer.vala"
					_tmp24_ = base3;
#line 429 "../lib/serializer.vala"
					if (number_compare (_tmp23_, _tmp24_) >= 0) {
#line 429 "../lib/serializer.vala"
						_tmp22_ = TRUE;
#line 1801 "serializer.c"
					} else {
#line 429 "../lib/serializer.vala"
						_tmp22_ = (exponent % 3) != 0;
#line 1805 "serializer.c"
					}
#line 429 "../lib/serializer.vala"
					_tmp21_ = _tmp22_;
#line 1809 "serializer.c"
				} else {
#line 429 "../lib/serializer.vala"
					_tmp21_ = FALSE;
#line 1813 "serializer.c"
				}
#line 429 "../lib/serializer.vala"
				_tmp17_ = _tmp21_;
#line 1817 "serializer.c"
			}
#line 428 "../lib/serializer.vala"
			if (!_tmp17_) {
#line 428 "../lib/serializer.vala"
				break;
#line 1823 "serializer.c"
			}
#line 431 "../lib/serializer.vala"
			exponent = exponent + 1;
#line 432 "../lib/serializer.vala"
			_tmp25_ = mantissa;
#line 432 "../lib/serializer.vala"
			_tmp26_ = base_;
#line 432 "../lib/serializer.vala"
			_tmp27_ = number_divide (_tmp25_, _tmp26_);
#line 432 "../lib/serializer.vala"
			_g_object_unref0 (mantissa);
#line 432 "../lib/serializer.vala"
			mantissa = _tmp27_;
#line 1837 "serializer.c"
		}
#line 435 "../lib/serializer.vala"
		while (TRUE) {
#line 1841 "serializer.c"
			gboolean _tmp28_ = FALSE;
			Number* _tmp31_;
			Number* _tmp32_;
			Number* _tmp33_;
#line 435 "../lib/serializer.vala"
			if (!eng_format) {
#line 1848 "serializer.c"
				Number* _tmp29_;
				Number* _tmp30_;
#line 435 "../lib/serializer.vala"
				_tmp29_ = mantissa;
#line 435 "../lib/serializer.vala"
				_tmp30_ = base10inv;
#line 435 "../lib/serializer.vala"
				_tmp28_ = number_compare (_tmp29_, _tmp30_) < 0;
#line 1857 "serializer.c"
			} else {
#line 435 "../lib/serializer.vala"
				_tmp28_ = FALSE;
#line 1861 "serializer.c"
			}
#line 435 "../lib/serializer.vala"
			if (!_tmp28_) {
#line 435 "../lib/serializer.vala"
				break;
#line 1867 "serializer.c"
			}
#line 437 "../lib/serializer.vala"
			exponent = exponent - 10;
#line 438 "../lib/serializer.vala"
			_tmp31_ = mantissa;
#line 438 "../lib/serializer.vala"
			_tmp32_ = base10;
#line 438 "../lib/serializer.vala"
			_tmp33_ = number_multiply (_tmp31_, _tmp32_);
#line 438 "../lib/serializer.vala"
			_g_object_unref0 (mantissa);
#line 438 "../lib/serializer.vala"
			mantissa = _tmp33_;
#line 1881 "serializer.c"
		}
#line 441 "../lib/serializer.vala"
		_tmp34_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 441 "../lib/serializer.vala"
		_g_object_unref0 (t);
#line 441 "../lib/serializer.vala"
		t = _tmp34_;
#line 442 "../lib/serializer.vala"
		while (TRUE) {
#line 1891 "serializer.c"
			gboolean _tmp35_ = FALSE;
			Number* _tmp36_;
			Number* _tmp37_;
			Number* _tmp39_;
			Number* _tmp40_;
			Number* _tmp41_;
#line 442 "../lib/serializer.vala"
			_tmp36_ = mantissa;
#line 442 "../lib/serializer.vala"
			_tmp37_ = t;
#line 442 "../lib/serializer.vala"
			if (number_compare (_tmp36_, _tmp37_) < 0) {
#line 442 "../lib/serializer.vala"
				_tmp35_ = TRUE;
#line 1906 "serializer.c"
			} else {
				gboolean _tmp38_ = FALSE;
#line 442 "../lib/serializer.vala"
				if (eng_format) {
#line 442 "../lib/serializer.vala"
					_tmp38_ = (exponent % 3) != 0;
#line 1913 "serializer.c"
				} else {
#line 442 "../lib/serializer.vala"
					_tmp38_ = FALSE;
#line 1917 "serializer.c"
				}
#line 442 "../lib/serializer.vala"
				_tmp35_ = _tmp38_;
#line 1921 "serializer.c"
			}
#line 442 "../lib/serializer.vala"
			if (!_tmp35_) {
#line 442 "../lib/serializer.vala"
				break;
#line 1927 "serializer.c"
			}
#line 444 "../lib/serializer.vala"
			exponent = exponent - 1;
#line 445 "../lib/serializer.vala"
			_tmp39_ = mantissa;
#line 445 "../lib/serializer.vala"
			_tmp40_ = base_;
#line 445 "../lib/serializer.vala"
			_tmp41_ = number_multiply (_tmp39_, _tmp40_);
#line 445 "../lib/serializer.vala"
			_g_object_unref0 (mantissa);
#line 445 "../lib/serializer.vala"
			mantissa = _tmp41_;
#line 1941 "serializer.c"
		}
	}
#line 449 "../lib/serializer.vala"
	_tmp42_ = mantissa;
#line 449 "../lib/serializer.vala"
	_tmp43_ = serializer_cast_to_string (self, _tmp42_, n_digits);
#line 449 "../lib/serializer.vala"
	_tmp44_ = _tmp43_;
#line 449 "../lib/serializer.vala"
	g_string_append (string, _tmp44_);
#line 449 "../lib/serializer.vala"
	_g_free0 (_tmp44_);
#line 451 "../lib/serializer.vala"
	result = exponent;
#line 451 "../lib/serializer.vala"
	_g_object_unref0 (base10inv);
#line 451 "../lib/serializer.vala"
	_g_object_unref0 (t);
#line 451 "../lib/serializer.vala"
	_g_object_unref0 (base10);
#line 451 "../lib/serializer.vala"
	_g_object_unref0 (base3);
#line 451 "../lib/serializer.vala"
	_g_object_unref0 (base_);
#line 451 "../lib/serializer.vala"
	_g_object_unref0 (mantissa);
#line 451 "../lib/serializer.vala"
	return result;
#line 1970 "serializer.c"
}

static gchar*
serializer_cast_to_exponential_string (Serializer* self,
                                       Number* x,
                                       gboolean eng_format,
                                       gint* n_digits)
{
	gchar* result = NULL;
	GString* string = NULL;
	GString* _tmp0_;
	Number* x_real = NULL;
	Number* _tmp1_;
	gint exponent = 0;
	Number* _tmp2_;
	GString* _tmp3_;
	gint _tmp4_;
	GString* _tmp5_;
	GString* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
#line 454 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 454 "../lib/serializer.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 456 "../lib/serializer.vala"
	_tmp0_ = g_string_sized_new ((gsize) 1024);
#line 456 "../lib/serializer.vala"
	string = _tmp0_;
#line 458 "../lib/serializer.vala"
	_tmp1_ = number_real_component (x);
#line 458 "../lib/serializer.vala"
	x_real = _tmp1_;
#line 459 "../lib/serializer.vala"
	_tmp2_ = x_real;
#line 459 "../lib/serializer.vala"
	_tmp3_ = string;
#line 459 "../lib/serializer.vala"
	_tmp4_ = serializer_cast_to_exponential_string_real (self, _tmp2_, _tmp3_, eng_format, n_digits);
#line 459 "../lib/serializer.vala"
	exponent = _tmp4_;
#line 460 "../lib/serializer.vala"
	_tmp5_ = string;
#line 460 "../lib/serializer.vala"
	serializer_append_exponent (self, _tmp5_, exponent);
#line 462 "../lib/serializer.vala"
	if (number_is_complex (x)) {
#line 2018 "serializer.c"
		Number* x_im = NULL;
		Number* _tmp6_;
		GString* _tmp7_;
		const gchar* _tmp8_;
		GString* s = NULL;
		GString* _tmp10_;
		gint n_complex_digits = 0;
		Number* _tmp11_;
		GString* _tmp12_;
		gint _tmp13_;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		GString* _tmp16_;
		const gchar* _tmp17_;
		GString* _tmp40_;
#line 464 "../lib/serializer.vala"
		_tmp6_ = number_imaginary_component (x);
#line 464 "../lib/serializer.vala"
		x_im = _tmp6_;
#line 466 "../lib/serializer.vala"
		_tmp7_ = string;
#line 466 "../lib/serializer.vala"
		_tmp8_ = _tmp7_->str;
#line 466 "../lib/serializer.vala"
		if (g_strcmp0 (_tmp8_, "0") == 0) {
#line 2044 "serializer.c"
			GString* _tmp9_;
#line 467 "../lib/serializer.vala"
			_tmp9_ = string;
#line 467 "../lib/serializer.vala"
			g_string_assign (_tmp9_, "");
#line 2050 "serializer.c"
		}
#line 469 "../lib/serializer.vala"
		_tmp10_ = g_string_sized_new ((gsize) 1024);
#line 469 "../lib/serializer.vala"
		s = _tmp10_;
#line 470 "../lib/serializer.vala"
		n_complex_digits = 0;
#line 471 "../lib/serializer.vala"
		_tmp11_ = x_im;
#line 471 "../lib/serializer.vala"
		_tmp12_ = s;
#line 471 "../lib/serializer.vala"
		_tmp13_ = serializer_cast_to_exponential_string_real (self, _tmp11_, _tmp12_, eng_format, &n_complex_digits);
#line 471 "../lib/serializer.vala"
		exponent = _tmp13_;
#line 472 "../lib/serializer.vala"
		if (n_complex_digits > (*n_digits)) {
#line 473 "../lib/serializer.vala"
			*n_digits = n_complex_digits;
#line 2070 "serializer.c"
		}
#line 474 "../lib/serializer.vala"
		_tmp16_ = s;
#line 474 "../lib/serializer.vala"
		_tmp17_ = _tmp16_->str;
#line 474 "../lib/serializer.vala"
		if (g_strcmp0 (_tmp17_, "0") == 0) {
#line 474 "../lib/serializer.vala"
			_tmp15_ = TRUE;
#line 2080 "serializer.c"
		} else {
			GString* _tmp18_;
			const gchar* _tmp19_;
#line 474 "../lib/serializer.vala"
			_tmp18_ = s;
#line 474 "../lib/serializer.vala"
			_tmp19_ = _tmp18_->str;
#line 474 "../lib/serializer.vala"
			_tmp15_ = g_strcmp0 (_tmp19_, "+0") == 0;
#line 2090 "serializer.c"
		}
#line 474 "../lib/serializer.vala"
		if (_tmp15_) {
#line 474 "../lib/serializer.vala"
			_tmp14_ = TRUE;
#line 2096 "serializer.c"
		} else {
			GString* _tmp20_;
			const gchar* _tmp21_;
#line 474 "../lib/serializer.vala"
			_tmp20_ = s;
#line 474 "../lib/serializer.vala"
			_tmp21_ = _tmp20_->str;
#line 474 "../lib/serializer.vala"
			_tmp14_ = g_strcmp0 (_tmp21_, "−0") == 0;
#line 2106 "serializer.c"
		}
#line 474 "../lib/serializer.vala"
		if (_tmp14_) {
#line 2110 "serializer.c"
		} else {
			GString* _tmp22_;
			const gchar* _tmp23_;
#line 478 "../lib/serializer.vala"
			_tmp22_ = s;
#line 478 "../lib/serializer.vala"
			_tmp23_ = _tmp22_->str;
#line 478 "../lib/serializer.vala"
			if (g_strcmp0 (_tmp23_, "1") == 0) {
#line 2120 "serializer.c"
				GString* _tmp24_;
#line 480 "../lib/serializer.vala"
				_tmp24_ = string;
#line 480 "../lib/serializer.vala"
				g_string_append (_tmp24_, "i");
#line 2126 "serializer.c"
			} else {
				GString* _tmp25_;
				const gchar* _tmp26_;
#line 482 "../lib/serializer.vala"
				_tmp25_ = s;
#line 482 "../lib/serializer.vala"
				_tmp26_ = _tmp25_->str;
#line 482 "../lib/serializer.vala"
				if (g_strcmp0 (_tmp26_, "+1") == 0) {
#line 2136 "serializer.c"
					GString* _tmp27_;
#line 484 "../lib/serializer.vala"
					_tmp27_ = string;
#line 484 "../lib/serializer.vala"
					g_string_append (_tmp27_, "+i");
#line 2142 "serializer.c"
				} else {
					GString* _tmp28_;
					const gchar* _tmp29_;
#line 486 "../lib/serializer.vala"
					_tmp28_ = s;
#line 486 "../lib/serializer.vala"
					_tmp29_ = _tmp28_->str;
#line 486 "../lib/serializer.vala"
					if (g_strcmp0 (_tmp29_, "−1") == 0) {
#line 2152 "serializer.c"
						GString* _tmp30_;
#line 488 "../lib/serializer.vala"
						_tmp30_ = string;
#line 488 "../lib/serializer.vala"
						g_string_append (_tmp30_, "−i");
#line 2158 "serializer.c"
					} else {
						GString* _tmp31_;
						const gchar* _tmp32_;
						GString* _tmp39_;
#line 492 "../lib/serializer.vala"
						_tmp31_ = s;
#line 492 "../lib/serializer.vala"
						_tmp32_ = _tmp31_->str;
#line 492 "../lib/serializer.vala"
						if (g_strcmp0 (_tmp32_, "+0") == 0) {
#line 2169 "serializer.c"
							GString* _tmp33_;
#line 493 "../lib/serializer.vala"
							_tmp33_ = string;
#line 493 "../lib/serializer.vala"
							g_string_append (_tmp33_, "+");
#line 2175 "serializer.c"
						} else {
							GString* _tmp34_;
							const gchar* _tmp35_;
#line 494 "../lib/serializer.vala"
							_tmp34_ = s;
#line 494 "../lib/serializer.vala"
							_tmp35_ = _tmp34_->str;
#line 494 "../lib/serializer.vala"
							if (g_strcmp0 (_tmp35_, "0") != 0) {
#line 2185 "serializer.c"
								GString* _tmp36_;
								GString* _tmp37_;
								const gchar* _tmp38_;
#line 495 "../lib/serializer.vala"
								_tmp36_ = string;
#line 495 "../lib/serializer.vala"
								_tmp37_ = s;
#line 495 "../lib/serializer.vala"
								_tmp38_ = _tmp37_->str;
#line 495 "../lib/serializer.vala"
								g_string_append (_tmp36_, _tmp38_);
#line 2197 "serializer.c"
							}
						}
#line 497 "../lib/serializer.vala"
						_tmp39_ = string;
#line 497 "../lib/serializer.vala"
						g_string_append (_tmp39_, "i");
#line 2204 "serializer.c"
					}
				}
			}
		}
#line 499 "../lib/serializer.vala"
		_tmp40_ = string;
#line 499 "../lib/serializer.vala"
		serializer_append_exponent (self, _tmp40_, exponent);
#line 462 "../lib/serializer.vala"
		_g_string_free0 (s);
#line 462 "../lib/serializer.vala"
		_g_object_unref0 (x_im);
#line 2217 "serializer.c"
	}
#line 502 "../lib/serializer.vala"
	_tmp41_ = string;
#line 502 "../lib/serializer.vala"
	_tmp42_ = _tmp41_->str;
#line 502 "../lib/serializer.vala"
	_tmp43_ = g_strdup (_tmp42_);
#line 502 "../lib/serializer.vala"
	result = _tmp43_;
#line 502 "../lib/serializer.vala"
	_g_object_unref0 (x_real);
#line 502 "../lib/serializer.vala"
	_g_string_free0 (string);
#line 502 "../lib/serializer.vala"
	return result;
#line 2233 "serializer.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 2250 "serializer.c"
}

static void
serializer_append_exponent (Serializer* self,
                            GString* string,
                            gint exponent)
{
#line 507 "../lib/serializer.vala"
	static const gunichar super_digits[10] = {8304U, 185U, 178U, 179U, 8308U, 8309U, 8310U, 8311U, 8312U, 8313U};
#line 2260 "serializer.c"
	gchar* super_value = NULL;
	gchar* _tmp0_;
#line 505 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 505 "../lib/serializer.vala"
	g_return_if_fail (string != NULL);
#line 509 "../lib/serializer.vala"
	if (exponent == 0) {
#line 510 "../lib/serializer.vala"
		return;
#line 2271 "serializer.c"
	}
#line 512 "../lib/serializer.vala"
	g_string_append (string, "×10");
#line 513 "../lib/serializer.vala"
	if (exponent < 0) {
#line 515 "../lib/serializer.vala"
		exponent = -exponent;
#line 516 "../lib/serializer.vala"
		g_string_append_unichar (string, 8315U);
#line 2281 "serializer.c"
	}
#line 519 "../lib/serializer.vala"
	_tmp0_ = g_strdup_printf ("%d", exponent);
#line 519 "../lib/serializer.vala"
	super_value = _tmp0_;
#line 2287 "serializer.c"
	{
		gint i = 0;
#line 520 "../lib/serializer.vala"
		i = 0;
#line 2292 "serializer.c"
		{
			gboolean _tmp1_ = FALSE;
#line 520 "../lib/serializer.vala"
			_tmp1_ = TRUE;
#line 520 "../lib/serializer.vala"
			while (TRUE) {
#line 2299 "serializer.c"
				const gchar* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				const gchar* _tmp6_;
				gunichar _tmp7_;
#line 520 "../lib/serializer.vala"
				if (!_tmp1_) {
#line 2307 "serializer.c"
					gint _tmp2_;
#line 520 "../lib/serializer.vala"
					_tmp2_ = i;
#line 520 "../lib/serializer.vala"
					i = _tmp2_ + 1;
#line 2313 "serializer.c"
				}
#line 520 "../lib/serializer.vala"
				_tmp1_ = FALSE;
#line 520 "../lib/serializer.vala"
				_tmp3_ = super_value;
#line 520 "../lib/serializer.vala"
				_tmp4_ = strlen (_tmp3_);
#line 520 "../lib/serializer.vala"
				_tmp5_ = _tmp4_;
#line 520 "../lib/serializer.vala"
				if (!(i < _tmp5_)) {
#line 520 "../lib/serializer.vala"
					break;
#line 2327 "serializer.c"
				}
#line 521 "../lib/serializer.vala"
				_tmp6_ = super_value;
#line 521 "../lib/serializer.vala"
				_tmp7_ = super_digits[string_get (_tmp6_, (glong) i) - '0'];
#line 521 "../lib/serializer.vala"
				g_string_append_unichar (string, _tmp7_);
#line 2335 "serializer.c"
			}
		}
	}
#line 505 "../lib/serializer.vala"
	_g_free0 (super_value);
#line 2341 "serializer.c"
}

const gchar*
serializer_get_error (Serializer* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 36 "../lib/serializer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../lib/serializer.vala"
	_tmp0_ = self->priv->_error;
#line 36 "../lib/serializer.vala"
	result = _tmp0_;
#line 36 "../lib/serializer.vala"
	return result;
#line 2357 "serializer.c"
}

void
serializer_set_error (Serializer* self,
                      const gchar* value)
{
#line 36 "../lib/serializer.vala"
	g_return_if_fail (self != NULL);
#line 36 "../lib/serializer.vala"
	if (g_strcmp0 (value, serializer_get_error (self)) != 0) {
#line 2368 "serializer.c"
		gchar* _tmp0_;
#line 36 "../lib/serializer.vala"
		_tmp0_ = g_strdup (value);
#line 36 "../lib/serializer.vala"
		_g_free0 (self->priv->_error);
#line 36 "../lib/serializer.vala"
		self->priv->_error = _tmp0_;
#line 36 "../lib/serializer.vala"
		g_object_notify_by_pspec ((GObject *) self, serializer_properties[SERIALIZER_ERROR_PROPERTY]);
#line 2378 "serializer.c"
	}
}

static void
serializer_class_init (SerializerClass * klass,
                       gpointer klass_data)
{
#line 20 "../lib/serializer.vala"
	serializer_parent_class = g_type_class_peek_parent (klass);
#line 20 "../lib/serializer.vala"
	g_type_class_adjust_private_offset (klass, &Serializer_private_offset);
#line 20 "../lib/serializer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_serializer_get_property;
#line 20 "../lib/serializer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_serializer_set_property;
#line 20 "../lib/serializer.vala"
	G_OBJECT_CLASS (klass)->finalize = serializer_finalize;
#line 20 "../lib/serializer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERIALIZER_ERROR_PROPERTY, serializer_properties[SERIALIZER_ERROR_PROPERTY] = g_param_spec_string ("error", "error", "error", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2398 "serializer.c"
}

static void
serializer_instance_init (Serializer * self,
                          gpointer klass)
{
#line 20 "../lib/serializer.vala"
	self->priv = serializer_get_instance_private (self);
#line 36 "../lib/serializer.vala"
	self->priv->_error = NULL;
#line 2409 "serializer.c"
}

static void
serializer_finalize (GObject * obj)
{
	Serializer * self;
#line 20 "../lib/serializer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SERIALIZER, Serializer);
#line 36 "../lib/serializer.vala"
	_g_free0 (self->priv->_error);
#line 20 "../lib/serializer.vala"
	G_OBJECT_CLASS (serializer_parent_class)->finalize (obj);
#line 2422 "serializer.c"
}

GType
serializer_get_type (void)
{
	static volatile gsize serializer_type_id__volatile = 0;
	if (g_once_init_enter (&serializer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SerializerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) serializer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Serializer), 0, (GInstanceInitFunc) serializer_instance_init, NULL };
		GType serializer_type_id;
		serializer_type_id = g_type_register_static (G_TYPE_OBJECT, "Serializer", &g_define_type_info, 0);
		Serializer_private_offset = g_type_add_instance_private (serializer_type_id, sizeof (SerializerPrivate));
		g_once_init_leave (&serializer_type_id__volatile, serializer_type_id);
	}
	return serializer_type_id__volatile;
}

static void
_vala_serializer_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	Serializer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SERIALIZER, Serializer);
#line 20 "../lib/serializer.vala"
	switch (property_id) {
#line 20 "../lib/serializer.vala"
		case SERIALIZER_ERROR_PROPERTY:
#line 20 "../lib/serializer.vala"
		g_value_set_string (value, serializer_get_error (self));
#line 20 "../lib/serializer.vala"
		break;
#line 2455 "serializer.c"
		default:
#line 20 "../lib/serializer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../lib/serializer.vala"
		break;
#line 2461 "serializer.c"
	}
}

static void
_vala_serializer_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	Serializer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SERIALIZER, Serializer);
#line 20 "../lib/serializer.vala"
	switch (property_id) {
#line 20 "../lib/serializer.vala"
		case SERIALIZER_ERROR_PROPERTY:
#line 20 "../lib/serializer.vala"
		serializer_set_error (self, g_value_get_string (value));
#line 20 "../lib/serializer.vala"
		break;
#line 2481 "serializer.c"
		default:
#line 20 "../lib/serializer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../lib/serializer.vala"
		break;
#line 2487 "serializer.c"
	}
}

