/* math-converter.c generated by valac 0.44.5, the Vala compiler
 * generated from math-converter.vala, do not modify */

/*
 * Copyright (C) 2008-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "calculator.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#define TYPE_MATH_CONVERTER (math_converter_get_type ())
#define MATH_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MATH_CONVERTER, MathConverter))
#define MATH_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MATH_CONVERTER, MathConverterClass))
#define IS_MATH_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MATH_CONVERTER))
#define IS_MATH_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MATH_CONVERTER))
#define MATH_CONVERTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MATH_CONVERTER, MathConverterClass))

typedef struct _MathConverter MathConverter;
typedef struct _MathConverterClass MathConverterClass;
typedef struct _MathConverterPrivate MathConverterPrivate;
enum  {
	MATH_CONVERTER_0_PROPERTY,
	MATH_CONVERTER_NUM_PROPERTIES
};
static GParamSpec* math_converter_properties[MATH_CONVERTER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	MATH_CONVERTER_CHANGED_SIGNAL,
	MATH_CONVERTER_NUM_SIGNALS
};
static guint math_converter_signals[MATH_CONVERTER_NUM_SIGNALS] = {0};

struct _MathConverter {
	GtkGrid parent_instance;
	MathConverterPrivate * priv;
};

struct _MathConverterClass {
	GtkGridClass parent_class;
};

struct _MathConverterPrivate {
	MathEquation* equation;
	gchar* category;
	GtkCellRendererText* from_renderer;
	GtkComboBox* from_combo;
	GtkComboBox* to_combo;
	GtkLabel* from_label;
	GtkLabel* to_label;
};

static gint MathConverter_private_offset;
static gpointer math_converter_parent_class = NULL;

GType math_converter_get_type (void) G_GNUC_CONST;
MathConverter* math_converter_new (MathEquation* equation);
MathConverter* math_converter_construct (GType object_type,
                                         MathEquation* equation);
void math_converter_set_equation (MathConverter* self,
                                  MathEquation* equation);
static void __lambda11_ (MathConverter* self,
                  GParamSpec* pspec);
static void math_converter_update_result_label (MathConverter* self);
static void ___lambda11__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
void math_converter_set_category (MathConverter* self,
                                  const gchar* category);
static void math_converter_update_from_model (MathConverter* self);
gchar* math_converter_get_category (MathConverter* self);
void math_converter_set_conversion (MathConverter* self,
                                    const gchar* unit_a,
                                    const gchar* unit_b);
static gboolean math_converter_set_active_unit (MathConverter* self,
                                         GtkComboBox* combo,
                                         GtkTreeIter* iter,
                                         Unit* unit);
void math_converter_get_conversion (MathConverter* self,
                                    Unit* * from_unit,
                                    Unit* * to_unit);
static Number* math_converter_convert_equation (MathConverter* self,
                                         Number* x,
                                         Unit* * source_unit,
                                         Unit* * target_unit);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gboolean math_converter_iter_is_unit (MathConverter* self,
                                      GtkTreeModel* model,
                                      GtkTreeIter* iter,
                                      Unit* unit);
static void math_converter_from_combobox_changed_cb (MathConverter* self);
static void _math_converter_from_combobox_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                     gpointer self);
static void math_converter_to_combobox_changed_cb (MathConverter* self);
static void _math_converter_to_combobox_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                   gpointer self);
static void math_converter_from_cell_data_func (MathConverter* self,
                                         GtkCellLayout* cell_layout,
                                         GtkCellRenderer* cell,
                                         GtkTreeModel* tree_model,
                                         GtkTreeIter* iter);
static void math_converter_swap_button_clicked_cb (MathConverter* self);
static void math_converter_do_convert (MathConverter* self,
                                Unit* * from_unit,
                                Unit* * to_unit);
static void _math_converter_swap_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static void math_converter_convert_button_clicked_cb (MathConverter* self);
static void _math_converter_convert_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self);
static GObject * math_converter_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void _math_converter_from_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                    GtkCellRenderer* cell,
                                                                    GtkTreeModel* tree_model,
                                                                    GtkTreeIter* iter,
                                                                    gpointer self);
static void _math_converter___lambda12_ (MathConverter* self);
static void __math_converter___lambda12__currency_manager_updated (CurrencyManager* _sender,
                                                            gpointer self);
static void math_converter_finalize (GObject * obj);

static inline gpointer
math_converter_get_instance_private (MathConverter* self)
{
	return G_STRUCT_MEMBER_P (self, MathConverter_private_offset);
}

MathConverter*
math_converter_construct (GType object_type,
                          MathEquation* equation)
{
	MathConverter * self = NULL;
#line 40 "../src/math-converter.vala"
	g_return_val_if_fail (equation != NULL, NULL);
#line 40 "../src/math-converter.vala"
	self = (MathConverter*) g_object_new (object_type, NULL);
#line 42 "../src/math-converter.vala"
	math_converter_set_equation (self, equation);
#line 40 "../src/math-converter.vala"
	return self;
#line 156 "math-converter.c"
}

MathConverter*
math_converter_new (MathEquation* equation)
{
#line 40 "../src/math-converter.vala"
	return math_converter_construct (TYPE_MATH_CONVERTER, equation);
#line 164 "math-converter.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 47 "../src/math-converter.vala"
	return self ? g_object_ref (self) : NULL;
#line 172 "math-converter.c"
}

static void
__lambda11_ (MathConverter* self,
             GParamSpec* pspec)
{
#line 48 "../src/math-converter.vala"
	g_return_if_fail (pspec != NULL);
#line 48 "../src/math-converter.vala"
	math_converter_update_result_label (self);
#line 183 "math-converter.c"
}

static void
___lambda11__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 48 "../src/math-converter.vala"
	__lambda11_ ((MathConverter*) self, pspec);
#line 193 "math-converter.c"
}

void
math_converter_set_equation (MathConverter* self,
                             MathEquation* equation)
{
	MathEquation* _tmp0_;
#line 45 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/math-converter.vala"
	g_return_if_fail (equation != NULL);
#line 47 "../src/math-converter.vala"
	_tmp0_ = _g_object_ref0 (equation);
#line 47 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->equation);
#line 47 "../src/math-converter.vala"
	self->priv->equation = _tmp0_;
#line 48 "../src/math-converter.vala"
	g_signal_connect_object ((GObject*) equation, "notify::display", (GCallback) ___lambda11__g_object_notify, self, 0);
#line 213 "math-converter.c"
}

void
math_converter_set_category (MathConverter* self,
                             const gchar* category)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 51 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/math-converter.vala"
	_tmp0_ = self->priv->category;
#line 53 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp0_, category) == 0) {
#line 54 "../src/math-converter.vala"
		return;
#line 230 "math-converter.c"
	}
#line 55 "../src/math-converter.vala"
	_tmp1_ = g_strdup (category);
#line 55 "../src/math-converter.vala"
	_g_free0 (self->priv->category);
#line 55 "../src/math-converter.vala"
	self->priv->category = _tmp1_;
#line 57 "../src/math-converter.vala"
	math_converter_update_from_model (self);
#line 240 "math-converter.c"
}

gchar*
math_converter_get_category (MathConverter* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 60 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../src/math-converter.vala"
	_tmp0_ = self->priv->category;
#line 62 "../src/math-converter.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 62 "../src/math-converter.vala"
	result = _tmp1_;
#line 62 "../src/math-converter.vala"
	return result;
#line 259 "math-converter.c"
}

void
math_converter_set_conversion (MathConverter* self,
                               const gchar* unit_a,
                               const gchar* unit_b)
{
	Unit* ua = NULL;
	UnitManager* _tmp0_;
	UnitManager* _tmp1_;
	Unit* _tmp2_;
	Unit* _tmp3_;
	Unit* ub = NULL;
	UnitManager* _tmp4_;
	UnitManager* _tmp5_;
	Unit* _tmp6_;
	Unit* _tmp7_;
	gboolean _tmp8_ = FALSE;
	Unit* _tmp9_;
	GtkComboBox* _tmp24_;
	Unit* _tmp25_;
	GtkComboBox* _tmp26_;
	Unit* _tmp27_;
#line 65 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/math-converter.vala"
	g_return_if_fail (unit_a != NULL);
#line 65 "../src/math-converter.vala"
	g_return_if_fail (unit_b != NULL);
#line 67 "../src/math-converter.vala"
	_tmp0_ = unit_manager_get_default ();
#line 67 "../src/math-converter.vala"
	_tmp1_ = _tmp0_;
#line 67 "../src/math-converter.vala"
	_tmp2_ = unit_manager_get_unit_by_name (_tmp1_, unit_a);
#line 67 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 67 "../src/math-converter.vala"
	_g_object_unref0 (_tmp1_);
#line 67 "../src/math-converter.vala"
	ua = _tmp3_;
#line 68 "../src/math-converter.vala"
	_tmp4_ = unit_manager_get_default ();
#line 68 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 68 "../src/math-converter.vala"
	_tmp6_ = unit_manager_get_unit_by_name (_tmp5_, unit_b);
#line 68 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 68 "../src/math-converter.vala"
	_g_object_unref0 (_tmp5_);
#line 68 "../src/math-converter.vala"
	ub = _tmp7_;
#line 69 "../src/math-converter.vala"
	_tmp9_ = ua;
#line 69 "../src/math-converter.vala"
	if (_tmp9_ == NULL) {
#line 69 "../src/math-converter.vala"
		_tmp8_ = TRUE;
#line 319 "math-converter.c"
	} else {
		Unit* _tmp10_;
#line 69 "../src/math-converter.vala"
		_tmp10_ = ub;
#line 69 "../src/math-converter.vala"
		_tmp8_ = _tmp10_ == NULL;
#line 326 "math-converter.c"
	}
#line 69 "../src/math-converter.vala"
	if (_tmp8_) {
#line 330 "math-converter.c"
		GtkTreeModel* model = NULL;
		GtkComboBox* _tmp11_;
		GtkTreeModel* _tmp12_;
		GtkTreeModel* _tmp13_;
		GtkTreeIter iter = {0};
		GtkTreeModel* _tmp14_;
		GtkTreeIter _tmp15_ = {0};
		gboolean _tmp16_;
#line 72 "../src/math-converter.vala"
		_tmp11_ = self->priv->from_combo;
#line 72 "../src/math-converter.vala"
		_tmp12_ = gtk_combo_box_get_model (_tmp11_);
#line 72 "../src/math-converter.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 72 "../src/math-converter.vala"
		model = _tmp13_;
#line 74 "../src/math-converter.vala"
		_tmp14_ = model;
#line 74 "../src/math-converter.vala"
		_tmp16_ = gtk_tree_model_get_iter_first (_tmp14_, &_tmp15_);
#line 74 "../src/math-converter.vala"
		iter = _tmp15_;
#line 74 "../src/math-converter.vala"
		if (_tmp16_) {
#line 355 "math-converter.c"
			GtkTreeIter child_iter = {0};
			GtkComboBox* _tmp22_;
			GtkTreeIter _tmp23_;
#line 77 "../src/math-converter.vala"
			while (TRUE) {
#line 361 "math-converter.c"
				GtkTreeModel* _tmp17_;
				GtkTreeIter _tmp18_;
				GtkTreeIter _tmp19_ = {0};
				gboolean _tmp20_;
				GtkTreeIter _tmp21_;
#line 77 "../src/math-converter.vala"
				_tmp17_ = model;
#line 77 "../src/math-converter.vala"
				_tmp18_ = iter;
#line 77 "../src/math-converter.vala"
				_tmp20_ = gtk_tree_model_iter_children (_tmp17_, &_tmp19_, &_tmp18_);
#line 77 "../src/math-converter.vala"
				child_iter = _tmp19_;
#line 77 "../src/math-converter.vala"
				if (!_tmp20_) {
#line 77 "../src/math-converter.vala"
					break;
#line 379 "math-converter.c"
				}
#line 78 "../src/math-converter.vala"
				_tmp21_ = child_iter;
#line 78 "../src/math-converter.vala"
				iter = _tmp21_;
#line 385 "math-converter.c"
			}
#line 79 "../src/math-converter.vala"
			_tmp22_ = self->priv->from_combo;
#line 79 "../src/math-converter.vala"
			_tmp23_ = iter;
#line 79 "../src/math-converter.vala"
			gtk_combo_box_set_active_iter (_tmp22_, &_tmp23_);
#line 393 "math-converter.c"
		}
#line 81 "../src/math-converter.vala"
		_g_object_unref0 (model);
#line 81 "../src/math-converter.vala"
		_g_object_unref0 (ub);
#line 81 "../src/math-converter.vala"
		_g_object_unref0 (ua);
#line 81 "../src/math-converter.vala"
		return;
#line 403 "math-converter.c"
	}
#line 84 "../src/math-converter.vala"
	_tmp24_ = self->priv->from_combo;
#line 84 "../src/math-converter.vala"
	_tmp25_ = ua;
#line 84 "../src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp24_, NULL, _tmp25_);
#line 85 "../src/math-converter.vala"
	_tmp26_ = self->priv->to_combo;
#line 85 "../src/math-converter.vala"
	_tmp27_ = ub;
#line 85 "../src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp26_, NULL, _tmp27_);
#line 65 "../src/math-converter.vala"
	_g_object_unref0 (ub);
#line 65 "../src/math-converter.vala"
	_g_object_unref0 (ua);
#line 421 "math-converter.c"
}

void
math_converter_get_conversion (MathConverter* self,
                               Unit* * from_unit,
                               Unit* * to_unit)
{
	Unit* _vala_from_unit = NULL;
	Unit* _vala_to_unit = NULL;
	GtkTreeIter from_iter = {0};
	GtkTreeIter to_iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkComboBox* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	GtkComboBox* _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreeIter _tmp6_;
	Unit* _tmp7_ = NULL;
	GtkComboBox* _tmp8_;
	GtkTreeModel* _tmp9_;
	GtkTreeIter _tmp10_;
	Unit* _tmp11_ = NULL;
#line 88 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 92 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_combo;
#line 92 "../src/math-converter.vala"
	gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 92 "../src/math-converter.vala"
	from_iter = _tmp1_;
#line 93 "../src/math-converter.vala"
	_tmp2_ = self->priv->to_combo;
#line 93 "../src/math-converter.vala"
	gtk_combo_box_get_active_iter (_tmp2_, &_tmp3_);
#line 93 "../src/math-converter.vala"
	to_iter = _tmp3_;
#line 95 "../src/math-converter.vala"
	_tmp4_ = self->priv->from_combo;
#line 95 "../src/math-converter.vala"
	_tmp5_ = gtk_combo_box_get_model (_tmp4_);
#line 95 "../src/math-converter.vala"
	_tmp6_ = from_iter;
#line 95 "../src/math-converter.vala"
	gtk_tree_model_get (_tmp5_, &_tmp6_, 2, &_tmp7_, -1, -1);
#line 95 "../src/math-converter.vala"
	_g_object_unref0 (_vala_from_unit);
#line 95 "../src/math-converter.vala"
	_vala_from_unit = _tmp7_;
#line 96 "../src/math-converter.vala"
	_tmp8_ = self->priv->to_combo;
#line 96 "../src/math-converter.vala"
	_tmp9_ = gtk_combo_box_get_model (_tmp8_);
#line 96 "../src/math-converter.vala"
	_tmp10_ = to_iter;
#line 96 "../src/math-converter.vala"
	gtk_tree_model_get (_tmp9_, &_tmp10_, 2, &_tmp11_, -1, -1);
#line 96 "../src/math-converter.vala"
	_g_object_unref0 (_vala_to_unit);
#line 96 "../src/math-converter.vala"
	_vala_to_unit = _tmp11_;
#line 88 "../src/math-converter.vala"
	if (from_unit) {
#line 88 "../src/math-converter.vala"
		*from_unit = _vala_from_unit;
#line 487 "math-converter.c"
	} else {
#line 88 "../src/math-converter.vala"
		_g_object_unref0 (_vala_from_unit);
#line 491 "math-converter.c"
	}
#line 88 "../src/math-converter.vala"
	if (to_unit) {
#line 88 "../src/math-converter.vala"
		*to_unit = _vala_to_unit;
#line 497 "math-converter.c"
	} else {
#line 88 "../src/math-converter.vala"
		_g_object_unref0 (_vala_to_unit);
#line 501 "math-converter.c"
	}
}

static void
math_converter_update_result_label (MathConverter* self)
{
	Number* x = NULL;
	MathEquation* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	Number* z = NULL;
	Number* _tmp4_;
	Unit* _tmp5_ = NULL;
	Unit* _tmp6_ = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
#line 99 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 101 "../src/math-converter.vala"
	_tmp0_ = self->priv->equation;
#line 101 "../src/math-converter.vala"
	_tmp1_ = math_equation_get_number (_tmp0_);
#line 101 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 101 "../src/math-converter.vala"
	x = _tmp2_;
#line 102 "../src/math-converter.vala"
	_tmp3_ = x;
#line 102 "../src/math-converter.vala"
	if (_tmp3_ == NULL) {
#line 103 "../src/math-converter.vala"
		_g_object_unref0 (x);
#line 103 "../src/math-converter.vala"
		return;
#line 539 "math-converter.c"
	}
#line 106 "../src/math-converter.vala"
	_tmp4_ = x;
#line 106 "../src/math-converter.vala"
	_tmp7_ = math_converter_convert_equation (self, _tmp4_, &_tmp5_, &_tmp6_);
#line 106 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 106 "../src/math-converter.vala"
	source_unit = _tmp5_;
#line 106 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 106 "../src/math-converter.vala"
	target_unit = _tmp6_;
#line 106 "../src/math-converter.vala"
	z = _tmp7_;
#line 107 "../src/math-converter.vala"
	_tmp8_ = z;
#line 107 "../src/math-converter.vala"
	if (_tmp8_ != NULL) {
#line 559 "math-converter.c"
		gchar* source_text = NULL;
		Unit* _tmp9_;
		Number* _tmp10_;
		gchar* _tmp11_;
		gchar* target_text = NULL;
		Unit* _tmp12_;
		Number* _tmp13_;
		gchar* _tmp14_;
		GtkLabel* _tmp15_;
		const gchar* _tmp16_;
		GtkLabel* _tmp17_;
		const gchar* _tmp18_;
#line 109 "../src/math-converter.vala"
		_tmp9_ = source_unit;
#line 109 "../src/math-converter.vala"
		_tmp10_ = x;
#line 109 "../src/math-converter.vala"
		_tmp11_ = unit_format (_tmp9_, _tmp10_);
#line 109 "../src/math-converter.vala"
		source_text = _tmp11_;
#line 110 "../src/math-converter.vala"
		_tmp12_ = target_unit;
#line 110 "../src/math-converter.vala"
		_tmp13_ = z;
#line 110 "../src/math-converter.vala"
		_tmp14_ = unit_format (_tmp12_, _tmp13_);
#line 110 "../src/math-converter.vala"
		target_text = _tmp14_;
#line 111 "../src/math-converter.vala"
		_tmp15_ = self->priv->from_label;
#line 111 "../src/math-converter.vala"
		_tmp16_ = source_text;
#line 111 "../src/math-converter.vala"
		gtk_label_set_text (_tmp15_, _tmp16_);
#line 112 "../src/math-converter.vala"
		_tmp17_ = self->priv->to_label;
#line 112 "../src/math-converter.vala"
		_tmp18_ = target_text;
#line 112 "../src/math-converter.vala"
		gtk_label_set_text (_tmp17_, _tmp18_);
#line 107 "../src/math-converter.vala"
		_g_free0 (target_text);
#line 107 "../src/math-converter.vala"
		_g_free0 (source_text);
#line 604 "math-converter.c"
	}
#line 99 "../src/math-converter.vala"
	_g_object_unref0 (z);
#line 99 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 99 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 99 "../src/math-converter.vala"
	_g_object_unref0 (x);
#line 614 "math-converter.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 120 "../src/math-converter.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 622 "math-converter.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 120 "../src/math-converter.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 630 "math-converter.c"
}

static void
math_converter_update_from_model (MathConverter* self)
{
	GtkTreeStore* from_model = NULL;
	GtkTreeStore* _tmp0_;
	const gchar* _tmp1_;
	GtkComboBox* _tmp49_;
	GtkTreeStore* _tmp50_;
#line 116 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 118 "../src/math-converter.vala"
	_tmp0_ = gtk_tree_store_new (3, G_TYPE_STRING, TYPE_UNIT_CATEGORY, TYPE_UNIT);
#line 118 "../src/math-converter.vala"
	from_model = _tmp0_;
#line 120 "../src/math-converter.vala"
	_tmp1_ = self->priv->category;
#line 120 "../src/math-converter.vala"
	if (_tmp1_ == NULL) {
#line 651 "math-converter.c"
		GList* categories = NULL;
		UnitManager* _tmp2_;
		UnitManager* _tmp3_;
		GList* _tmp4_;
		GList* _tmp5_;
		GList* _tmp6_;
#line 122 "../src/math-converter.vala"
		_tmp2_ = unit_manager_get_default ();
#line 122 "../src/math-converter.vala"
		_tmp3_ = _tmp2_;
#line 122 "../src/math-converter.vala"
		_tmp4_ = unit_manager_get_categories (_tmp3_);
#line 122 "../src/math-converter.vala"
		_tmp5_ = _tmp4_;
#line 122 "../src/math-converter.vala"
		_g_object_unref0 (_tmp3_);
#line 122 "../src/math-converter.vala"
		categories = _tmp5_;
#line 123 "../src/math-converter.vala"
		_tmp6_ = categories;
#line 672 "math-converter.c"
		{
			GList* category_collection = NULL;
			GList* category_it = NULL;
#line 123 "../src/math-converter.vala"
			category_collection = _tmp6_;
#line 123 "../src/math-converter.vala"
			for (category_it = category_collection; category_it != NULL; category_it = category_it->next) {
#line 680 "math-converter.c"
				UnitCategory* _tmp7_;
				UnitCategory* category = NULL;
#line 123 "../src/math-converter.vala"
				_tmp7_ = _g_object_ref0 ((UnitCategory*) category_it->data);
#line 123 "../src/math-converter.vala"
				category = _tmp7_;
#line 687 "math-converter.c"
				{
					GtkTreeIter parent = {0};
					GtkTreeStore* _tmp8_;
					GtkTreeIter _tmp9_ = {0};
					GtkTreeStore* _tmp10_;
					GtkTreeIter _tmp11_;
					UnitCategory* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
					UnitCategory* _tmp16_;
					UnitCategory* _tmp17_;
					GList* _tmp18_;
#line 126 "../src/math-converter.vala"
					_tmp8_ = from_model;
#line 126 "../src/math-converter.vala"
					gtk_tree_store_append (_tmp8_, &_tmp9_, NULL);
#line 126 "../src/math-converter.vala"
					parent = _tmp9_;
#line 127 "../src/math-converter.vala"
					_tmp10_ = from_model;
#line 127 "../src/math-converter.vala"
					_tmp11_ = parent;
#line 127 "../src/math-converter.vala"
					_tmp12_ = category;
#line 127 "../src/math-converter.vala"
					_tmp13_ = unit_category_get_display_name (_tmp12_);
#line 127 "../src/math-converter.vala"
					_tmp14_ = _tmp13_;
#line 127 "../src/math-converter.vala"
					_tmp15_ = _tmp14_;
#line 127 "../src/math-converter.vala"
					_tmp16_ = category;
#line 127 "../src/math-converter.vala"
					gtk_tree_store_set (_tmp10_, &_tmp11_, 0, _tmp15_, 1, _tmp16_, -1, -1);
#line 127 "../src/math-converter.vala"
					_g_free0 (_tmp15_);
#line 129 "../src/math-converter.vala"
					_tmp17_ = category;
#line 129 "../src/math-converter.vala"
					_tmp18_ = unit_category_get_units (_tmp17_);
#line 729 "math-converter.c"
					{
						GList* unit_collection = NULL;
						GList* unit_it = NULL;
#line 129 "../src/math-converter.vala"
						unit_collection = _tmp18_;
#line 129 "../src/math-converter.vala"
						for (unit_it = unit_collection; unit_it != NULL; unit_it = unit_it->next) {
#line 737 "math-converter.c"
							Unit* _tmp19_;
							Unit* unit = NULL;
#line 129 "../src/math-converter.vala"
							_tmp19_ = _g_object_ref0 ((Unit*) unit_it->data);
#line 129 "../src/math-converter.vala"
							unit = _tmp19_;
#line 744 "math-converter.c"
							{
								GtkTreeIter iter = {0};
								GtkTreeStore* _tmp20_;
								GtkTreeIter _tmp21_;
								GtkTreeIter _tmp22_ = {0};
								GtkTreeStore* _tmp23_;
								GtkTreeIter _tmp24_;
								Unit* _tmp25_;
								gchar* _tmp26_;
								gchar* _tmp27_;
								gchar* _tmp28_;
								UnitCategory* _tmp29_;
								Unit* _tmp30_;
#line 132 "../src/math-converter.vala"
								_tmp20_ = from_model;
#line 132 "../src/math-converter.vala"
								_tmp21_ = parent;
#line 132 "../src/math-converter.vala"
								gtk_tree_store_append (_tmp20_, &_tmp22_, &_tmp21_);
#line 132 "../src/math-converter.vala"
								iter = _tmp22_;
#line 133 "../src/math-converter.vala"
								_tmp23_ = from_model;
#line 133 "../src/math-converter.vala"
								_tmp24_ = iter;
#line 133 "../src/math-converter.vala"
								_tmp25_ = unit;
#line 133 "../src/math-converter.vala"
								_tmp26_ = unit_get_display_name (_tmp25_);
#line 133 "../src/math-converter.vala"
								_tmp27_ = _tmp26_;
#line 133 "../src/math-converter.vala"
								_tmp28_ = _tmp27_;
#line 133 "../src/math-converter.vala"
								_tmp29_ = category;
#line 133 "../src/math-converter.vala"
								_tmp30_ = unit;
#line 133 "../src/math-converter.vala"
								gtk_tree_store_set (_tmp23_, &_tmp24_, 0, _tmp28_, 1, _tmp29_, 2, _tmp30_, -1, -1);
#line 133 "../src/math-converter.vala"
								_g_free0 (_tmp28_);
#line 129 "../src/math-converter.vala"
								_g_object_unref0 (unit);
#line 788 "math-converter.c"
							}
						}
					}
#line 123 "../src/math-converter.vala"
					_g_object_unref0 (category);
#line 794 "math-converter.c"
				}
			}
		}
#line 120 "../src/math-converter.vala"
		(categories == NULL) ? NULL : (categories = (_g_list_free__g_object_unref0_ (categories), NULL));
#line 800 "math-converter.c"
	} else {
		UnitCategory* c = NULL;
		UnitManager* _tmp31_;
		UnitManager* _tmp32_;
		const gchar* _tmp33_;
		UnitCategory* _tmp34_;
		UnitCategory* _tmp35_;
		UnitCategory* _tmp36_;
		GList* _tmp37_;
#line 139 "../src/math-converter.vala"
		_tmp31_ = unit_manager_get_default ();
#line 139 "../src/math-converter.vala"
		_tmp32_ = _tmp31_;
#line 139 "../src/math-converter.vala"
		_tmp33_ = self->priv->category;
#line 139 "../src/math-converter.vala"
		_tmp34_ = unit_manager_get_category (_tmp32_, _tmp33_);
#line 139 "../src/math-converter.vala"
		_tmp35_ = _tmp34_;
#line 139 "../src/math-converter.vala"
		_g_object_unref0 (_tmp32_);
#line 139 "../src/math-converter.vala"
		c = _tmp35_;
#line 140 "../src/math-converter.vala"
		_tmp36_ = c;
#line 140 "../src/math-converter.vala"
		_tmp37_ = unit_category_get_units (_tmp36_);
#line 828 "math-converter.c"
		{
			GList* unit_collection = NULL;
			GList* unit_it = NULL;
#line 140 "../src/math-converter.vala"
			unit_collection = _tmp37_;
#line 140 "../src/math-converter.vala"
			for (unit_it = unit_collection; unit_it != NULL; unit_it = unit_it->next) {
#line 836 "math-converter.c"
				Unit* _tmp38_;
				Unit* unit = NULL;
#line 140 "../src/math-converter.vala"
				_tmp38_ = _g_object_ref0 ((Unit*) unit_it->data);
#line 140 "../src/math-converter.vala"
				unit = _tmp38_;
#line 843 "math-converter.c"
				{
					GtkTreeIter iter = {0};
					GtkTreeStore* _tmp39_;
					GtkTreeIter _tmp40_ = {0};
					GtkTreeStore* _tmp41_;
					GtkTreeIter _tmp42_;
					Unit* _tmp43_;
					gchar* _tmp44_;
					gchar* _tmp45_;
					gchar* _tmp46_;
					UnitCategory* _tmp47_;
					Unit* _tmp48_;
#line 143 "../src/math-converter.vala"
					_tmp39_ = from_model;
#line 143 "../src/math-converter.vala"
					gtk_tree_store_append (_tmp39_, &_tmp40_, NULL);
#line 143 "../src/math-converter.vala"
					iter = _tmp40_;
#line 144 "../src/math-converter.vala"
					_tmp41_ = from_model;
#line 144 "../src/math-converter.vala"
					_tmp42_ = iter;
#line 144 "../src/math-converter.vala"
					_tmp43_ = unit;
#line 144 "../src/math-converter.vala"
					_tmp44_ = unit_get_display_name (_tmp43_);
#line 144 "../src/math-converter.vala"
					_tmp45_ = _tmp44_;
#line 144 "../src/math-converter.vala"
					_tmp46_ = _tmp45_;
#line 144 "../src/math-converter.vala"
					_tmp47_ = c;
#line 144 "../src/math-converter.vala"
					_tmp48_ = unit;
#line 144 "../src/math-converter.vala"
					gtk_tree_store_set (_tmp41_, &_tmp42_, 0, _tmp46_, 1, _tmp47_, 2, _tmp48_, -1, -1);
#line 144 "../src/math-converter.vala"
					_g_free0 (_tmp46_);
#line 140 "../src/math-converter.vala"
					_g_object_unref0 (unit);
#line 884 "math-converter.c"
				}
			}
		}
#line 120 "../src/math-converter.vala"
		_g_object_unref0 (c);
#line 890 "math-converter.c"
	}
#line 148 "../src/math-converter.vala"
	_tmp49_ = self->priv->from_combo;
#line 148 "../src/math-converter.vala"
	_tmp50_ = from_model;
#line 148 "../src/math-converter.vala"
	gtk_combo_box_set_model (_tmp49_, (GtkTreeModel*) _tmp50_);
#line 116 "../src/math-converter.vala"
	_g_object_unref0 (from_model);
#line 900 "math-converter.c"
}

static gboolean
math_converter_iter_is_unit (MathConverter* self,
                             GtkTreeModel* model,
                             GtkTreeIter* iter,
                             Unit* unit)
{
	gboolean result = FALSE;
	Unit* u = NULL;
	GtkTreeIter _tmp0_;
	Unit* _tmp1_ = NULL;
#line 151 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 151 "../src/math-converter.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 151 "../src/math-converter.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 151 "../src/math-converter.vala"
	g_return_val_if_fail (unit != NULL, FALSE);
#line 154 "../src/math-converter.vala"
	_tmp0_ = *iter;
#line 154 "../src/math-converter.vala"
	gtk_tree_model_get (model, &_tmp0_, 2, &_tmp1_, -1, -1);
#line 154 "../src/math-converter.vala"
	_g_object_unref0 (u);
#line 154 "../src/math-converter.vala"
	u = _tmp1_;
#line 155 "../src/math-converter.vala"
	result = u == unit;
#line 155 "../src/math-converter.vala"
	_g_object_unref0 (u);
#line 155 "../src/math-converter.vala"
	return result;
#line 935 "math-converter.c"
}

static gboolean
math_converter_set_active_unit (MathConverter* self,
                                GtkComboBox* combo,
                                GtkTreeIter* iter,
                                Unit* unit)
{
	gboolean result = FALSE;
	GtkTreeModel* model = NULL;
	GtkTreeModel* _tmp0_;
	GtkTreeModel* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkTreeIter child_iter = {0};
	GtkTreeModel* _tmp5_;
	GtkTreeIter _tmp6_ = {0};
	gboolean _tmp7_;
#line 158 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 158 "../src/math-converter.vala"
	g_return_val_if_fail (combo != NULL, FALSE);
#line 158 "../src/math-converter.vala"
	g_return_val_if_fail (unit != NULL, FALSE);
#line 160 "../src/math-converter.vala"
	_tmp0_ = gtk_combo_box_get_model (combo);
#line 160 "../src/math-converter.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 160 "../src/math-converter.vala"
	model = _tmp1_;
#line 161 "../src/math-converter.vala"
	if (iter != NULL) {
#line 967 "math-converter.c"
		GtkTreeModel* _tmp3_;
		GtkTreeIter _tmp4_;
#line 161 "../src/math-converter.vala"
		_tmp3_ = model;
#line 161 "../src/math-converter.vala"
		_tmp4_ = *iter;
#line 161 "../src/math-converter.vala"
		_tmp2_ = math_converter_iter_is_unit (self, _tmp3_, &_tmp4_, unit);
#line 976 "math-converter.c"
	} else {
#line 161 "../src/math-converter.vala"
		_tmp2_ = FALSE;
#line 980 "math-converter.c"
	}
#line 161 "../src/math-converter.vala"
	if (_tmp2_) {
#line 163 "../src/math-converter.vala"
		gtk_combo_box_set_active_iter (combo, iter);
#line 164 "../src/math-converter.vala"
		result = TRUE;
#line 164 "../src/math-converter.vala"
		_g_object_unref0 (model);
#line 164 "../src/math-converter.vala"
		return result;
#line 992 "math-converter.c"
	}
#line 168 "../src/math-converter.vala"
	_tmp5_ = model;
#line 168 "../src/math-converter.vala"
	_tmp7_ = gtk_tree_model_iter_children (_tmp5_, &_tmp6_, iter);
#line 168 "../src/math-converter.vala"
	child_iter = _tmp6_;
#line 168 "../src/math-converter.vala"
	if (!_tmp7_) {
#line 169 "../src/math-converter.vala"
		result = FALSE;
#line 169 "../src/math-converter.vala"
		_g_object_unref0 (model);
#line 169 "../src/math-converter.vala"
		return result;
#line 1008 "math-converter.c"
	}
	{
		gboolean _tmp8_ = FALSE;
#line 171 "../src/math-converter.vala"
		_tmp8_ = TRUE;
#line 171 "../src/math-converter.vala"
		while (TRUE) {
#line 1016 "math-converter.c"
			GtkTreeIter _tmp11_;
#line 171 "../src/math-converter.vala"
			if (!_tmp8_) {
#line 1020 "math-converter.c"
				GtkTreeModel* _tmp9_;
				gboolean _tmp10_;
#line 175 "../src/math-converter.vala"
				_tmp9_ = model;
#line 175 "../src/math-converter.vala"
				_tmp10_ = gtk_tree_model_iter_next (_tmp9_, &child_iter);
#line 175 "../src/math-converter.vala"
				if (!_tmp10_) {
#line 175 "../src/math-converter.vala"
					break;
#line 1031 "math-converter.c"
				}
			}
#line 171 "../src/math-converter.vala"
			_tmp8_ = FALSE;
#line 173 "../src/math-converter.vala"
			_tmp11_ = child_iter;
#line 173 "../src/math-converter.vala"
			if (math_converter_set_active_unit (self, combo, &_tmp11_, unit)) {
#line 174 "../src/math-converter.vala"
				result = TRUE;
#line 174 "../src/math-converter.vala"
				_g_object_unref0 (model);
#line 174 "../src/math-converter.vala"
				return result;
#line 1046 "math-converter.c"
			}
		}
	}
#line 177 "../src/math-converter.vala"
	result = FALSE;
#line 177 "../src/math-converter.vala"
	_g_object_unref0 (model);
#line 177 "../src/math-converter.vala"
	return result;
#line 1056 "math-converter.c"
}

static void
math_converter_from_combobox_changed_cb (MathConverter* self)
{
	UnitCategory* category = NULL;
	UnitCategory* to_category = NULL;
	Unit* unit = NULL;
	GtkTreeIter iter = {0};
	GtkTreeIter to_iter = {0};
	GtkTreeModel* model = NULL;
	GtkComboBox* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkListStore* to_model = NULL;
	GtkComboBox* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkListStore* _tmp5_;
	GtkComboBox* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	gboolean _tmp8_;
	GtkTreeModel* _tmp9_;
	GtkTreeIter _tmp10_;
	UnitCategory* _tmp11_ = NULL;
	Unit* _tmp12_ = NULL;
	GtkComboBox* _tmp13_;
	GtkTreeIter _tmp14_ = {0};
	gboolean _tmp15_;
	UnitCategory* _tmp19_;
	UnitCategory* _tmp20_;
#line 181 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/math-converter.vala"
	category = NULL;
#line 183 "../src/math-converter.vala"
	to_category = NULL;
#line 187 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_combo;
#line 187 "../src/math-converter.vala"
	_tmp1_ = gtk_combo_box_get_model (_tmp0_);
#line 187 "../src/math-converter.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 187 "../src/math-converter.vala"
	model = _tmp2_;
#line 188 "../src/math-converter.vala"
	_tmp3_ = self->priv->to_combo;
#line 188 "../src/math-converter.vala"
	_tmp4_ = gtk_combo_box_get_model (_tmp3_);
#line 188 "../src/math-converter.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gtk_list_store_get_type ()) ? ((GtkListStore*) _tmp4_) : NULL);
#line 188 "../src/math-converter.vala"
	to_model = _tmp5_;
#line 190 "../src/math-converter.vala"
	_tmp6_ = self->priv->from_combo;
#line 190 "../src/math-converter.vala"
	_tmp8_ = gtk_combo_box_get_active_iter (_tmp6_, &_tmp7_);
#line 190 "../src/math-converter.vala"
	iter = _tmp7_;
#line 190 "../src/math-converter.vala"
	if (!_tmp8_) {
#line 191 "../src/math-converter.vala"
		_g_object_unref0 (to_model);
#line 191 "../src/math-converter.vala"
		_g_object_unref0 (model);
#line 191 "../src/math-converter.vala"
		_g_object_unref0 (unit);
#line 191 "../src/math-converter.vala"
		_g_object_unref0 (to_category);
#line 191 "../src/math-converter.vala"
		_g_object_unref0 (category);
#line 191 "../src/math-converter.vala"
		return;
#line 1129 "math-converter.c"
	}
#line 193 "../src/math-converter.vala"
	_tmp9_ = model;
#line 193 "../src/math-converter.vala"
	_tmp10_ = iter;
#line 193 "../src/math-converter.vala"
	gtk_tree_model_get (_tmp9_, &_tmp10_, 1, &_tmp11_, 2, &_tmp12_, -1, -1);
#line 193 "../src/math-converter.vala"
	_g_object_unref0 (category);
#line 193 "../src/math-converter.vala"
	category = _tmp11_;
#line 193 "../src/math-converter.vala"
	_g_object_unref0 (unit);
#line 193 "../src/math-converter.vala"
	unit = _tmp12_;
#line 194 "../src/math-converter.vala"
	_tmp13_ = self->priv->to_combo;
#line 194 "../src/math-converter.vala"
	_tmp15_ = gtk_combo_box_get_active_iter (_tmp13_, &_tmp14_);
#line 194 "../src/math-converter.vala"
	to_iter = _tmp14_;
#line 194 "../src/math-converter.vala"
	if (_tmp15_) {
#line 1153 "math-converter.c"
		GtkListStore* _tmp16_;
		GtkTreeIter _tmp17_;
		UnitCategory* _tmp18_ = NULL;
#line 195 "../src/math-converter.vala"
		_tmp16_ = to_model;
#line 195 "../src/math-converter.vala"
		_tmp17_ = to_iter;
#line 195 "../src/math-converter.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp16_, &_tmp17_, 1, &_tmp18_, -1);
#line 195 "../src/math-converter.vala"
		_g_object_unref0 (to_category);
#line 195 "../src/math-converter.vala"
		to_category = _tmp18_;
#line 1167 "math-converter.c"
	}
#line 197 "../src/math-converter.vala"
	_tmp19_ = category;
#line 197 "../src/math-converter.vala"
	_tmp20_ = to_category;
#line 197 "../src/math-converter.vala"
	if (_tmp19_ != _tmp20_) {
#line 1175 "math-converter.c"
		GtkListStore* _tmp21_;
		UnitCategory* _tmp22_;
		GList* _tmp23_;
		GtkComboBox* _tmp35_;
		GtkListStore* _tmp36_;
		GtkComboBox* _tmp37_;
#line 200 "../src/math-converter.vala"
		_tmp21_ = gtk_list_store_new (3, G_TYPE_STRING, TYPE_UNIT_CATEGORY, TYPE_UNIT, -1);
#line 200 "../src/math-converter.vala"
		_g_object_unref0 (to_model);
#line 200 "../src/math-converter.vala"
		to_model = _tmp21_;
#line 201 "../src/math-converter.vala"
		_tmp22_ = category;
#line 201 "../src/math-converter.vala"
		_tmp23_ = unit_category_get_units (_tmp22_);
#line 1192 "math-converter.c"
		{
			GList* u_collection = NULL;
			GList* u_it = NULL;
#line 201 "../src/math-converter.vala"
			u_collection = _tmp23_;
#line 201 "../src/math-converter.vala"
			for (u_it = u_collection; u_it != NULL; u_it = u_it->next) {
#line 1200 "math-converter.c"
				Unit* _tmp24_;
				Unit* u = NULL;
#line 201 "../src/math-converter.vala"
				_tmp24_ = _g_object_ref0 ((Unit*) u_it->data);
#line 201 "../src/math-converter.vala"
				u = _tmp24_;
#line 1207 "math-converter.c"
				{
					GtkListStore* _tmp25_;
					GtkTreeIter _tmp26_ = {0};
					GtkListStore* _tmp27_;
					GtkTreeIter _tmp28_;
					Unit* _tmp29_;
					gchar* _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
					UnitCategory* _tmp33_;
					Unit* _tmp34_;
#line 203 "../src/math-converter.vala"
					_tmp25_ = to_model;
#line 203 "../src/math-converter.vala"
					gtk_list_store_append (_tmp25_, &_tmp26_);
#line 203 "../src/math-converter.vala"
					iter = _tmp26_;
#line 204 "../src/math-converter.vala"
					_tmp27_ = to_model;
#line 204 "../src/math-converter.vala"
					_tmp28_ = iter;
#line 204 "../src/math-converter.vala"
					_tmp29_ = u;
#line 204 "../src/math-converter.vala"
					_tmp30_ = unit_get_display_name (_tmp29_);
#line 204 "../src/math-converter.vala"
					_tmp31_ = _tmp30_;
#line 204 "../src/math-converter.vala"
					_tmp32_ = _tmp31_;
#line 204 "../src/math-converter.vala"
					_tmp33_ = category;
#line 204 "../src/math-converter.vala"
					_tmp34_ = u;
#line 204 "../src/math-converter.vala"
					gtk_list_store_set (_tmp27_, &_tmp28_, 0, _tmp32_, 1, _tmp33_, 2, _tmp34_, -1, -1);
#line 204 "../src/math-converter.vala"
					_g_free0 (_tmp32_);
#line 201 "../src/math-converter.vala"
					_g_object_unref0 (u);
#line 1247 "math-converter.c"
				}
			}
		}
#line 206 "../src/math-converter.vala"
		_tmp35_ = self->priv->to_combo;
#line 206 "../src/math-converter.vala"
		_tmp36_ = to_model;
#line 206 "../src/math-converter.vala"
		gtk_combo_box_set_model (_tmp35_, (GtkTreeModel*) _tmp36_);
#line 209 "../src/math-converter.vala"
		_tmp37_ = self->priv->to_combo;
#line 209 "../src/math-converter.vala"
		gtk_combo_box_set_active (_tmp37_, 0);
#line 1261 "math-converter.c"
	}
#line 181 "../src/math-converter.vala"
	_g_object_unref0 (to_model);
#line 181 "../src/math-converter.vala"
	_g_object_unref0 (model);
#line 181 "../src/math-converter.vala"
	_g_object_unref0 (unit);
#line 181 "../src/math-converter.vala"
	_g_object_unref0 (to_category);
#line 181 "../src/math-converter.vala"
	_g_object_unref0 (category);
#line 1273 "math-converter.c"
}

static void
_math_converter_from_combobox_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_from_combobox_changed_cb ((MathConverter*) self);
#line 1282 "math-converter.c"
}

static void
math_converter_to_combobox_changed_cb (MathConverter* self)
{
#line 214 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 217 "../src/math-converter.vala"
	math_converter_update_result_label (self);
#line 218 "../src/math-converter.vala"
	g_signal_emit (self, math_converter_signals[MATH_CONVERTER_CHANGED_SIGNAL], 0);
#line 1294 "math-converter.c"
}

static void
_math_converter_to_combobox_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                              gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_to_combobox_changed_cb ((MathConverter*) self);
#line 1303 "math-converter.c"
}

static void
math_converter_from_cell_data_func (MathConverter* self,
                                    GtkCellLayout* cell_layout,
                                    GtkCellRenderer* cell,
                                    GtkTreeModel* tree_model,
                                    GtkTreeIter* iter)
{
	GtkTreeIter _tmp0_;
#line 221 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 221 "../src/math-converter.vala"
	g_return_if_fail (cell_layout != NULL);
#line 221 "../src/math-converter.vala"
	g_return_if_fail (cell != NULL);
#line 221 "../src/math-converter.vala"
	g_return_if_fail (tree_model != NULL);
#line 221 "../src/math-converter.vala"
	g_return_if_fail (iter != NULL);
#line 223 "../src/math-converter.vala"
	_tmp0_ = *iter;
#line 223 "../src/math-converter.vala"
	g_object_set ((GObject*) cell, "sensitive", !gtk_tree_model_iter_has_child (tree_model, &_tmp0_), NULL);
#line 1328 "math-converter.c"
}

static void
math_converter_swap_button_clicked_cb (MathConverter* self)
{
	Unit* from_unit = NULL;
	Unit* to_unit = NULL;
	Unit* _tmp0_ = NULL;
	Unit* _tmp1_ = NULL;
	GtkComboBox* _tmp2_;
	Unit* _tmp3_;
	GtkComboBox* _tmp4_;
	Unit* _tmp5_;
	Unit* _tmp6_ = NULL;
	Unit* _tmp7_ = NULL;
#line 227 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 230 "../src/math-converter.vala"
	math_converter_get_conversion (self, &_tmp0_, &_tmp1_);
#line 230 "../src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 230 "../src/math-converter.vala"
	from_unit = _tmp0_;
#line 230 "../src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 230 "../src/math-converter.vala"
	to_unit = _tmp1_;
#line 232 "../src/math-converter.vala"
	_tmp2_ = self->priv->from_combo;
#line 232 "../src/math-converter.vala"
	_tmp3_ = to_unit;
#line 232 "../src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp2_, NULL, _tmp3_);
#line 233 "../src/math-converter.vala"
	_tmp4_ = self->priv->to_combo;
#line 233 "../src/math-converter.vala"
	_tmp5_ = from_unit;
#line 233 "../src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp4_, NULL, _tmp5_);
#line 235 "../src/math-converter.vala"
	math_converter_do_convert (self, &_tmp6_, &_tmp7_);
#line 235 "../src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 235 "../src/math-converter.vala"
	from_unit = _tmp6_;
#line 235 "../src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 235 "../src/math-converter.vala"
	to_unit = _tmp7_;
#line 237 "../src/math-converter.vala"
	math_converter_update_result_label (self);
#line 227 "../src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 227 "../src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 1384 "math-converter.c"
}

static void
_math_converter_swap_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_swap_button_clicked_cb ((MathConverter*) self);
#line 1393 "math-converter.c"
}

static void
math_converter_do_convert (MathConverter* self,
                           Unit* * from_unit,
                           Unit* * to_unit)
{
	Unit* _vala_from_unit = NULL;
	Unit* _vala_to_unit = NULL;
	Number* x = NULL;
	MathEquation* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
#line 240 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 241 "../src/math-converter.vala"
	_tmp0_ = self->priv->equation;
#line 241 "../src/math-converter.vala"
	_tmp1_ = math_equation_get_number (_tmp0_);
#line 241 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 241 "../src/math-converter.vala"
	x = _tmp2_;
#line 242 "../src/math-converter.vala"
	_tmp3_ = x;
#line 242 "../src/math-converter.vala"
	if (_tmp3_ != NULL) {
#line 1422 "math-converter.c"
		Number* z = NULL;
		Number* _tmp4_;
		Unit* _tmp5_ = NULL;
		Unit* _tmp6_ = NULL;
		Number* _tmp7_;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		Number* _tmp10_;
#line 244 "../src/math-converter.vala"
		_tmp4_ = x;
#line 244 "../src/math-converter.vala"
		_tmp7_ = math_converter_convert_equation (self, _tmp4_, &_tmp5_, &_tmp6_);
#line 244 "../src/math-converter.vala"
		_g_object_unref0 (_vala_from_unit);
#line 244 "../src/math-converter.vala"
		_vala_from_unit = _tmp5_;
#line 244 "../src/math-converter.vala"
		_g_object_unref0 (_vala_to_unit);
#line 244 "../src/math-converter.vala"
		_vala_to_unit = _tmp6_;
#line 244 "../src/math-converter.vala"
		z = _tmp7_;
#line 245 "../src/math-converter.vala"
		_tmp10_ = z;
#line 245 "../src/math-converter.vala"
		if (_tmp10_ != NULL) {
#line 1449 "math-converter.c"
			Unit* _tmp11_;
#line 245 "../src/math-converter.vala"
			_tmp11_ = _vala_from_unit;
#line 245 "../src/math-converter.vala"
			_tmp9_ = _tmp11_ != NULL;
#line 1455 "math-converter.c"
		} else {
#line 245 "../src/math-converter.vala"
			_tmp9_ = FALSE;
#line 1459 "math-converter.c"
		}
#line 245 "../src/math-converter.vala"
		if (_tmp9_) {
#line 1463 "math-converter.c"
			Unit* _tmp12_;
#line 245 "../src/math-converter.vala"
			_tmp12_ = _vala_to_unit;
#line 245 "../src/math-converter.vala"
			_tmp8_ = _tmp12_ != NULL;
#line 1469 "math-converter.c"
		} else {
#line 245 "../src/math-converter.vala"
			_tmp8_ = FALSE;
#line 1473 "math-converter.c"
		}
#line 245 "../src/math-converter.vala"
		if (_tmp8_) {
#line 1477 "math-converter.c"
			MathEquation* _tmp13_;
			MathEquation* _tmp14_;
			Serializer* _tmp15_;
			Serializer* _tmp16_;
			Number* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			Unit* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			Unit* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			MathEquation* _tmp30_;
#line 247 "../src/math-converter.vala"
			_tmp13_ = self->priv->equation;
#line 247 "../src/math-converter.vala"
			_tmp14_ = self->priv->equation;
#line 247 "../src/math-converter.vala"
			_tmp15_ = math_equation_get_serializer (_tmp14_);
#line 247 "../src/math-converter.vala"
			_tmp16_ = _tmp15_;
#line 247 "../src/math-converter.vala"
			_tmp17_ = x;
#line 247 "../src/math-converter.vala"
			_tmp18_ = serializer_to_string (_tmp16_, _tmp17_);
#line 247 "../src/math-converter.vala"
			_tmp19_ = _tmp18_;
#line 247 "../src/math-converter.vala"
			_tmp20_ = _vala_from_unit;
#line 247 "../src/math-converter.vala"
			_tmp21_ = unit_get_name (_tmp20_);
#line 247 "../src/math-converter.vala"
			_tmp22_ = _tmp21_;
#line 247 "../src/math-converter.vala"
			_tmp23_ = _tmp22_;
#line 247 "../src/math-converter.vala"
			_tmp24_ = _vala_to_unit;
#line 247 "../src/math-converter.vala"
			_tmp25_ = unit_get_name (_tmp24_);
#line 247 "../src/math-converter.vala"
			_tmp26_ = _tmp25_;
#line 247 "../src/math-converter.vala"
			_tmp27_ = _tmp26_;
#line 247 "../src/math-converter.vala"
			_tmp28_ = g_strdup_printf ("%s %s %s %s", _tmp19_, _tmp23_, _ ("in"), _tmp27_);
#line 247 "../src/math-converter.vala"
			_tmp29_ = _tmp28_;
#line 247 "../src/math-converter.vala"
			math_equation_set (_tmp13_, _tmp29_);
#line 247 "../src/math-converter.vala"
			_g_free0 (_tmp29_);
#line 247 "../src/math-converter.vala"
			_g_free0 (_tmp27_);
#line 247 "../src/math-converter.vala"
			_g_free0 (_tmp23_);
#line 247 "../src/math-converter.vala"
			_g_free0 (_tmp19_);
#line 248 "../src/math-converter.vala"
			_tmp30_ = self->priv->equation;
#line 248 "../src/math-converter.vala"
			math_equation_solve (_tmp30_);
#line 1544 "math-converter.c"
		}
#line 242 "../src/math-converter.vala"
		_g_object_unref0 (z);
#line 1548 "math-converter.c"
	}
#line 240 "../src/math-converter.vala"
	_g_object_unref0 (x);
#line 240 "../src/math-converter.vala"
	if (from_unit) {
#line 240 "../src/math-converter.vala"
		*from_unit = _vala_from_unit;
#line 1556 "math-converter.c"
	} else {
#line 240 "../src/math-converter.vala"
		_g_object_unref0 (_vala_from_unit);
#line 1560 "math-converter.c"
	}
#line 240 "../src/math-converter.vala"
	if (to_unit) {
#line 240 "../src/math-converter.vala"
		*to_unit = _vala_to_unit;
#line 1566 "math-converter.c"
	} else {
#line 240 "../src/math-converter.vala"
		_g_object_unref0 (_vala_to_unit);
#line 1570 "math-converter.c"
	}
}

static void
math_converter_convert_button_clicked_cb (MathConverter* self)
{
	Unit* from_unit = NULL;
	Unit* to_unit = NULL;
	Unit* _tmp0_ = NULL;
	Unit* _tmp1_ = NULL;
#line 254 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/math-converter.vala"
	math_converter_do_convert (self, &_tmp0_, &_tmp1_);
#line 257 "../src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 257 "../src/math-converter.vala"
	from_unit = _tmp0_;
#line 257 "../src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 257 "../src/math-converter.vala"
	to_unit = _tmp1_;
#line 259 "../src/math-converter.vala"
	math_converter_update_result_label (self);
#line 254 "../src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 254 "../src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 1599 "math-converter.c"
}

static void
_math_converter_convert_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_convert_button_clicked_cb ((MathConverter*) self);
#line 1608 "math-converter.c"
}

static Number*
math_converter_convert_equation (MathConverter* self,
                                 Number* x,
                                 Unit* * source_unit,
                                 Unit* * target_unit)
{
	Unit* _vala_source_unit = NULL;
	Unit* _vala_target_unit = NULL;
	Number* result = NULL;
	GtkTreeIter from_iter = {0};
	GtkTreeIter to_iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	GtkComboBox* _tmp3_;
	GtkTreeIter _tmp4_ = {0};
	gboolean _tmp5_;
	UnitCategory* category = NULL;
	GtkComboBox* _tmp6_;
	GtkTreeModel* _tmp7_;
	GtkTreeModel* _tmp8_;
	GtkTreeIter _tmp9_;
	UnitCategory* _tmp10_ = NULL;
	Unit* _tmp11_ = NULL;
	GtkComboBox* _tmp12_;
	GtkTreeModel* _tmp13_;
	GtkTreeModel* _tmp14_;
	GtkTreeIter _tmp15_;
	Unit* _tmp16_ = NULL;
	UnitCategory* _tmp17_;
	Unit* _tmp18_;
	Unit* _tmp19_;
	Number* _tmp20_;
#line 262 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 262 "../src/math-converter.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 267 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_combo;
#line 267 "../src/math-converter.vala"
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 267 "../src/math-converter.vala"
	from_iter = _tmp1_;
#line 267 "../src/math-converter.vala"
	if (!_tmp2_) {
#line 268 "../src/math-converter.vala"
		result = NULL;
#line 268 "../src/math-converter.vala"
		if (source_unit) {
#line 268 "../src/math-converter.vala"
			*source_unit = _vala_source_unit;
#line 1662 "math-converter.c"
		} else {
#line 268 "../src/math-converter.vala"
			_g_object_unref0 (_vala_source_unit);
#line 1666 "math-converter.c"
		}
#line 268 "../src/math-converter.vala"
		if (target_unit) {
#line 268 "../src/math-converter.vala"
			*target_unit = _vala_target_unit;
#line 1672 "math-converter.c"
		} else {
#line 268 "../src/math-converter.vala"
			_g_object_unref0 (_vala_target_unit);
#line 1676 "math-converter.c"
		}
#line 268 "../src/math-converter.vala"
		return result;
#line 1680 "math-converter.c"
	}
#line 269 "../src/math-converter.vala"
	_tmp3_ = self->priv->to_combo;
#line 269 "../src/math-converter.vala"
	_tmp5_ = gtk_combo_box_get_active_iter (_tmp3_, &_tmp4_);
#line 269 "../src/math-converter.vala"
	to_iter = _tmp4_;
#line 269 "../src/math-converter.vala"
	if (!_tmp5_) {
#line 270 "../src/math-converter.vala"
		result = NULL;
#line 270 "../src/math-converter.vala"
		if (source_unit) {
#line 270 "../src/math-converter.vala"
			*source_unit = _vala_source_unit;
#line 1696 "math-converter.c"
		} else {
#line 270 "../src/math-converter.vala"
			_g_object_unref0 (_vala_source_unit);
#line 1700 "math-converter.c"
		}
#line 270 "../src/math-converter.vala"
		if (target_unit) {
#line 270 "../src/math-converter.vala"
			*target_unit = _vala_target_unit;
#line 1706 "math-converter.c"
		} else {
#line 270 "../src/math-converter.vala"
			_g_object_unref0 (_vala_target_unit);
#line 1710 "math-converter.c"
		}
#line 270 "../src/math-converter.vala"
		return result;
#line 1714 "math-converter.c"
	}
#line 272 "../src/math-converter.vala"
	_tmp6_ = self->priv->from_combo;
#line 272 "../src/math-converter.vala"
	_tmp7_ = gtk_combo_box_get_model (_tmp6_);
#line 272 "../src/math-converter.vala"
	_tmp8_ = _tmp7_;
#line 272 "../src/math-converter.vala"
	_tmp9_ = from_iter;
#line 272 "../src/math-converter.vala"
	gtk_tree_model_get (_tmp8_, &_tmp9_, 1, &_tmp10_, 2, &_tmp11_, -1, -1);
#line 272 "../src/math-converter.vala"
	_g_object_unref0 (category);
#line 272 "../src/math-converter.vala"
	category = _tmp10_;
#line 272 "../src/math-converter.vala"
	_g_object_unref0 (_vala_source_unit);
#line 272 "../src/math-converter.vala"
	_vala_source_unit = _tmp11_;
#line 273 "../src/math-converter.vala"
	_tmp12_ = self->priv->to_combo;
#line 273 "../src/math-converter.vala"
	_tmp13_ = gtk_combo_box_get_model (_tmp12_);
#line 273 "../src/math-converter.vala"
	_tmp14_ = _tmp13_;
#line 273 "../src/math-converter.vala"
	_tmp15_ = to_iter;
#line 273 "../src/math-converter.vala"
	gtk_tree_model_get (_tmp14_, &_tmp15_, 2, &_tmp16_, -1, -1);
#line 273 "../src/math-converter.vala"
	_g_object_unref0 (_vala_target_unit);
#line 273 "../src/math-converter.vala"
	_vala_target_unit = _tmp16_;
#line 275 "../src/math-converter.vala"
	_tmp17_ = category;
#line 275 "../src/math-converter.vala"
	_tmp18_ = _vala_source_unit;
#line 275 "../src/math-converter.vala"
	_tmp19_ = _vala_target_unit;
#line 275 "../src/math-converter.vala"
	_tmp20_ = unit_category_convert (_tmp17_, x, _tmp18_, _tmp19_);
#line 275 "../src/math-converter.vala"
	result = _tmp20_;
#line 275 "../src/math-converter.vala"
	_g_object_unref0 (category);
#line 275 "../src/math-converter.vala"
	if (source_unit) {
#line 275 "../src/math-converter.vala"
		*source_unit = _vala_source_unit;
#line 1764 "math-converter.c"
	} else {
#line 275 "../src/math-converter.vala"
		_g_object_unref0 (_vala_source_unit);
#line 1768 "math-converter.c"
	}
#line 275 "../src/math-converter.vala"
	if (target_unit) {
#line 275 "../src/math-converter.vala"
		*target_unit = _vala_target_unit;
#line 1774 "math-converter.c"
	} else {
#line 275 "../src/math-converter.vala"
		_g_object_unref0 (_vala_target_unit);
#line 1778 "math-converter.c"
	}
#line 275 "../src/math-converter.vala"
	return result;
#line 1782 "math-converter.c"
}

static void
_math_converter_from_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                               GtkCellRenderer* cell,
                                                               GtkTreeModel* tree_model,
                                                               GtkTreeIter* iter,
                                                               gpointer self)
{
#line 34 "../src/math-converter.vala"
	math_converter_from_cell_data_func ((MathConverter*) self, cell_layout, cell, tree_model, iter);
#line 1794 "math-converter.c"
}

static void
_math_converter___lambda12_ (MathConverter* self)
{
#line 35 "../src/math-converter.vala"
	math_converter_update_result_label (self);
#line 1802 "math-converter.c"
}

static void
__math_converter___lambda12__currency_manager_updated (CurrencyManager* _sender,
                                                       gpointer self)
{
#line 35 "../src/math-converter.vala"
	_math_converter___lambda12_ ((MathConverter*) self);
#line 1811 "math-converter.c"
}

static GObject *
math_converter_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MathConverter * self;
	GtkComboBox* _tmp0_;
	GtkCellRendererText* _tmp1_;
	CurrencyManager* _tmp2_;
	CurrencyManager* _tmp3_;
#line 32 "../src/math-converter.vala"
	parent_class = G_OBJECT_CLASS (math_converter_parent_class);
#line 32 "../src/math-converter.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 32 "../src/math-converter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MATH_CONVERTER, MathConverter);
#line 34 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_combo;
#line 34 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_renderer;
#line 34 "../src/math-converter.vala"
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp0_, (GtkCellRenderer*) _tmp1_, _math_converter_from_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 35 "../src/math-converter.vala"
	_tmp2_ = currency_manager_get_default ();
#line 35 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 35 "../src/math-converter.vala"
	g_signal_connect_object (_tmp3_, "updated", (GCallback) __math_converter___lambda12__currency_manager_updated, self, 0);
#line 35 "../src/math-converter.vala"
	_g_object_unref0 (_tmp3_);
#line 37 "../src/math-converter.vala"
	math_converter_update_from_model (self);
#line 32 "../src/math-converter.vala"
	return obj;
#line 1850 "math-converter.c"
}

static void
math_converter_class_init (MathConverterClass * klass,
                           gpointer klass_data)
{
#line 12 "../src/math-converter.vala"
	math_converter_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/math-converter.vala"
	g_type_class_adjust_private_offset (klass, &MathConverter_private_offset);
#line 12 "../src/math-converter.vala"
	G_OBJECT_CLASS (klass)->constructor = math_converter_constructor;
#line 12 "../src/math-converter.vala"
	G_OBJECT_CLASS (klass)->finalize = math_converter_finalize;
#line 12 "../src/math-converter.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/calculator/math-converter.ui");
#line 12 "../src/math-converter.vala"
	math_converter_signals[MATH_CONVERTER_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_MATH_CONVERTER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_renderer", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_renderer));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_combo));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_combo));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_label", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_label));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_label", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_label));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "from_combobox_changed_cb", G_CALLBACK(_math_converter_from_combobox_changed_cb_gtk_combo_box_changed));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "to_combobox_changed_cb", G_CALLBACK(_math_converter_to_combobox_changed_cb_gtk_combo_box_changed));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "swap_button_clicked_cb", G_CALLBACK(_math_converter_swap_button_clicked_cb_gtk_button_clicked));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "convert_button_clicked_cb", G_CALLBACK(_math_converter_convert_button_clicked_cb_gtk_button_clicked));
#line 1887 "math-converter.c"
}

static void
math_converter_instance_init (MathConverter * self,
                              gpointer klass)
{
#line 12 "../src/math-converter.vala"
	self->priv = math_converter_get_instance_private (self);
#line 14 "../src/math-converter.vala"
	self->priv->equation = NULL;
#line 12 "../src/math-converter.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1900 "math-converter.c"
}

static void
math_converter_finalize (GObject * obj)
{
	MathConverter * self;
#line 12 "../src/math-converter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MATH_CONVERTER, MathConverter);
#line 14 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->equation);
#line 16 "../src/math-converter.vala"
	_g_free0 (self->priv->category);
#line 19 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_renderer);
#line 22 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_combo);
#line 24 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_combo);
#line 26 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_label);
#line 28 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_label);
#line 12 "../src/math-converter.vala"
	G_OBJECT_CLASS (math_converter_parent_class)->finalize (obj);
#line 1925 "math-converter.c"
}

GType
math_converter_get_type (void)
{
	static volatile gsize math_converter_type_id__volatile = 0;
	if (g_once_init_enter (&math_converter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MathConverterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) math_converter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MathConverter), 0, (GInstanceInitFunc) math_converter_instance_init, NULL };
		GType math_converter_type_id;
		math_converter_type_id = g_type_register_static (gtk_grid_get_type (), "MathConverter", &g_define_type_info, 0);
		MathConverter_private_offset = g_type_add_instance_private (math_converter_type_id, sizeof (MathConverterPrivate));
		g_once_init_leave (&math_converter_type_id__volatile, math_converter_type_id);
	}
	return math_converter_type_id__volatile;
}

