/* math-window.c generated by valac 0.44.5, the Vala compiler
 * generated from math-window.vala, do not modify */

/*
 * Copyright (C) 1987-2008 Sun Microsystems, Inc. All Rights Reserved.
 * Copyright (C) 2008-2012 Robert Ancell.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "calculator.h"
#include <glib.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gtksourceview/gtksource.h>

#define TYPE_MATH_WINDOW (math_window_get_type ())
#define MATH_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MATH_WINDOW, MathWindow))
#define MATH_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MATH_WINDOW, MathWindowClass))
#define IS_MATH_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MATH_WINDOW))
#define IS_MATH_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MATH_WINDOW))
#define MATH_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MATH_WINDOW, MathWindowClass))

typedef struct _MathWindow MathWindow;
typedef struct _MathWindowClass MathWindowClass;
typedef struct _MathWindowPrivate MathWindowPrivate;

#define TYPE_MATH_DISPLAY (math_display_get_type ())
#define MATH_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MATH_DISPLAY, MathDisplay))
#define MATH_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MATH_DISPLAY, MathDisplayClass))
#define IS_MATH_DISPLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MATH_DISPLAY))
#define IS_MATH_DISPLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MATH_DISPLAY))
#define MATH_DISPLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MATH_DISPLAY, MathDisplayClass))

typedef struct _MathDisplay MathDisplay;
typedef struct _MathDisplayClass MathDisplayClass;

#define TYPE_MATH_BUTTONS (math_buttons_get_type ())
#define MATH_BUTTONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MATH_BUTTONS, MathButtons))
#define MATH_BUTTONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MATH_BUTTONS, MathButtonsClass))
#define IS_MATH_BUTTONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MATH_BUTTONS))
#define IS_MATH_BUTTONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MATH_BUTTONS))
#define MATH_BUTTONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MATH_BUTTONS, MathButtonsClass))

typedef struct _MathButtons MathButtons;
typedef struct _MathButtonsClass MathButtonsClass;

#define TYPE_MATH_CONVERTER (math_converter_get_type ())
#define MATH_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MATH_CONVERTER, MathConverter))
#define MATH_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MATH_CONVERTER, MathConverterClass))
#define IS_MATH_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MATH_CONVERTER))
#define IS_MATH_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MATH_CONVERTER))
#define MATH_CONVERTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MATH_CONVERTER, MathConverterClass))

typedef struct _MathConverter MathConverter;
typedef struct _MathConverterClass MathConverterClass;
enum  {
	MATH_WINDOW_0_PROPERTY,
	MATH_WINDOW_EQUATION_PROPERTY,
	MATH_WINDOW_DISPLAY_PROPERTY,
	MATH_WINDOW_BUTTONS_PROPERTY,
	MATH_WINDOW_NUM_PROPERTIES
};
static GParamSpec* math_window_properties[MATH_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	BUTTON_MODE_BASIC,
	BUTTON_MODE_ADVANCED,
	BUTTON_MODE_FINANCIAL,
	BUTTON_MODE_PROGRAMMING,
	BUTTON_MODE_KEYBOARD
} ButtonMode;

#define TYPE_BUTTON_MODE (button_mode_get_type ())
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MathWindow {
	GtkApplicationWindow parent_instance;
	MathWindowPrivate * priv;
	GtkMenuButton* primary_menu_button;
};

struct _MathWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _MathWindowPrivate {
	MathEquation* _equation;
	MathDisplay* _display;
	MathButtons* _buttons;
	gboolean right_aligned;
	gboolean remove_buttons;
	GtkMenuButton* menu_button;
	GtkLabel* mode_label;
	GtkGrid* grid;
	MathConverter* converter;
};

static gint MathWindow_private_offset;
static gpointer math_window_parent_class = NULL;

GType math_window_get_type (void) G_GNUC_CONST;
GType math_display_get_type (void) G_GNUC_CONST;
GType math_buttons_get_type (void) G_GNUC_CONST;
GType math_converter_get_type (void) G_GNUC_CONST;
static void math_window_copy_cb (MathWindow* self);
static void _math_window_copy_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
static void math_window_paste_cb (MathWindow* self);
static void _math_window_paste_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self);
static void math_window_undo_cb (MathWindow* self);
static void _math_window_undo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
static void math_window_redo_cb (MathWindow* self);
static void _math_window_redo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
static void math_window_mode_cb (MathWindow* self,
                          GSimpleAction* action,
                          GVariant* parameter);
static void _math_window_mode_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
static void math_window_clear_cb (MathWindow* self);
static void _math_window_clear_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self);
static void _gtk_window_close_gsimple_action_activate_callback (GSimpleAction* action,
                                                         GVariant* parameter,
                                                         gpointer self);
MathWindow* math_window_new (GtkApplication* app,
                             MathEquation* equation);
MathWindow* math_window_construct (GType object_type,
                                   GtkApplication* app,
                                   MathEquation* equation);
void math_converter_set_equation (MathConverter* self,
                                  MathEquation* equation);
void math_converter_set_category (MathConverter* self,
                                  const gchar* category);
void math_converter_set_conversion (MathConverter* self,
                                    const gchar* unit_a,
                                    const gchar* unit_b);
MathDisplay* math_display_new (MathEquation* equation);
MathDisplay* math_display_construct (GType object_type,
                                     MathEquation* equation);
void math_display_grabfocus (MathDisplay* self);
MathButtons* math_buttons_new (MathEquation* equation);
MathButtons* math_buttons_construct (GType object_type,
                                     MathEquation* equation);
GType button_mode_get_type (void) G_GNUC_CONST;
ButtonMode math_buttons_get_mode (MathButtons* self);
static void math_window_mode_changed_cb (MathWindow* self);
static void _math_window_mode_changed_cb_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self);
void math_display_clear_history (MathDisplay* self);
MathButtons* math_window_get_buttons (MathWindow* self);
void math_window_critical_error (MathWindow* self,
                                 const gchar* title,
                                 const gchar* contents);
static gboolean math_window_real_key_press_event (GtkWidget* base,
                                           GdkEventKey* event);
MathEquation* math_window_get_equation (MathWindow* self);
static void math_window_scroll_changed_cb (MathWindow* self,
                                    GtkAdjustment* adjustment);
static void _math_window_scroll_changed_cb_gtk_adjustment_changed (GtkAdjustment* _sender,
                                                            gpointer self);
static void math_window_scroll_value_changed_cb (MathWindow* self,
                                          GtkAdjustment* adjustment);
static void _math_window_scroll_value_changed_cb_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                        gpointer self);
MathDisplay* math_window_get_display (MathWindow* self);
void math_display_grab_focus (MathDisplay* self);
void math_buttons_set_mode (MathButtons* self,
                            ButtonMode value);
static void math_window_finalize (GObject * obj);
static void _vala_math_window_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);

static const GActionEntry MATH_WINDOW_window_entries[7] = {{"copy", _math_window_copy_cb_gsimple_action_activate_callback, NULL, NULL, NULL}, {"paste", _math_window_paste_cb_gsimple_action_activate_callback, NULL, NULL, NULL}, {"undo", _math_window_undo_cb_gsimple_action_activate_callback, NULL, NULL, NULL}, {"redo", _math_window_redo_cb_gsimple_action_activate_callback, NULL, NULL, NULL}, {"mode", _math_window_mode_cb_gsimple_action_activate_callback, "s", "\"basic\"", NULL}, {"clear", _math_window_clear_cb_gsimple_action_activate_callback, NULL, NULL, NULL}, {"close", _gtk_window_close_gsimple_action_activate_callback, NULL, NULL, NULL}};

static inline gpointer
math_window_get_instance_private (MathWindow* self)
{
	return G_STRUCT_MEMBER_P (self, MathWindow_private_offset);
}

static void
_math_window_copy_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 38 "../src/math-window.vala"
	math_window_copy_cb ((MathWindow*) self);
#line 216 "math-window.c"
}

static void
_math_window_paste_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                        GVariant* parameter,
                                                        gpointer self)
{
#line 38 "../src/math-window.vala"
	math_window_paste_cb ((MathWindow*) self);
#line 226 "math-window.c"
}

static void
_math_window_undo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 38 "../src/math-window.vala"
	math_window_undo_cb ((MathWindow*) self);
#line 236 "math-window.c"
}

static void
_math_window_redo_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 38 "../src/math-window.vala"
	math_window_redo_cb ((MathWindow*) self);
#line 246 "math-window.c"
}

static void
_math_window_mode_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 38 "../src/math-window.vala"
	math_window_mode_cb ((MathWindow*) self, action, parameter);
#line 256 "math-window.c"
}

static void
_math_window_clear_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                        GVariant* parameter,
                                                        gpointer self)
{
#line 38 "../src/math-window.vala"
	math_window_clear_cb ((MathWindow*) self);
#line 266 "math-window.c"
}

static void
_gtk_window_close_gsimple_action_activate_callback (GSimpleAction* action,
                                                    GVariant* parameter,
                                                    gpointer self)
{
#line 38 "../src/math-window.vala"
	gtk_window_close ((GtkWindow*) self);
#line 276 "math-window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 52 "../src/math-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 284 "math-window.c"
}

static void
_math_window_mode_changed_cb_g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self)
{
#line 71 "../src/math-window.vala"
	math_window_mode_changed_cb ((MathWindow*) self);
#line 294 "math-window.c"
}

MathWindow*
math_window_construct (GType object_type,
                       GtkApplication* app,
                       MathEquation* equation)
{
	MathWindow * self = NULL;
	MathEquation* _tmp0_;
	MathConverter* _tmp1_;
	MathEquation* _tmp2_;
	MathConverter* _tmp3_;
	MathConverter* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	MathDisplay* _tmp11_;
	GtkGrid* _tmp12_;
	MathDisplay* _tmp13_;
	MathDisplay* _tmp14_;
	MathDisplay* _tmp15_;
	MathButtons* _tmp16_;
	GtkGrid* _tmp17_;
	MathButtons* _tmp18_;
	gboolean _tmp19_ = FALSE;
	MathButtons* _tmp20_;
	ButtonMode _tmp21_;
	ButtonMode _tmp22_;
	MathButtons* _tmp23_;
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp24_;
	GdkScreen* _tmp25_;
#line 49 "../src/math-window.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 49 "../src/math-window.vala"
	g_return_val_if_fail (equation != NULL, NULL);
#line 51 "../src/math-window.vala"
	self = (MathWindow*) g_object_new (object_type, "application", app, NULL);
#line 52 "../src/math-window.vala"
	_tmp0_ = _g_object_ref0 (equation);
#line 52 "../src/math-window.vala"
	_g_object_unref0 (self->priv->_equation);
#line 52 "../src/math-window.vala"
	self->priv->_equation = _tmp0_;
#line 53 "../src/math-window.vala"
	self->priv->right_aligned = TRUE;
#line 55 "../src/math-window.vala"
	g_action_map_add_action_entries ((GActionMap*) self, MATH_WINDOW_window_entries, (gint) G_N_ELEMENTS (MATH_WINDOW_window_entries), self);
#line 57 "../src/math-window.vala"
	_tmp1_ = self->priv->converter;
#line 57 "../src/math-window.vala"
	_tmp2_ = self->priv->_equation;
#line 57 "../src/math-window.vala"
	math_converter_set_equation (_tmp1_, _tmp2_);
#line 58 "../src/math-window.vala"
	_tmp3_ = self->priv->converter;
#line 58 "../src/math-window.vala"
	math_converter_set_category (_tmp3_, NULL);
#line 59 "../src/math-window.vala"
	_tmp4_ = self->priv->converter;
#line 59 "../src/math-window.vala"
	_tmp5_ = math_equation_get_source_units (equation);
#line 59 "../src/math-window.vala"
	_tmp6_ = _tmp5_;
#line 59 "../src/math-window.vala"
	_tmp7_ = _tmp6_;
#line 59 "../src/math-window.vala"
	_tmp8_ = math_equation_get_target_units (equation);
#line 59 "../src/math-window.vala"
	_tmp9_ = _tmp8_;
#line 59 "../src/math-window.vala"
	_tmp10_ = _tmp9_;
#line 59 "../src/math-window.vala"
	math_converter_set_conversion (_tmp4_, _tmp7_, _tmp10_);
#line 59 "../src/math-window.vala"
	_g_free0 (_tmp10_);
#line 59 "../src/math-window.vala"
	_g_free0 (_tmp7_);
#line 61 "../src/math-window.vala"
	_tmp11_ = math_display_new (equation);
#line 61 "../src/math-window.vala"
	g_object_ref_sink (_tmp11_);
#line 61 "../src/math-window.vala"
	_g_object_unref0 (self->priv->_display);
#line 61 "../src/math-window.vala"
	self->priv->_display = _tmp11_;
#line 62 "../src/math-window.vala"
	_tmp12_ = self->priv->grid;
#line 62 "../src/math-window.vala"
	_tmp13_ = self->priv->_display;
#line 62 "../src/math-window.vala"
	gtk_grid_attach (_tmp12_, (GtkWidget*) _tmp13_, 0, 1, 1, 1);
#line 63 "../src/math-window.vala"
	_tmp14_ = self->priv->_display;
#line 63 "../src/math-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp14_);
#line 64 "../src/math-window.vala"
	_tmp15_ = self->priv->_display;
#line 64 "../src/math-window.vala"
	math_display_grabfocus (_tmp15_);
#line 66 "../src/math-window.vala"
	_tmp16_ = math_buttons_new (equation);
#line 66 "../src/math-window.vala"
	g_object_ref_sink (_tmp16_);
#line 66 "../src/math-window.vala"
	_g_object_unref0 (self->priv->_buttons);
#line 66 "../src/math-window.vala"
	self->priv->_buttons = _tmp16_;
#line 67 "../src/math-window.vala"
	_tmp17_ = self->priv->grid;
#line 67 "../src/math-window.vala"
	_tmp18_ = self->priv->_buttons;
#line 67 "../src/math-window.vala"
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
#line 69 "../src/math-window.vala"
	_tmp20_ = self->priv->_buttons;
#line 69 "../src/math-window.vala"
	_tmp21_ = math_buttons_get_mode (_tmp20_);
#line 69 "../src/math-window.vala"
	_tmp22_ = _tmp21_;
#line 69 "../src/math-window.vala"
	if (_tmp22_ != BUTTON_MODE_KEYBOARD) {
#line 69 "../src/math-window.vala"
		_tmp19_ = TRUE;
#line 422 "math-window.c"
	} else {
#line 69 "../src/math-window.vala"
		_tmp19_ = FALSE;
#line 426 "math-window.c"
	}
#line 69 "../src/math-window.vala"
	self->priv->remove_buttons = _tmp19_;
#line 71 "../src/math-window.vala"
	_tmp23_ = self->priv->_buttons;
#line 71 "../src/math-window.vala"
	g_signal_connect_object ((GObject*) _tmp23_, "notify::mode", (GCallback) _math_window_mode_changed_cb_g_object_notify, self, 0);
#line 72 "../src/math-window.vala"
	math_window_mode_changed_cb (self);
#line 74 "../src/math-window.vala"
	_tmp24_ = gtk_css_provider_new ();
#line 74 "../src/math-window.vala"
	provider = _tmp24_;
#line 75 "../src/math-window.vala"
	gtk_css_provider_load_from_resource (provider, "/org/gnome/calculator/calculator.css");
#line 76 "../src/math-window.vala"
	_tmp25_ = gtk_window_get_screen ((GtkWindow*) self);
#line 76 "../src/math-window.vala"
	gtk_style_context_add_provider_for_screen (_tmp25_, (GtkStyleProvider*) provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 49 "../src/math-window.vala"
	_g_object_unref0 (provider);
#line 49 "../src/math-window.vala"
	return self;
#line 450 "math-window.c"
}

MathWindow*
math_window_new (GtkApplication* app,
                 MathEquation* equation)
{
#line 49 "../src/math-window.vala"
	return math_window_construct (TYPE_MATH_WINDOW, app, equation);
#line 459 "math-window.c"
}

static void
math_window_clear_cb (MathWindow* self)
{
	MathDisplay* _tmp0_;
#line 79 "../src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/math-window.vala"
	_tmp0_ = self->priv->_display;
#line 81 "../src/math-window.vala"
	math_display_clear_history (_tmp0_);
#line 472 "math-window.c"
}

static void
math_window_mode_changed_cb (MathWindow* self)
{
	GSimpleAction* action = NULL;
	GAction* _tmp0_;
	GSimpleAction* _tmp1_;
	MathButtons* _tmp2_;
	MathButtons* _tmp3_;
	ButtonMode _tmp4_;
	ButtonMode _tmp5_;
	gboolean _tmp26_ = FALSE;
#line 84 "../src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/math-window.vala"
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) self, "mode");
#line 86 "../src/math-window.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction));
#line 86 "../src/math-window.vala"
	action = _tmp1_;
#line 88 "../src/math-window.vala"
	_tmp2_ = math_window_get_buttons (self);
#line 88 "../src/math-window.vala"
	_tmp3_ = _tmp2_;
#line 88 "../src/math-window.vala"
	_tmp4_ = math_buttons_get_mode (_tmp3_);
#line 88 "../src/math-window.vala"
	_tmp5_ = _tmp4_;
#line 88 "../src/math-window.vala"
	switch (_tmp5_) {
#line 504 "math-window.c"
		default:
#line 88 "../src/math-window.vala"
		case BUTTON_MODE_BASIC:
#line 508 "math-window.c"
		{
			GtkLabel* _tmp6_;
			GSimpleAction* _tmp7_;
			GVariant* _tmp8_;
			GVariant* _tmp9_;
#line 92 "../src/math-window.vala"
			_tmp6_ = self->priv->mode_label;
#line 92 "../src/math-window.vala"
			gtk_label_set_label (_tmp6_, _ ("Basic Mode"));
#line 93 "../src/math-window.vala"
			_tmp7_ = action;
#line 93 "../src/math-window.vala"
			_tmp8_ = g_variant_new_string ("basic");
#line 93 "../src/math-window.vala"
			g_variant_ref_sink (_tmp8_);
#line 93 "../src/math-window.vala"
			_tmp9_ = _tmp8_;
#line 93 "../src/math-window.vala"
			g_simple_action_set_state (_tmp7_, _tmp9_);
#line 93 "../src/math-window.vala"
			_g_variant_unref0 (_tmp9_);
#line 94 "../src/math-window.vala"
			break;
#line 532 "math-window.c"
		}
#line 88 "../src/math-window.vala"
		case BUTTON_MODE_ADVANCED:
#line 536 "math-window.c"
		{
			GtkLabel* _tmp10_;
			GSimpleAction* _tmp11_;
			GVariant* _tmp12_;
			GVariant* _tmp13_;
#line 97 "../src/math-window.vala"
			_tmp10_ = self->priv->mode_label;
#line 97 "../src/math-window.vala"
			gtk_label_set_label (_tmp10_, _ ("Advanced Mode"));
#line 98 "../src/math-window.vala"
			_tmp11_ = action;
#line 98 "../src/math-window.vala"
			_tmp12_ = g_variant_new_string ("advanced");
#line 98 "../src/math-window.vala"
			g_variant_ref_sink (_tmp12_);
#line 98 "../src/math-window.vala"
			_tmp13_ = _tmp12_;
#line 98 "../src/math-window.vala"
			g_simple_action_set_state (_tmp11_, _tmp13_);
#line 98 "../src/math-window.vala"
			_g_variant_unref0 (_tmp13_);
#line 99 "../src/math-window.vala"
			break;
#line 560 "math-window.c"
		}
#line 88 "../src/math-window.vala"
		case BUTTON_MODE_FINANCIAL:
#line 564 "math-window.c"
		{
			GtkLabel* _tmp14_;
			GSimpleAction* _tmp15_;
			GVariant* _tmp16_;
			GVariant* _tmp17_;
#line 102 "../src/math-window.vala"
			_tmp14_ = self->priv->mode_label;
#line 102 "../src/math-window.vala"
			gtk_label_set_label (_tmp14_, _ ("Financial Mode"));
#line 103 "../src/math-window.vala"
			_tmp15_ = action;
#line 103 "../src/math-window.vala"
			_tmp16_ = g_variant_new_string ("financial");
#line 103 "../src/math-window.vala"
			g_variant_ref_sink (_tmp16_);
#line 103 "../src/math-window.vala"
			_tmp17_ = _tmp16_;
#line 103 "../src/math-window.vala"
			g_simple_action_set_state (_tmp15_, _tmp17_);
#line 103 "../src/math-window.vala"
			_g_variant_unref0 (_tmp17_);
#line 104 "../src/math-window.vala"
			break;
#line 588 "math-window.c"
		}
#line 88 "../src/math-window.vala"
		case BUTTON_MODE_PROGRAMMING:
#line 592 "math-window.c"
		{
			GtkLabel* _tmp18_;
			GSimpleAction* _tmp19_;
			GVariant* _tmp20_;
			GVariant* _tmp21_;
#line 107 "../src/math-window.vala"
			_tmp18_ = self->priv->mode_label;
#line 107 "../src/math-window.vala"
			gtk_label_set_label (_tmp18_, _ ("Programming Mode"));
#line 108 "../src/math-window.vala"
			_tmp19_ = action;
#line 108 "../src/math-window.vala"
			_tmp20_ = g_variant_new_string ("programming");
#line 108 "../src/math-window.vala"
			g_variant_ref_sink (_tmp20_);
#line 108 "../src/math-window.vala"
			_tmp21_ = _tmp20_;
#line 108 "../src/math-window.vala"
			g_simple_action_set_state (_tmp19_, _tmp21_);
#line 108 "../src/math-window.vala"
			_g_variant_unref0 (_tmp21_);
#line 109 "../src/math-window.vala"
			break;
#line 616 "math-window.c"
		}
#line 88 "../src/math-window.vala"
		case BUTTON_MODE_KEYBOARD:
#line 620 "math-window.c"
		{
			GtkLabel* _tmp22_;
			GSimpleAction* _tmp23_;
			GVariant* _tmp24_;
			GVariant* _tmp25_;
#line 112 "../src/math-window.vala"
			_tmp22_ = self->priv->mode_label;
#line 112 "../src/math-window.vala"
			gtk_label_set_label (_tmp22_, _ ("Keyboard Mode"));
#line 113 "../src/math-window.vala"
			_tmp23_ = action;
#line 113 "../src/math-window.vala"
			_tmp24_ = g_variant_new_string ("keyboard");
#line 113 "../src/math-window.vala"
			g_variant_ref_sink (_tmp24_);
#line 113 "../src/math-window.vala"
			_tmp25_ = _tmp24_;
#line 113 "../src/math-window.vala"
			g_simple_action_set_state (_tmp23_, _tmp25_);
#line 113 "../src/math-window.vala"
			_g_variant_unref0 (_tmp25_);
#line 114 "../src/math-window.vala"
			break;
#line 644 "math-window.c"
		}
	}
#line 117 "../src/math-window.vala"
	if (self->priv->remove_buttons == TRUE) {
#line 649 "math-window.c"
		MathButtons* _tmp27_;
		ButtonMode _tmp28_;
		ButtonMode _tmp29_;
#line 117 "../src/math-window.vala"
		_tmp27_ = self->priv->_buttons;
#line 117 "../src/math-window.vala"
		_tmp28_ = math_buttons_get_mode (_tmp27_);
#line 117 "../src/math-window.vala"
		_tmp29_ = _tmp28_;
#line 117 "../src/math-window.vala"
		_tmp26_ = _tmp29_ != BUTTON_MODE_KEYBOARD;
#line 661 "math-window.c"
	} else {
#line 117 "../src/math-window.vala"
		_tmp26_ = FALSE;
#line 665 "math-window.c"
	}
#line 117 "../src/math-window.vala"
	if (_tmp26_) {
#line 669 "math-window.c"
		MathButtons* _tmp30_;
		MathConverter* _tmp31_;
#line 119 "../src/math-window.vala"
		_tmp30_ = self->priv->_buttons;
#line 119 "../src/math-window.vala"
		gtk_widget_show ((GtkWidget*) _tmp30_);
#line 120 "../src/math-window.vala"
		self->priv->remove_buttons = FALSE;
#line 121 "../src/math-window.vala"
		_tmp31_ = self->priv->converter;
#line 121 "../src/math-window.vala"
		gtk_widget_hide ((GtkWidget*) _tmp31_);
#line 682 "math-window.c"
	} else {
		gboolean _tmp32_ = FALSE;
#line 123 "../src/math-window.vala"
		if (self->priv->remove_buttons == FALSE) {
#line 687 "math-window.c"
			MathButtons* _tmp33_;
			ButtonMode _tmp34_;
			ButtonMode _tmp35_;
#line 123 "../src/math-window.vala"
			_tmp33_ = self->priv->_buttons;
#line 123 "../src/math-window.vala"
			_tmp34_ = math_buttons_get_mode (_tmp33_);
#line 123 "../src/math-window.vala"
			_tmp35_ = _tmp34_;
#line 123 "../src/math-window.vala"
			_tmp32_ = _tmp35_ == BUTTON_MODE_KEYBOARD;
#line 699 "math-window.c"
		} else {
#line 123 "../src/math-window.vala"
			_tmp32_ = FALSE;
#line 703 "math-window.c"
		}
#line 123 "../src/math-window.vala"
		if (_tmp32_) {
#line 707 "math-window.c"
			MathButtons* _tmp36_;
			MathConverter* _tmp37_;
#line 125 "../src/math-window.vala"
			_tmp36_ = self->priv->_buttons;
#line 125 "../src/math-window.vala"
			gtk_widget_hide ((GtkWidget*) _tmp36_);
#line 126 "../src/math-window.vala"
			self->priv->remove_buttons = TRUE;
#line 127 "../src/math-window.vala"
			_tmp37_ = self->priv->converter;
#line 127 "../src/math-window.vala"
			gtk_widget_show ((GtkWidget*) _tmp37_);
#line 720 "math-window.c"
		}
	}
#line 84 "../src/math-window.vala"
	_g_object_unref0 (action);
#line 725 "math-window.c"
}

void
math_window_critical_error (MathWindow* self,
                            const gchar* title,
                            const gchar* contents)
{
	GtkMessageDialog* dialog = NULL;
	GtkMessageDialog* _tmp0_;
#line 131 "../src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 131 "../src/math-window.vala"
	g_return_if_fail (title != NULL);
#line 131 "../src/math-window.vala"
	g_return_if_fail (contents != NULL);
#line 133 "../src/math-window.vala"
	_tmp0_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, 0, GTK_MESSAGE_ERROR, GTK_BUTTONS_NONE, "%s", title);
#line 133 "../src/math-window.vala"
	g_object_ref_sink (_tmp0_);
#line 133 "../src/math-window.vala"
	dialog = _tmp0_;
#line 137 "../src/math-window.vala"
	gtk_message_dialog_format_secondary_text (dialog, "%s", contents);
#line 138 "../src/math-window.vala"
	gtk_dialog_add_buttons ((GtkDialog*) dialog, _ ("_Quit"), GTK_RESPONSE_ACCEPT, NULL);
#line 140 "../src/math-window.vala"
	gtk_dialog_run ((GtkDialog*) dialog);
#line 142 "../src/math-window.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 131 "../src/math-window.vala"
	_g_object_unref0 (dialog);
#line 757 "math-window.c"
}

static gboolean
math_window_real_key_press_event (GtkWidget* base,
                                  GdkEventKey* event)
{
	MathWindow * self;
	gboolean result = FALSE;
	gboolean _result_ = FALSE;
	gboolean _tmp0_ = FALSE;
	MathButtons* _tmp1_;
	MathButtons* _tmp2_;
	ButtonMode _tmp3_;
	ButtonMode _tmp4_;
#line 145 "../src/math-window.vala"
	self = (MathWindow*) base;
#line 145 "../src/math-window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 147 "../src/math-window.vala"
	_result_ = GTK_WIDGET_CLASS (math_window_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow), event);
#line 149 "../src/math-window.vala"
	_tmp1_ = math_window_get_buttons (self);
#line 149 "../src/math-window.vala"
	_tmp2_ = _tmp1_;
#line 149 "../src/math-window.vala"
	_tmp3_ = math_buttons_get_mode (_tmp2_);
#line 149 "../src/math-window.vala"
	_tmp4_ = _tmp3_;
#line 149 "../src/math-window.vala"
	if (_tmp4_ == BUTTON_MODE_PROGRAMMING) {
#line 788 "math-window.c"
		GdkModifierType _tmp5_;
#line 149 "../src/math-window.vala"
		_tmp5_ = event->state;
#line 149 "../src/math-window.vala"
		_tmp0_ = (_tmp5_ & GDK_CONTROL_MASK) == GDK_CONTROL_MASK;
#line 794 "math-window.c"
	} else {
#line 149 "../src/math-window.vala"
		_tmp0_ = FALSE;
#line 798 "math-window.c"
	}
#line 149 "../src/math-window.vala"
	if (_tmp0_) {
#line 151 "../src/math-window.vala"
		switch (event->keyval) {
#line 151 "../src/math-window.vala"
			case GDK_KEY_b:
#line 806 "math-window.c"
			{
				MathEquation* _tmp6_;
				MathEquation* _tmp7_;
#line 155 "../src/math-window.vala"
				_tmp6_ = math_window_get_equation (self);
#line 155 "../src/math-window.vala"
				_tmp7_ = _tmp6_;
#line 155 "../src/math-window.vala"
				math_equation_set_number_base (_tmp7_, 2);
#line 156 "../src/math-window.vala"
				result = TRUE;
#line 156 "../src/math-window.vala"
				return result;
#line 820 "math-window.c"
			}
#line 151 "../src/math-window.vala"
			case GDK_KEY_o:
#line 824 "math-window.c"
			{
				MathEquation* _tmp8_;
				MathEquation* _tmp9_;
#line 159 "../src/math-window.vala"
				_tmp8_ = math_window_get_equation (self);
#line 159 "../src/math-window.vala"
				_tmp9_ = _tmp8_;
#line 159 "../src/math-window.vala"
				math_equation_set_number_base (_tmp9_, 8);
#line 160 "../src/math-window.vala"
				result = TRUE;
#line 160 "../src/math-window.vala"
				return result;
#line 838 "math-window.c"
			}
#line 151 "../src/math-window.vala"
			case GDK_KEY_d:
#line 842 "math-window.c"
			{
				MathEquation* _tmp10_;
				MathEquation* _tmp11_;
#line 163 "../src/math-window.vala"
				_tmp10_ = math_window_get_equation (self);
#line 163 "../src/math-window.vala"
				_tmp11_ = _tmp10_;
#line 163 "../src/math-window.vala"
				math_equation_set_number_base (_tmp11_, 10);
#line 164 "../src/math-window.vala"
				result = TRUE;
#line 164 "../src/math-window.vala"
				return result;
#line 856 "math-window.c"
			}
#line 151 "../src/math-window.vala"
			case GDK_KEY_h:
#line 860 "math-window.c"
			{
				MathEquation* _tmp12_;
				MathEquation* _tmp13_;
#line 167 "../src/math-window.vala"
				_tmp12_ = math_window_get_equation (self);
#line 167 "../src/math-window.vala"
				_tmp13_ = _tmp12_;
#line 167 "../src/math-window.vala"
				math_equation_set_number_base (_tmp13_, 16);
#line 168 "../src/math-window.vala"
				result = TRUE;
#line 168 "../src/math-window.vala"
				return result;
#line 874 "math-window.c"
			}
			default:
#line 151 "../src/math-window.vala"
			break;
#line 879 "math-window.c"
		}
	}
#line 172 "../src/math-window.vala"
	result = _result_;
#line 172 "../src/math-window.vala"
	return result;
#line 886 "math-window.c"
}

static void
math_window_scroll_changed_cb (MathWindow* self,
                               GtkAdjustment* adjustment)
{
#line 176 "../src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/math-window.vala"
	g_return_if_fail (adjustment != NULL);
#line 178 "../src/math-window.vala"
	if (self->priv->right_aligned) {
#line 179 "../src/math-window.vala"
		gtk_adjustment_set_value (adjustment, gtk_adjustment_get_upper (adjustment) - gtk_adjustment_get_page_size (adjustment));
#line 901 "math-window.c"
	}
}

static void
_math_window_scroll_changed_cb_gtk_adjustment_changed (GtkAdjustment* _sender,
                                                       gpointer self)
{
#line 13 "../src/math-window.vala"
	math_window_scroll_changed_cb ((MathWindow*) self, _sender);
#line 911 "math-window.c"
}

static void
math_window_scroll_value_changed_cb (MathWindow* self,
                                     GtkAdjustment* adjustment)
{
#line 183 "../src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/math-window.vala"
	g_return_if_fail (adjustment != NULL);
#line 185 "../src/math-window.vala"
	if (gtk_adjustment_get_value (adjustment) == (gtk_adjustment_get_upper (adjustment) - gtk_adjustment_get_page_size (adjustment))) {
#line 186 "../src/math-window.vala"
		self->priv->right_aligned = TRUE;
#line 926 "math-window.c"
	} else {
#line 188 "../src/math-window.vala"
		self->priv->right_aligned = FALSE;
#line 930 "math-window.c"
	}
}

static void
_math_window_scroll_value_changed_cb_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                   gpointer self)
{
#line 13 "../src/math-window.vala"
	math_window_scroll_value_changed_cb ((MathWindow*) self, _sender);
#line 940 "math-window.c"
}

static void
math_window_copy_cb (MathWindow* self)
{
	MathEquation* _tmp0_;
	MathEquation* _tmp1_;
#line 191 "../src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 193 "../src/math-window.vala"
	_tmp0_ = math_window_get_equation (self);
#line 193 "../src/math-window.vala"
	_tmp1_ = _tmp0_;
#line 193 "../src/math-window.vala"
	math_equation_copy (_tmp1_);
#line 956 "math-window.c"
}

static void
math_window_paste_cb (MathWindow* self)
{
	MathEquation* _tmp0_;
	MathEquation* _tmp1_;
#line 196 "../src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 198 "../src/math-window.vala"
	_tmp0_ = math_window_get_equation (self);
#line 198 "../src/math-window.vala"
	_tmp1_ = _tmp0_;
#line 198 "../src/math-window.vala"
	math_equation_paste (_tmp1_);
#line 972 "math-window.c"
}

static void
math_window_undo_cb (MathWindow* self)
{
	MathEquation* _tmp0_;
	MathEquation* _tmp1_;
#line 201 "../src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 203 "../src/math-window.vala"
	_tmp0_ = math_window_get_equation (self);
#line 203 "../src/math-window.vala"
	_tmp1_ = _tmp0_;
#line 203 "../src/math-window.vala"
	gtk_source_buffer_undo ((GtkSourceBuffer*) _tmp1_);
#line 988 "math-window.c"
}

static void
math_window_redo_cb (MathWindow* self)
{
	MathEquation* _tmp0_;
	MathEquation* _tmp1_;
#line 206 "../src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/math-window.vala"
	_tmp0_ = math_window_get_equation (self);
#line 208 "../src/math-window.vala"
	_tmp1_ = _tmp0_;
#line 208 "../src/math-window.vala"
	gtk_source_buffer_redo ((GtkSourceBuffer*) _tmp1_);
#line 1004 "math-window.c"
}

static void
math_window_mode_cb (MathWindow* self,
                     GSimpleAction* action,
                     GVariant* parameter)
{
	const GVariantType* _tmp0_;
	GtkPopover* popover = NULL;
	GtkMenuButton* _tmp1_;
	GtkPopover* _tmp2_;
	GtkPopover* _tmp3_;
	GtkPopover* _tmp4_;
	GtkMenuButton* _tmp5_;
	MathDisplay* _tmp6_;
	MathDisplay* _tmp7_;
	ButtonMode mode = 0;
	gchar* mode_str = NULL;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	MathButtons* _tmp15_;
	MathButtons* _tmp16_;
	ButtonMode _tmp17_;
#line 211 "../src/math-window.vala"
	g_return_if_fail (self != NULL);
#line 211 "../src/math-window.vala"
	g_return_if_fail (action != NULL);
#line 211 "../src/math-window.vala"
	_vala_return_if_fail (parameter != NULL, "parameter != null");
#line 211 "../src/math-window.vala"
	_tmp0_ = G_VARIANT_TYPE_STRING;
#line 211 "../src/math-window.vala"
	_vala_return_if_fail (g_variant_is_of_type (parameter, _tmp0_), "parameter.is_of_type (VariantType.STRING)");
#line 215 "../src/math-window.vala"
	_tmp1_ = self->priv->menu_button;
#line 215 "../src/math-window.vala"
	_tmp2_ = gtk_menu_button_get_popover (_tmp1_);
#line 215 "../src/math-window.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 215 "../src/math-window.vala"
	popover = _tmp3_;
#line 216 "../src/math-window.vala"
	_tmp4_ = popover;
#line 216 "../src/math-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp4_);
#line 217 "../src/math-window.vala"
	_tmp5_ = self->priv->menu_button;
#line 217 "../src/math-window.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp5_, FALSE);
#line 219 "../src/math-window.vala"
	_tmp6_ = math_window_get_display (self);
#line 219 "../src/math-window.vala"
	_tmp7_ = _tmp6_;
#line 219 "../src/math-window.vala"
	math_display_grab_focus (_tmp7_);
#line 221 "../src/math-window.vala"
	mode = BUTTON_MODE_BASIC;
#line 222 "../src/math-window.vala"
	_tmp8_ = g_variant_get_string (parameter, NULL);
#line 222 "../src/math-window.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 222 "../src/math-window.vala"
	mode_str = _tmp9_;
#line 224 "../src/math-window.vala"
	_tmp10_ = mode_str;
#line 224 "../src/math-window.vala"
	if (g_strcmp0 (_tmp10_, "basic") == 0) {
#line 225 "../src/math-window.vala"
		mode = BUTTON_MODE_BASIC;
#line 1075 "math-window.c"
	} else {
		const gchar* _tmp11_;
#line 226 "../src/math-window.vala"
		_tmp11_ = mode_str;
#line 226 "../src/math-window.vala"
		if (g_strcmp0 (_tmp11_, "advanced") == 0) {
#line 227 "../src/math-window.vala"
			mode = BUTTON_MODE_ADVANCED;
#line 1084 "math-window.c"
		} else {
			const gchar* _tmp12_;
#line 228 "../src/math-window.vala"
			_tmp12_ = mode_str;
#line 228 "../src/math-window.vala"
			if (g_strcmp0 (_tmp12_, "financial") == 0) {
#line 229 "../src/math-window.vala"
				mode = BUTTON_MODE_FINANCIAL;
#line 1093 "math-window.c"
			} else {
				const gchar* _tmp13_;
#line 230 "../src/math-window.vala"
				_tmp13_ = mode_str;
#line 230 "../src/math-window.vala"
				if (g_strcmp0 (_tmp13_, "programming") == 0) {
#line 231 "../src/math-window.vala"
					mode = BUTTON_MODE_PROGRAMMING;
#line 1102 "math-window.c"
				} else {
					const gchar* _tmp14_;
#line 232 "../src/math-window.vala"
					_tmp14_ = mode_str;
#line 232 "../src/math-window.vala"
					if (g_strcmp0 (_tmp14_, "keyboard") == 0) {
#line 233 "../src/math-window.vala"
						mode = BUTTON_MODE_KEYBOARD;
#line 1111 "math-window.c"
					} else {
#line 234 "../src/math-window.vala"
						g_assert_not_reached ();
#line 1115 "math-window.c"
					}
				}
			}
		}
	}
#line 236 "../src/math-window.vala"
	_tmp15_ = math_window_get_buttons (self);
#line 236 "../src/math-window.vala"
	_tmp16_ = _tmp15_;
#line 236 "../src/math-window.vala"
	_tmp17_ = mode;
#line 236 "../src/math-window.vala"
	math_buttons_set_mode (_tmp16_, _tmp17_);
#line 211 "../src/math-window.vala"
	_g_free0 (mode_str);
#line 211 "../src/math-window.vala"
	_g_object_unref0 (popover);
#line 1133 "math-window.c"
}

MathEquation*
math_window_get_equation (MathWindow* self)
{
	MathEquation* result;
	MathEquation* _tmp0_;
#line 16 "../src/math-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 16 "../src/math-window.vala"
	_tmp0_ = self->priv->_equation;
#line 16 "../src/math-window.vala"
	result = _tmp0_;
#line 16 "../src/math-window.vala"
	return result;
#line 1149 "math-window.c"
}

MathDisplay*
math_window_get_display (MathWindow* self)
{
	MathDisplay* result;
	MathDisplay* _tmp0_;
#line 19 "../src/math-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19 "../src/math-window.vala"
	_tmp0_ = self->priv->_display;
#line 19 "../src/math-window.vala"
	result = _tmp0_;
#line 19 "../src/math-window.vala"
	return result;
#line 1165 "math-window.c"
}

MathButtons*
math_window_get_buttons (MathWindow* self)
{
	MathButtons* result;
	MathButtons* _tmp0_;
#line 21 "../src/math-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../src/math-window.vala"
	_tmp0_ = self->priv->_buttons;
#line 21 "../src/math-window.vala"
	result = _tmp0_;
#line 21 "../src/math-window.vala"
	return result;
#line 1181 "math-window.c"
}

static void
math_window_class_init (MathWindowClass * klass,
                        gpointer klass_data)
{
#line 13 "../src/math-window.vala"
	math_window_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/math-window.vala"
	g_type_class_adjust_private_offset (klass, &MathWindow_private_offset);
#line 13 "../src/math-window.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) math_window_real_key_press_event;
#line 13 "../src/math-window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_math_window_get_property;
#line 13 "../src/math-window.vala"
	G_OBJECT_CLASS (klass)->finalize = math_window_finalize;
#line 13 "../src/math-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_WINDOW_EQUATION_PROPERTY, math_window_properties[MATH_WINDOW_EQUATION_PROPERTY] = g_param_spec_object ("equation", "equation", "equation", TYPE_MATH_EQUATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 13 "../src/math-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_WINDOW_DISPLAY_PROPERTY, math_window_properties[MATH_WINDOW_DISPLAY_PROPERTY] = g_param_spec_object ("display", "display", "display", TYPE_MATH_DISPLAY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 13 "../src/math-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_WINDOW_BUTTONS_PROPERTY, math_window_properties[MATH_WINDOW_BUTTONS_PROPERTY] = g_param_spec_object ("buttons", "buttons", "buttons", TYPE_MATH_BUTTONS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 13 "../src/math-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/calculator/math-window.ui");
#line 13 "../src/math-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "menu_button", FALSE, MathWindow_private_offset + G_STRUCT_OFFSET (MathWindowPrivate, menu_button));
#line 13 "../src/math-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "mode_label", FALSE, MathWindow_private_offset + G_STRUCT_OFFSET (MathWindowPrivate, mode_label));
#line 13 "../src/math-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "grid", FALSE, MathWindow_private_offset + G_STRUCT_OFFSET (MathWindowPrivate, grid));
#line 13 "../src/math-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "converter", FALSE, MathWindow_private_offset + G_STRUCT_OFFSET (MathWindowPrivate, converter));
#line 13 "../src/math-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "primary_menu_button", FALSE, G_STRUCT_OFFSET (MathWindow, primary_menu_button));
#line 13 "../src/math-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "scroll_changed_cb", G_CALLBACK(_math_window_scroll_changed_cb_gtk_adjustment_changed));
#line 13 "../src/math-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "scroll_value_changed_cb", G_CALLBACK(_math_window_scroll_value_changed_cb_gtk_adjustment_value_changed));
#line 1220 "math-window.c"
}

static void
math_window_instance_init (MathWindow * self,
                           gpointer klass)
{
#line 13 "../src/math-window.vala"
	self->priv = math_window_get_instance_private (self);
#line 13 "../src/math-window.vala"
	g_type_ensure (TYPE_MATH_CONVERTER);
#line 13 "../src/math-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1233 "math-window.c"
}

static void
math_window_finalize (GObject * obj)
{
	MathWindow * self;
#line 13 "../src/math-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MATH_WINDOW, MathWindow);
#line 15 "../src/math-window.vala"
	_g_object_unref0 (self->priv->_equation);
#line 18 "../src/math-window.vala"
	_g_object_unref0 (self->priv->_display);
#line 20 "../src/math-window.vala"
	_g_object_unref0 (self->priv->_buttons);
#line 26 "../src/math-window.vala"
	_g_object_unref0 (self->priv->menu_button);
#line 28 "../src/math-window.vala"
	_g_object_unref0 (self->priv->mode_label);
#line 30 "../src/math-window.vala"
	_g_object_unref0 (self->priv->grid);
#line 32 "../src/math-window.vala"
	_g_object_unref0 (self->priv->converter);
#line 36 "../src/math-window.vala"
	_g_object_unref0 (self->primary_menu_button);
#line 13 "../src/math-window.vala"
	G_OBJECT_CLASS (math_window_parent_class)->finalize (obj);
#line 1260 "math-window.c"
}

GType
math_window_get_type (void)
{
	static volatile gsize math_window_type_id__volatile = 0;
	if (g_once_init_enter (&math_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MathWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) math_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MathWindow), 0, (GInstanceInitFunc) math_window_instance_init, NULL };
		GType math_window_type_id;
		math_window_type_id = g_type_register_static (gtk_application_window_get_type (), "MathWindow", &g_define_type_info, 0);
		MathWindow_private_offset = g_type_add_instance_private (math_window_type_id, sizeof (MathWindowPrivate));
		g_once_init_leave (&math_window_type_id__volatile, math_window_type_id);
	}
	return math_window_type_id__volatile;
}

static void
_vala_math_window_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	MathWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MATH_WINDOW, MathWindow);
#line 13 "../src/math-window.vala"
	switch (property_id) {
#line 13 "../src/math-window.vala"
		case MATH_WINDOW_EQUATION_PROPERTY:
#line 13 "../src/math-window.vala"
		g_value_set_object (value, math_window_get_equation (self));
#line 13 "../src/math-window.vala"
		break;
#line 13 "../src/math-window.vala"
		case MATH_WINDOW_DISPLAY_PROPERTY:
#line 13 "../src/math-window.vala"
		g_value_set_object (value, math_window_get_display (self));
#line 13 "../src/math-window.vala"
		break;
#line 13 "../src/math-window.vala"
		case MATH_WINDOW_BUTTONS_PROPERTY:
#line 13 "../src/math-window.vala"
		g_value_set_object (value, math_window_get_buttons (self));
#line 13 "../src/math-window.vala"
		break;
#line 1305 "math-window.c"
		default:
#line 13 "../src/math-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../src/math-window.vala"
		break;
#line 1311 "math-window.c"
	}
}

