/* number.c generated by valac 0.44.5, the Vala compiler
 * generated from number.vala, do not modify */

/*
 * Copyright (C) 1987-2008 Sun Microsystems, Inc. All Rights Reserved.
 * Copyright (C) 2008-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
/*  This maths library is based on the MP multi-precision floating-point
 *  arithmetic package originally written in FORTRAN by Richard Brent,
 *  Computer Centre, Australian National University in the 1970's.
 *
 *  It has been converted from FORTRAN into C using the freely available
 *  f2c translator, available via netlib on research.att.com.
 *
 *  The subsequently converted C code has then been tidied up, mainly to
 *  remove any dependencies on the libI77 and libF77 support libraries.
 *
 *  FOR A GENERAL DESCRIPTION OF THE PHILOSOPHY AND DESIGN OF MP,
 *  SEE - R. P. BRENT, A FORTRAN MULTIPLE-PRECISION ARITHMETIC
 *  SOME ADDITIONAL DETAILS ARE GIVEN IN THE SAME ISSUE, 71-81.
 *  FOR DETAILS OF THE IMPLEMENTATION, CALLING SEQUENCES ETC. SEE
 *  THE MP USERS GUIDE.
 */

#include <glib.h>
#include <glib-object.h>
#include "mpc.h"
#include "mpfr.h"
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

typedef gint (*BitwiseFunc) (gint v1, gint v2, gpointer user_data);
typedef enum  {
	ANGLE_UNIT_RADIANS,
	ANGLE_UNIT_DEGREES,
	ANGLE_UNIT_GRADIANS
} AngleUnit;

#define TYPE_ANGLE_UNIT (angle_unit_get_type ())

#define TYPE_NUMBER (number_get_type ())
#define NUMBER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER, Number))
#define NUMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER, NumberClass))
#define IS_NUMBER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER))
#define IS_NUMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER))
#define NUMBER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER, NumberClass))

typedef struct _Number Number;
typedef struct _NumberClass NumberClass;
typedef struct _NumberPrivate NumberPrivate;
enum  {
	NUMBER_0_PROPERTY,
	NUMBER_NUM_PROPERTIES
};
static GParamSpec* number_properties[NUMBER_NUM_PROPERTIES];
typedef struct _MPFRRealRef MPFRRealRef;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SERIALIZER (serializer_get_type ())
#define SERIALIZER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SERIALIZER, Serializer))
#define SERIALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SERIALIZER, SerializerClass))
#define IS_SERIALIZER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SERIALIZER))
#define IS_SERIALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SERIALIZER))
#define SERIALIZER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SERIALIZER, SerializerClass))

typedef struct _Serializer Serializer;
typedef struct _SerializerClass SerializerClass;
typedef enum  {
	DISPLAY_FORMAT_AUTOMATIC,
	DISPLAY_FORMAT_FIXED,
	DISPLAY_FORMAT_SCIENTIFIC,
	DISPLAY_FORMAT_ENGINEERING
} DisplayFormat;

#define TYPE_DISPLAY_FORMAT (display_format_get_type ())

struct _Number {
	GObject parent_instance;
	NumberPrivate * priv;
};

struct _NumberClass {
	GObjectClass parent_class;
};

struct _NumberPrivate {
	__mpc_struct num;
};

struct _MPFRRealRef {
	__mpfr_struct val;
};

static gint Number_private_offset;
static gpointer number_parent_class = NULL;
static mpfr_prec_t number__precision;
static mpfr_prec_t number__precision = (mpfr_prec_t) 1000;
static gchar* number__error;
static gchar* number__error = NULL;

GType angle_unit_get_type (void) G_GNUC_CONST;
GType number_get_type (void) G_GNUC_CONST;
mpfr_prec_t number_get_precision (void);
Number* number_new_integer (gint64 real,
                            gint64 imag);
Number* number_construct_integer (GType object_type,
                                  gint64 real,
                                  gint64 imag);
Number* number_new_unsigned_integer (guint64 real,
                                     guint64 imag);
Number* number_construct_unsigned_integer (GType object_type,
                                           guint64 real,
                                           guint64 imag);
Number* number_new_fraction (gint64 numerator,
                             gint64 denominator);
Number* number_construct_fraction (GType object_type,
                                   gint64 numerator,
                                   gint64 denominator);
Number* number_new_mpreal (__mpfr_struct* real,
                           __mpfr_struct* imag);
Number* number_construct_mpreal (GType object_type,
                                 __mpfr_struct* real,
                                 __mpfr_struct* imag);
Number* number_new_double (gdouble real,
                           gdouble imag);
Number* number_construct_double (GType object_type,
                                 gdouble real,
                                 gdouble imag);
Number* number_new_complex (Number* r,
                            Number* i);
Number* number_construct_complex (GType object_type,
                                  Number* r,
                                  Number* i);
void mpfr_real_ref_free (MPFRRealRef * self);
Number* number_new_polar (Number* r,
                          Number* theta,
                          AngleUnit unit);
Number* number_construct_polar (GType object_type,
                                Number* r,
                                Number* theta,
                                AngleUnit unit);
Number* number_cos (Number* self,
                    AngleUnit unit);
Number* number_sin (Number* self,
                    AngleUnit unit);
Number* number_multiply (Number* self,
                         Number* y);
Number* number_new_eulers (void);
Number* number_construct_eulers (GType object_type);
Number* number_new_i (void);
Number* number_construct_i (GType object_type);
Number* number_new_pi (void);
Number* number_construct_pi (GType object_type);
Number* number_new_random (void);
Number* number_construct_random (GType object_type);
gint64 number_to_integer (Number* self);
guint64 number_to_unsigned_integer (Number* self);
gfloat number_to_float (Number* self);
gdouble number_to_double (Number* self);
gboolean number_is_zero (Number* self);
gboolean number_is_negative (Number* self);
gboolean number_is_integer (Number* self);
gboolean number_is_complex (Number* self);
gboolean number_is_positive_integer (Number* self);
gboolean number_is_natural (Number* self);
void number_check_flags (void);
void number_set_error (const gchar* value);
gboolean number_equals (Number* self,
                        Number* y);
gint number_compare (Number* self,
                     Number* y);
Number* number_sgn (Number* self);
Number* number_invert_sign (Number* self);
Number* number_new (void);
Number* number_construct (GType object_type);
Number* number_abs (Number* self);
Number* number_arg (Number* self,
                    AngleUnit unit);
static void number_mpc_from_radians (__mpc_struct* res,
                              __mpc_struct* op,
                              AngleUnit unit);
Number* number_conjugate (Number* self);
Number* number_real_component (Number* self);
Number* number_imaginary_component (Number* self);
Number* number_integer_component (Number* self);
Number* number_fractional_component (Number* self);
Number* number_fractional_part (Number* self);
Number* number_subtract (Number* self,
                         Number* y);
Number* number_floor (Number* self);
Number* number_ceiling (Number* self);
Number* number_round (Number* self);
Number* number_reciprocal (Number* self);
Number* number_epowy (Number* self);
Number* number_xpowy (Number* self,
                      Number* y);
Number* number_root (Number* self,
                     gint64 n);
Number* number_xpowy_integer (Number* self,
                              gint64 n);
Number* number_sqrt (Number* self);
Number* number_ln (Number* self);
Number* number_logarithm (Number* self,
                          gint64 n);
Number* number_divide (Number* self,
                       Number* y);
Number* number_factorial (Number* self);
Number* number_add (Number* self,
                    Number* y);
Number* number_multiply_integer (Number* self,
                                 gint64 y);
Number* number_divide_integer (Number* self,
                               gint64 y);
Number* number_modulus_divide (Number* self,
                               Number* y);
Number* number_modular_exponentiation (Number* self,
                                       Number* exp,
                                       Number* mod);
static Number* number_copy (Number* self);
static void number_mpc_to_radians (__mpc_struct* res,
                            __mpc_struct* op,
                            AngleUnit unit);
Number* number_tan (Number* self,
                    AngleUnit unit);
static Number* number_to_radians (Number* self,
                           AngleUnit unit);
Number* number_asin (Number* self,
                     AngleUnit unit);
Number* number_acos (Number* self,
                     AngleUnit unit);
Number* number_atan (Number* self,
                     AngleUnit unit);
Number* number_sinh (Number* self);
Number* number_cosh (Number* self);
Number* number_tanh (Number* self);
Number* number_asinh (Number* self);
Number* number_acosh (Number* self);
Number* number_atanh (Number* self);
Number* number_and (Number* self,
                    Number* y);
static Number* number_bitwise (Number* self,
                        Number* y,
                        BitwiseFunc bitwise_operator,
                        gpointer bitwise_operator_target,
                        gint wordlen);
static gint __lambda4_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda4__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
Number* number_or (Number* self,
                   Number* y);
static gint __lambda5_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda5__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
Number* number_xor (Number* self,
                    Number* y);
static gint __lambda6_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda6__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
Number* number_not (Number* self,
                    gint wordlen);
static gint __lambda7_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda7__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
Number* number_mask (Number* self,
                     Number* x,
                     gint wordlen);
static gchar* number_to_hex_string (Number* self);
Number* mp_set_from_string (const gchar* str,
                            gint default_base);
Number* number_shift (Number* self,
                      gint count);
Number* number_ones_complement (Number* self,
                                gint wordlen);
static gint __lambda8_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda8__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
Number* number_twos_complement (Number* self,
                                gint wordlen);
GList* number_factorize (Number* self);
GList* number_factorize_uint64 (Number* self,
                                guint64 n);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gboolean _mpc_equal (const __mpc_struct * s1,
                     const __mpc_struct * s2);
static gint number_hex_to_int (Number* self,
                        gchar digit);
GType serializer_get_type (void) G_GNUC_CONST;
GType display_format_get_type (void) G_GNUC_CONST;
Serializer* serializer_new (DisplayFormat format,
                            gint number_base,
                            gint trailing_digits);
Serializer* serializer_construct (GType object_type,
                                  DisplayFormat format,
                                  gint number_base,
                                  gint trailing_digits);
gchar* serializer_to_string (Serializer* self,
                             Number* x);
void number_set_precision (mpfr_prec_t value);
const gchar* number_get_error (void);
static void number_finalize (GObject * obj);
static void _vala_number_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_number_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec);
gint parse_literal_prefix (const gchar* str,
                           gint* prefix_len);
Number* set_from_sexagesimal (const gchar* str);
gint char_val (gunichar c,
               gint number_base);
gboolean mp_is_overflow (Number* x,
                         gint wordlen);

GType
angle_unit_get_type (void)
{
	static volatile gsize angle_unit_type_id__volatile = 0;
	if (g_once_init_enter (&angle_unit_type_id__volatile)) {
		static const GEnumValue values[] = {{ANGLE_UNIT_RADIANS, "ANGLE_UNIT_RADIANS", "radians"}, {ANGLE_UNIT_DEGREES, "ANGLE_UNIT_DEGREES", "degrees"}, {ANGLE_UNIT_GRADIANS, "ANGLE_UNIT_GRADIANS", "gradians"}, {0, NULL, NULL}};
		GType angle_unit_type_id;
		angle_unit_type_id = g_enum_register_static ("AngleUnit", values);
		g_once_init_leave (&angle_unit_type_id__volatile, angle_unit_type_id);
	}
	return angle_unit_type_id__volatile;
}

static inline gpointer
number_get_instance_private (Number* self)
{
	return G_STRUCT_MEMBER_P (self, Number_private_offset);
}

Number*
number_construct_integer (GType object_type,
                          gint64 real,
                          gint64 imag)
{
	Number * self = NULL;
#line 51 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 53 "../lib/number.vala"
	mpc_set_si_si (&self->priv->num, (glong) real, (glong) imag, MPC_RNDNN);
#line 51 "../lib/number.vala"
	return self;
#line 375 "number.c"
}

Number*
number_new_integer (gint64 real,
                    gint64 imag)
{
#line 51 "../lib/number.vala"
	return number_construct_integer (TYPE_NUMBER, real, imag);
#line 384 "number.c"
}

Number*
number_construct_unsigned_integer (GType object_type,
                                   guint64 real,
                                   guint64 imag)
{
	Number * self = NULL;
#line 56 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 58 "../lib/number.vala"
	mpc_set_ui_ui (&self->priv->num, (gulong) real, (gulong) imag, MPC_RNDNN);
#line 56 "../lib/number.vala"
	return self;
#line 399 "number.c"
}

Number*
number_new_unsigned_integer (guint64 real,
                             guint64 imag)
{
#line 56 "../lib/number.vala"
	return number_construct_unsigned_integer (TYPE_NUMBER, real, imag);
#line 408 "number.c"
}

Number*
number_construct_fraction (GType object_type,
                           gint64 numerator,
                           gint64 denominator)
{
	Number * self = NULL;
#line 63 "../lib/number.vala"
	if (denominator < ((gint64) 0)) {
#line 65 "../lib/number.vala"
		numerator = -numerator;
#line 66 "../lib/number.vala"
		denominator = -denominator;
#line 423 "number.c"
	}
#line 69 "../lib/number.vala"
	self = (Number*) number_construct_integer (object_type, numerator, (gint64) 0);
#line 70 "../lib/number.vala"
	if (denominator != ((gint64) 1)) {
#line 72 "../lib/number.vala"
		mpc_div_ui (&self->priv->num, &self->priv->num, (gulong) ((glong) denominator), MPC_RNDNN);
#line 431 "number.c"
	}
#line 61 "../lib/number.vala"
	return self;
#line 435 "number.c"
}

Number*
number_new_fraction (gint64 numerator,
                     gint64 denominator)
{
#line 61 "../lib/number.vala"
	return number_construct_fraction (TYPE_NUMBER, numerator, denominator);
#line 444 "number.c"
}

static gint
mpc_set_mpreal (__mpc_struct *self,
                __mpfr_struct* re,
                __mpfr_struct* im,
                mpc_rnd_t rnd)
{
	gint result = 0;
	__mpfr_struct _tmp1_;
	__mpfr_struct _tmp2_;
#line 59 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
	g_return_val_if_fail (re != NULL, 0);
#line 61 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
	if (im == NULL) {
#line 460 "number.c"
		__mpfr_struct _tmp0_;
#line 62 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
		_tmp0_ = *re;
#line 62 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
		result = mpc_set_fr (&(*self), &_tmp0_, rnd);
#line 62 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
		return result;
#line 468 "number.c"
	}
#line 64 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
	_tmp1_ = *re;
#line 64 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
	_tmp2_ = *im;
#line 64 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
	result = mpc_set_fr_fr (&(*self), &_tmp1_, &_tmp2_, rnd);
#line 64 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
	return result;
#line 478 "number.c"
}

Number*
number_construct_mpreal (GType object_type,
                         __mpfr_struct* real,
                         __mpfr_struct* imag)
{
	Number * self = NULL;
	__mpfr_struct _tmp0_;
#line 77 "../lib/number.vala"
	g_return_val_if_fail (real != NULL, NULL);
#line 77 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 79 "../lib/number.vala"
	_tmp0_ = *real;
#line 79 "../lib/number.vala"
	mpc_set_mpreal (&self->priv->num, &_tmp0_, imag, MPC_RNDNN);
#line 77 "../lib/number.vala"
	return self;
#line 498 "number.c"
}

Number*
number_new_mpreal (__mpfr_struct* real,
                   __mpfr_struct* imag)
{
#line 77 "../lib/number.vala"
	return number_construct_mpreal (TYPE_NUMBER, real, imag);
#line 507 "number.c"
}

Number*
number_construct_double (GType object_type,
                         gdouble real,
                         gdouble imag)
{
	Number * self = NULL;
#line 82 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 84 "../lib/number.vala"
	mpc_set_d_d (&self->priv->num, real, imag, MPC_RNDNN);
#line 82 "../lib/number.vala"
	return self;
#line 522 "number.c"
}

Number*
number_new_double (gdouble real,
                   gdouble imag)
{
#line 82 "../lib/number.vala"
	return number_construct_double (TYPE_NUMBER, real, imag);
#line 531 "number.c"
}

Number*
number_construct_complex (GType object_type,
                          Number* r,
                          Number* i)
{
	Number * self = NULL;
	MPFRRealRef* _tmp0_;
	MPFRRealRef* _tmp1_;
#line 87 "../lib/number.vala"
	g_return_val_if_fail (r != NULL, NULL);
#line 87 "../lib/number.vala"
	g_return_val_if_fail (i != NULL, NULL);
#line 87 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 89 "../lib/number.vala"
	_tmp0_ = mpc_realref (&r->priv->num);
#line 89 "../lib/number.vala"
	_tmp1_ = mpc_realref (&i->priv->num);
#line 89 "../lib/number.vala"
	mpc_set_mpreal (&self->priv->num, &_tmp0_->val, &_tmp1_->val, MPC_RNDNN);
#line 87 "../lib/number.vala"
	return self;
#line 556 "number.c"
}

Number*
number_new_complex (Number* r,
                    Number* i)
{
#line 87 "../lib/number.vala"
	return number_construct_complex (TYPE_NUMBER, r, i);
#line 565 "number.c"
}

Number*
number_construct_polar (GType object_type,
                        Number* r,
                        Number* theta,
                        AngleUnit unit)
{
	Number * self = NULL;
	Number* x = NULL;
	Number* _tmp0_;
	Number* y = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
#line 92 "../lib/number.vala"
	g_return_val_if_fail (r != NULL, NULL);
#line 92 "../lib/number.vala"
	g_return_val_if_fail (theta != NULL, NULL);
#line 94 "../lib/number.vala"
	_tmp0_ = number_cos (theta, unit);
#line 94 "../lib/number.vala"
	x = _tmp0_;
#line 95 "../lib/number.vala"
	_tmp1_ = number_sin (theta, unit);
#line 95 "../lib/number.vala"
	y = _tmp1_;
#line 96 "../lib/number.vala"
	_tmp2_ = number_multiply (x, r);
#line 96 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 96 "../lib/number.vala"
	_tmp4_ = number_multiply (y, r);
#line 96 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 96 "../lib/number.vala"
	self = (Number*) number_construct_complex (object_type, _tmp3_, _tmp5_);
#line 96 "../lib/number.vala"
	_g_object_unref0 (_tmp5_);
#line 96 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 92 "../lib/number.vala"
	_g_object_unref0 (y);
#line 92 "../lib/number.vala"
	_g_object_unref0 (x);
#line 92 "../lib/number.vala"
	return self;
#line 615 "number.c"
}

Number*
number_new_polar (Number* r,
                  Number* theta,
                  AngleUnit unit)
{
#line 92 "../lib/number.vala"
	return number_construct_polar (TYPE_NUMBER, r, theta, unit);
#line 625 "number.c"
}

Number*
number_construct_eulers (GType object_type)
{
	Number * self = NULL;
	MPFRRealRef* _tmp0_;
	MPFRRealRef* _tmp1_;
	MPFRRealRef* _tmp2_;
	MPFRRealRef* _tmp3_;
#line 99 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 101 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 101 "../lib/number.vala"
	mpfr_set_ui (&_tmp0_->val, (gulong) 1, MPFR_RNDN);
#line 103 "../lib/number.vala"
	_tmp1_ = mpc_realref (&self->priv->num);
#line 103 "../lib/number.vala"
	_tmp2_ = mpc_realref (&self->priv->num);
#line 103 "../lib/number.vala"
	mpfr_exp (&_tmp1_->val, &_tmp2_->val, MPFR_RNDN);
#line 104 "../lib/number.vala"
	_tmp3_ = mpc_imagref (&self->priv->num);
#line 104 "../lib/number.vala"
	mpfr_set_zero (&_tmp3_->val, MPFR_RNDN);
#line 99 "../lib/number.vala"
	return self;
#line 654 "number.c"
}

Number*
number_new_eulers (void)
{
#line 99 "../lib/number.vala"
	return number_construct_eulers (TYPE_NUMBER);
#line 662 "number.c"
}

Number*
number_construct_i (GType object_type)
{
	Number * self = NULL;
#line 107 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 109 "../lib/number.vala"
	mpc_set_si_si (&self->priv->num, (glong) 0, (glong) 1, MPC_RNDNN);
#line 107 "../lib/number.vala"
	return self;
#line 675 "number.c"
}

Number*
number_new_i (void)
{
#line 107 "../lib/number.vala"
	return number_construct_i (TYPE_NUMBER);
#line 683 "number.c"
}

Number*
number_construct_pi (GType object_type)
{
	Number * self = NULL;
	MPFRRealRef* _tmp0_;
	MPFRRealRef* _tmp1_;
#line 112 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 114 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 114 "../lib/number.vala"
	mpfr_const_pi (&_tmp0_->val, MPFR_RNDN);
#line 115 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&self->priv->num);
#line 115 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 112 "../lib/number.vala"
	return self;
#line 704 "number.c"
}

Number*
number_new_pi (void)
{
#line 112 "../lib/number.vala"
	return number_construct_pi (TYPE_NUMBER);
#line 712 "number.c"
}

Number*
number_construct_random (GType object_type)
{
	Number * self = NULL;
#line 121 "../lib/number.vala"
	self = (Number*) number_construct_double (object_type, g_random_double (), (gdouble) 0);
#line 119 "../lib/number.vala"
	return self;
#line 723 "number.c"
}

Number*
number_new_random (void)
{
#line 119 "../lib/number.vala"
	return number_construct_random (TYPE_NUMBER);
#line 731 "number.c"
}

gint64
number_to_integer (Number* self)
{
	gint64 result = 0LL;
	MPFRRealRef* _tmp0_;
#line 124 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 126 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 126 "../lib/number.vala"
	result = (gint64) mpfr_get_si (&_tmp0_->val, MPFR_RNDN);
#line 126 "../lib/number.vala"
	return result;
#line 747 "number.c"
}

guint64
number_to_unsigned_integer (Number* self)
{
	guint64 result = 0ULL;
	MPFRRealRef* _tmp0_;
#line 129 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 131 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 131 "../lib/number.vala"
	result = (guint64) mpfr_get_ui (&_tmp0_->val, MPFR_RNDN);
#line 131 "../lib/number.vala"
	return result;
#line 763 "number.c"
}

gfloat
number_to_float (Number* self)
{
	gfloat result = 0.0F;
	MPFRRealRef* _tmp0_;
#line 134 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 136 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 136 "../lib/number.vala"
	result = mpfr_get_flt (&_tmp0_->val, MPFR_RNDN);
#line 136 "../lib/number.vala"
	return result;
#line 779 "number.c"
}

gdouble
number_to_double (Number* self)
{
	gdouble result = 0.0;
	MPFRRealRef* _tmp0_;
#line 139 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 141 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 141 "../lib/number.vala"
	result = mpfr_get_d (&_tmp0_->val, MPFR_RNDN);
#line 141 "../lib/number.vala"
	return result;
#line 795 "number.c"
}

static gboolean
mpc_is_zero (__mpc_struct *self)
{
	gboolean result = FALSE;
	gint res = 0;
	gboolean _tmp0_ = FALSE;
#line 72 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
	res = mpc_cmp_si_si (&(*self), (glong) 0, (glong) 0);
#line 72 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
	if (MPC_INEX_RE (res) == 0) {
#line 72 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
		_tmp0_ = MPC_INEX_IM (res) == 0;
#line 810 "number.c"
	} else {
#line 72 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
		_tmp0_ = FALSE;
#line 814 "number.c"
	}
#line 72 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
	result = _tmp0_;
#line 72 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
	return result;
#line 820 "number.c"
}

gboolean
number_is_zero (Number* self)
{
	gboolean result = FALSE;
#line 145 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 147 "../lib/number.vala"
	result = mpc_is_zero (&self->priv->num);
#line 147 "../lib/number.vala"
	return result;
#line 833 "number.c"
}

gboolean
number_is_negative (Number* self)
{
	gboolean result = FALSE;
	MPFRRealRef* _tmp0_;
#line 151 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 153 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 153 "../lib/number.vala"
	result = mpfr_sgn (&_tmp0_->val) < 0;
#line 153 "../lib/number.vala"
	return result;
#line 849 "number.c"
}

gboolean
number_is_integer (Number* self)
{
	gboolean result = FALSE;
	MPFRRealRef* _tmp0_;
#line 157 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 159 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 160 "../lib/number.vala"
		result = FALSE;
#line 160 "../lib/number.vala"
		return result;
#line 865 "number.c"
	}
#line 162 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 162 "../lib/number.vala"
	result = mpfr_integer_p (&_tmp0_->val) != 0;
#line 162 "../lib/number.vala"
	return result;
#line 873 "number.c"
}

gboolean
number_is_positive_integer (Number* self)
{
	gboolean result = FALSE;
#line 166 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 168 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 169 "../lib/number.vala"
		result = FALSE;
#line 169 "../lib/number.vala"
		return result;
#line 888 "number.c"
	} else {
		gboolean _tmp0_ = FALSE;
		MPFRRealRef* _tmp1_;
#line 171 "../lib/number.vala"
		_tmp1_ = mpc_realref (&self->priv->num);
#line 171 "../lib/number.vala"
		if (mpfr_sgn (&_tmp1_->val) >= 0) {
#line 171 "../lib/number.vala"
			_tmp0_ = number_is_integer (self);
#line 898 "number.c"
		} else {
#line 171 "../lib/number.vala"
			_tmp0_ = FALSE;
#line 902 "number.c"
		}
#line 171 "../lib/number.vala"
		result = _tmp0_;
#line 171 "../lib/number.vala"
		return result;
#line 908 "number.c"
	}
}

gboolean
number_is_natural (Number* self)
{
	gboolean result = FALSE;
#line 175 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 177 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 178 "../lib/number.vala"
		result = FALSE;
#line 178 "../lib/number.vala"
		return result;
#line 924 "number.c"
	} else {
		gboolean _tmp0_ = FALSE;
		MPFRRealRef* _tmp1_;
#line 180 "../lib/number.vala"
		_tmp1_ = mpc_realref (&self->priv->num);
#line 180 "../lib/number.vala"
		if (mpfr_sgn (&_tmp1_->val) > 0) {
#line 180 "../lib/number.vala"
			_tmp0_ = number_is_integer (self);
#line 934 "number.c"
		} else {
#line 180 "../lib/number.vala"
			_tmp0_ = FALSE;
#line 938 "number.c"
		}
#line 180 "../lib/number.vala"
		result = _tmp0_;
#line 180 "../lib/number.vala"
		return result;
#line 944 "number.c"
	}
}

gboolean
number_is_complex (Number* self)
{
	gboolean result = FALSE;
	MPFRRealRef* _tmp0_;
#line 184 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 186 "../lib/number.vala"
	_tmp0_ = mpc_imagref (&self->priv->num);
#line 186 "../lib/number.vala"
	result = !mpfr_zero_p (&_tmp0_->val);
#line 186 "../lib/number.vala"
	return result;
#line 961 "number.c"
}

void
number_check_flags (void)
{
#line 192 "../lib/number.vala"
	if (mpfr_underflow_p () != 0) {
#line 195 "../lib/number.vala"
		number_set_error (_ ("Underflow error"));
#line 971 "number.c"
	} else {
#line 197 "../lib/number.vala"
		if (mpfr_overflow_p () != 0) {
#line 200 "../lib/number.vala"
			number_set_error (_ ("Overflow error"));
#line 977 "number.c"
		}
	}
}

static gboolean
mpc_is_equal (__mpc_struct *self,
              __mpc_struct* c)
{
	gboolean result = FALSE;
	gint res = 0;
	__mpc_struct _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 73 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
	g_return_val_if_fail (c != NULL, FALSE);
#line 73 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
	_tmp0_ = *c;
#line 73 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
	res = mpc_cmp (&(*self), &_tmp0_);
#line 73 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
	if (MPC_INEX_RE (res) == 0) {
#line 73 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
		_tmp1_ = MPC_INEX_IM (res) == 0;
#line 1000 "number.c"
	} else {
#line 73 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
		_tmp1_ = FALSE;
#line 1004 "number.c"
	}
#line 73 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
	result = _tmp1_;
#line 73 "/builddir/build/BUILD/gnome-calculator-3.32.2/vapi/mpc.vapi"
	return result;
#line 1010 "number.c"
}

gboolean
number_equals (Number* self,
               Number* y)
{
	gboolean result = FALSE;
#line 205 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 205 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, FALSE);
#line 207 "../lib/number.vala"
	result = mpc_is_equal (&self->priv->num, &y->priv->num);
#line 207 "../lib/number.vala"
	return result;
#line 1026 "number.c"
}

gint
number_compare (Number* self,
                Number* y)
{
	gint result = 0;
	MPFRRealRef* _tmp0_;
	MPFRRealRef* _tmp1_;
#line 215 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 215 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, 0);
#line 217 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 217 "../lib/number.vala"
	_tmp1_ = mpc_realref (&y->priv->num);
#line 217 "../lib/number.vala"
	result = mpfr_cmp (&_tmp0_->val, &_tmp1_->val);
#line 217 "../lib/number.vala"
	return result;
#line 1048 "number.c"
}

Number*
number_sgn (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	MPFRRealRef* _tmp0_;
	Number* _tmp1_;
#line 221 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 223 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 223 "../lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) mpfr_sgn (&_tmp0_->val), (gint64) 0);
#line 223 "../lib/number.vala"
	z = _tmp1_;
#line 224 "../lib/number.vala"
	result = z;
#line 224 "../lib/number.vala"
	return result;
#line 1070 "number.c"
}

Number*
number_invert_sign (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 228 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 230 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 230 "../lib/number.vala"
	z = _tmp0_;
#line 231 "../lib/number.vala"
	mpc_neg (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 232 "../lib/number.vala"
	result = z;
#line 232 "../lib/number.vala"
	return result;
#line 1091 "number.c"
}

Number*
number_abs (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	MPFRRealRef* _tmp1_;
	MPFRRealRef* _tmp2_;
#line 236 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 238 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 238 "../lib/number.vala"
	z = _tmp0_;
#line 239 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 239 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 240 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 240 "../lib/number.vala"
	mpc_abs (&_tmp2_->val, &self->priv->num, MPFR_RNDN);
#line 241 "../lib/number.vala"
	result = z;
#line 241 "../lib/number.vala"
	return result;
#line 1120 "number.c"
}

Number*
number_arg (Number* self,
            AngleUnit unit)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	MPFRRealRef* _tmp3_;
	Number* _tmp4_;
	MPFRRealRef* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	gboolean _tmp8_ = FALSE;
#line 245 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 247 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 1141 "number.c"
		Number* _tmp0_;
#line 250 "../lib/number.vala"
		number_set_error (_ ("Argument not defined for zero"));
#line 251 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 251 "../lib/number.vala"
		result = _tmp0_;
#line 251 "../lib/number.vala"
		return result;
#line 1151 "number.c"
	}
#line 253 "../lib/number.vala"
	_tmp1_ = number_new ();
#line 253 "../lib/number.vala"
	z = _tmp1_;
#line 254 "../lib/number.vala"
	_tmp2_ = z;
#line 254 "../lib/number.vala"
	_tmp3_ = mpc_imagref (&_tmp2_->priv->num);
#line 254 "../lib/number.vala"
	mpfr_set_zero (&_tmp3_->val, MPFR_RNDN);
#line 255 "../lib/number.vala"
	_tmp4_ = z;
#line 255 "../lib/number.vala"
	_tmp5_ = mpc_realref (&_tmp4_->priv->num);
#line 255 "../lib/number.vala"
	mpc_arg (&_tmp5_->val, &self->priv->num, MPFR_RNDN);
#line 256 "../lib/number.vala"
	_tmp6_ = z;
#line 256 "../lib/number.vala"
	_tmp7_ = z;
#line 256 "../lib/number.vala"
	number_mpc_from_radians (&_tmp6_->priv->num, &_tmp7_->priv->num, unit);
#line 261 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 261 "../lib/number.vala"
		_tmp8_ = number_is_negative (self);
#line 1179 "number.c"
	} else {
#line 261 "../lib/number.vala"
		_tmp8_ = FALSE;
#line 1183 "number.c"
	}
#line 261 "../lib/number.vala"
	if (_tmp8_) {
#line 1187 "number.c"
		Number* _tmp9_;
		MPFRRealRef* _tmp10_;
		Number* _tmp11_;
		MPFRRealRef* _tmp12_;
#line 262 "../lib/number.vala"
		_tmp9_ = z;
#line 262 "../lib/number.vala"
		_tmp10_ = mpc_realref (&_tmp9_->priv->num);
#line 262 "../lib/number.vala"
		_tmp11_ = z;
#line 262 "../lib/number.vala"
		_tmp12_ = mpc_realref (&_tmp11_->priv->num);
#line 262 "../lib/number.vala"
		mpfr_abs (&_tmp10_->val, &_tmp12_->val, MPFR_RNDN);
#line 1202 "number.c"
	}
#line 264 "../lib/number.vala"
	result = z;
#line 264 "../lib/number.vala"
	return result;
#line 1208 "number.c"
}

Number*
number_conjugate (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 268 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 270 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 270 "../lib/number.vala"
	z = _tmp0_;
#line 271 "../lib/number.vala"
	mpc_conj (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 272 "../lib/number.vala"
	result = z;
#line 272 "../lib/number.vala"
	return result;
#line 1229 "number.c"
}

Number*
number_real_component (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	MPFRRealRef* _tmp1_;
#line 276 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 278 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 278 "../lib/number.vala"
	z = _tmp0_;
#line 279 "../lib/number.vala"
	_tmp1_ = mpc_realref (&self->priv->num);
#line 279 "../lib/number.vala"
	mpc_set_mpreal (&z->priv->num, &_tmp1_->val, NULL, MPC_RNDNN);
#line 280 "../lib/number.vala"
	result = z;
#line 280 "../lib/number.vala"
	return result;
#line 1253 "number.c"
}

Number*
number_imaginary_component (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	MPFRRealRef* _tmp1_;
#line 284 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 287 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 287 "../lib/number.vala"
	z = _tmp0_;
#line 288 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&self->priv->num);
#line 288 "../lib/number.vala"
	mpc_set_mpreal (&z->priv->num, &_tmp1_->val, NULL, MPC_RNDNN);
#line 289 "../lib/number.vala"
	result = z;
#line 289 "../lib/number.vala"
	return result;
#line 1277 "number.c"
}

Number*
number_integer_component (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	MPFRRealRef* _tmp1_;
	MPFRRealRef* _tmp2_;
	MPFRRealRef* _tmp3_;
#line 292 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 294 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 294 "../lib/number.vala"
	z = _tmp0_;
#line 295 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 295 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 296 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 296 "../lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 296 "../lib/number.vala"
	mpfr_trunc (&_tmp2_->val, &_tmp3_->val);
#line 297 "../lib/number.vala"
	result = z;
#line 297 "../lib/number.vala"
	return result;
#line 1309 "number.c"
}

Number*
number_fractional_component (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	MPFRRealRef* _tmp1_;
	MPFRRealRef* _tmp2_;
	MPFRRealRef* _tmp3_;
#line 301 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 303 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 303 "../lib/number.vala"
	z = _tmp0_;
#line 304 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 304 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 305 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 305 "../lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 305 "../lib/number.vala"
	mpfr_frac (&_tmp2_->val, &_tmp3_->val, MPFR_RNDN);
#line 306 "../lib/number.vala"
	result = z;
#line 306 "../lib/number.vala"
	return result;
#line 1341 "number.c"
}

Number*
number_fractional_part (Number* self)
{
	Number* result = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
#line 310 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 312 "../lib/number.vala"
	_tmp0_ = number_floor (self);
#line 312 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 312 "../lib/number.vala"
	_tmp2_ = number_subtract (self, _tmp1_);
#line 312 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 312 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 312 "../lib/number.vala"
	result = _tmp3_;
#line 312 "../lib/number.vala"
	return result;
#line 1368 "number.c"
}

Number*
number_floor (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	MPFRRealRef* _tmp1_;
	MPFRRealRef* _tmp2_;
	MPFRRealRef* _tmp3_;
#line 316 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 318 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 318 "../lib/number.vala"
	z = _tmp0_;
#line 319 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 319 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 320 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 320 "../lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 320 "../lib/number.vala"
	mpfr_floor (&_tmp2_->val, &_tmp3_->val);
#line 321 "../lib/number.vala"
	result = z;
#line 321 "../lib/number.vala"
	return result;
#line 1400 "number.c"
}

Number*
number_ceiling (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	MPFRRealRef* _tmp1_;
	MPFRRealRef* _tmp2_;
	MPFRRealRef* _tmp3_;
#line 325 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 327 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 327 "../lib/number.vala"
	z = _tmp0_;
#line 328 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 328 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 329 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 329 "../lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 329 "../lib/number.vala"
	mpfr_ceil (&_tmp2_->val, &_tmp3_->val);
#line 330 "../lib/number.vala"
	result = z;
#line 330 "../lib/number.vala"
	return result;
#line 1432 "number.c"
}

Number*
number_round (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	MPFRRealRef* _tmp1_;
	MPFRRealRef* _tmp2_;
	MPFRRealRef* _tmp3_;
#line 334 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 336 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 336 "../lib/number.vala"
	z = _tmp0_;
#line 337 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 337 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 338 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 338 "../lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 338 "../lib/number.vala"
	mpfr_round (&_tmp2_->val, &_tmp3_->val);
#line 339 "../lib/number.vala"
	result = z;
#line 339 "../lib/number.vala"
	return result;
#line 1464 "number.c"
}

Number*
number_reciprocal (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	MPFRRealRef* _tmp1_;
#line 343 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 345 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 345 "../lib/number.vala"
	z = _tmp0_;
#line 346 "../lib/number.vala"
	mpc_set_si_si (&z->priv->num, (glong) 1, (glong) 0, MPC_RNDNN);
#line 347 "../lib/number.vala"
	_tmp1_ = mpc_realref (&z->priv->num);
#line 347 "../lib/number.vala"
	mpc_fr_div (&z->priv->num, &_tmp1_->val, &self->priv->num, MPC_RNDNN);
#line 348 "../lib/number.vala"
	result = z;
#line 348 "../lib/number.vala"
	return result;
#line 1490 "number.c"
}

Number*
number_epowy (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 352 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 354 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 354 "../lib/number.vala"
	z = _tmp0_;
#line 355 "../lib/number.vala"
	mpc_exp (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 356 "../lib/number.vala"
	result = z;
#line 356 "../lib/number.vala"
	return result;
#line 1511 "number.c"
}

Number*
number_xpowy (Number* self,
              Number* y)
{
	Number* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	Number* z = NULL;
	Number* _tmp10_;
	Number* _tmp11_;
#line 360 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 360 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 363 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 363 "../lib/number.vala"
		_tmp0_ = number_is_negative (y);
#line 1534 "number.c"
	} else {
#line 363 "../lib/number.vala"
		_tmp0_ = FALSE;
#line 1538 "number.c"
	}
#line 363 "../lib/number.vala"
	if (_tmp0_) {
#line 1542 "number.c"
		Number* _tmp1_;
#line 366 "../lib/number.vala"
		number_set_error (_ ("The power of zero is undefined for a negative exponent"));
#line 367 "../lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 367 "../lib/number.vala"
		result = _tmp1_;
#line 367 "../lib/number.vala"
		return result;
#line 1552 "number.c"
	}
#line 371 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 371 "../lib/number.vala"
		_tmp2_ = number_is_zero (y);
#line 1558 "number.c"
	} else {
#line 371 "../lib/number.vala"
		_tmp2_ = FALSE;
#line 1562 "number.c"
	}
#line 371 "../lib/number.vala"
	if (_tmp2_) {
#line 1566 "number.c"
		Number* _tmp3_;
#line 374 "../lib/number.vala"
		number_set_error (_ ("Zero raised to zero is undefined"));
#line 375 "../lib/number.vala"
		_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 375 "../lib/number.vala"
		result = _tmp3_;
#line 375 "../lib/number.vala"
		return result;
#line 1576 "number.c"
	}
#line 377 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 377 "../lib/number.vala"
		_tmp5_ = !number_is_complex (y);
#line 1582 "number.c"
	} else {
#line 377 "../lib/number.vala"
		_tmp5_ = FALSE;
#line 1586 "number.c"
	}
#line 377 "../lib/number.vala"
	if (_tmp5_) {
#line 377 "../lib/number.vala"
		_tmp4_ = !number_is_integer (y);
#line 1592 "number.c"
	} else {
#line 377 "../lib/number.vala"
		_tmp4_ = FALSE;
#line 1596 "number.c"
	}
#line 377 "../lib/number.vala"
	if (_tmp4_) {
#line 1600 "number.c"
		Number* reciprocal = NULL;
		Number* _tmp6_;
		Number* _tmp7_;
#line 379 "../lib/number.vala"
		_tmp6_ = number_reciprocal (y);
#line 379 "../lib/number.vala"
		reciprocal = _tmp6_;
#line 380 "../lib/number.vala"
		_tmp7_ = reciprocal;
#line 380 "../lib/number.vala"
		if (number_is_integer (_tmp7_)) {
#line 1612 "number.c"
			Number* _tmp8_;
			Number* _tmp9_;
#line 381 "../lib/number.vala"
			_tmp8_ = reciprocal;
#line 381 "../lib/number.vala"
			_tmp9_ = number_root (self, number_to_integer (_tmp8_));
#line 381 "../lib/number.vala"
			result = _tmp9_;
#line 381 "../lib/number.vala"
			_g_object_unref0 (reciprocal);
#line 381 "../lib/number.vala"
			return result;
#line 1625 "number.c"
		}
#line 377 "../lib/number.vala"
		_g_object_unref0 (reciprocal);
#line 1629 "number.c"
	}
#line 384 "../lib/number.vala"
	_tmp10_ = number_new ();
#line 384 "../lib/number.vala"
	z = _tmp10_;
#line 385 "../lib/number.vala"
	_tmp11_ = z;
#line 385 "../lib/number.vala"
	mpc_pow (&_tmp11_->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 386 "../lib/number.vala"
	result = z;
#line 386 "../lib/number.vala"
	return result;
#line 1643 "number.c"
}

Number*
number_xpowy_integer (Number* self,
                      gint64 n)
{
	Number* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
	Number* z = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
#line 390 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 393 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 393 "../lib/number.vala"
		_tmp0_ = n < ((gint64) 0);
#line 1662 "number.c"
	} else {
#line 393 "../lib/number.vala"
		_tmp0_ = FALSE;
#line 1666 "number.c"
	}
#line 393 "../lib/number.vala"
	if (_tmp0_) {
#line 1670 "number.c"
		Number* _tmp1_;
#line 396 "../lib/number.vala"
		number_set_error (_ ("The power of zero is undefined for a negative exponent"));
#line 397 "../lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 397 "../lib/number.vala"
		result = _tmp1_;
#line 397 "../lib/number.vala"
		return result;
#line 1680 "number.c"
	}
#line 401 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 401 "../lib/number.vala"
		_tmp2_ = n == ((gint64) 0);
#line 1686 "number.c"
	} else {
#line 401 "../lib/number.vala"
		_tmp2_ = FALSE;
#line 1690 "number.c"
	}
#line 401 "../lib/number.vala"
	if (_tmp2_) {
#line 1694 "number.c"
		Number* _tmp3_;
#line 404 "../lib/number.vala"
		number_set_error (_ ("Zero raised to zero is undefined"));
#line 405 "../lib/number.vala"
		_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 405 "../lib/number.vala"
		result = _tmp3_;
#line 405 "../lib/number.vala"
		return result;
#line 1704 "number.c"
	}
#line 407 "../lib/number.vala"
	_tmp4_ = number_new ();
#line 407 "../lib/number.vala"
	z = _tmp4_;
#line 408 "../lib/number.vala"
	_tmp5_ = z;
#line 408 "../lib/number.vala"
	mpc_pow_si (&_tmp5_->priv->num, &self->priv->num, (glong) n, MPC_RNDNN);
#line 409 "../lib/number.vala"
	result = z;
#line 409 "../lib/number.vala"
	return result;
#line 1718 "number.c"
}

Number*
number_root (Number* self,
             gint64 n)
{
	Number* result = NULL;
	guint64 p = 0ULL;
	Number* z = NULL;
	Number* _tmp0_;
	gboolean _tmp4_ = FALSE;
#line 413 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 416 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 416 "../lib/number.vala"
	z = _tmp0_;
#line 417 "../lib/number.vala"
	if (n < ((gint64) 0)) {
#line 1738 "number.c"
		Number* _tmp1_;
#line 419 "../lib/number.vala"
		_tmp1_ = z;
#line 419 "../lib/number.vala"
		mpc_ui_div (&_tmp1_->priv->num, (gulong) 1, &self->priv->num, MPC_RNDNN);
#line 420 "../lib/number.vala"
		if (n == G_MININT64) {
#line 421 "../lib/number.vala"
			p = ((guint64) G_MAXINT64) + 1;
#line 1748 "number.c"
		} else {
#line 423 "../lib/number.vala"
			p = (guint64) (-n);
#line 1752 "number.c"
		}
	} else {
#line 424 "../lib/number.vala"
		if (n > ((gint64) 0)) {
#line 1757 "number.c"
			Number* _tmp2_;
#line 425 "../lib/number.vala"
			_tmp2_ = z;
#line 425 "../lib/number.vala"
			mpc_set (&_tmp2_->priv->num, &self->priv->num, MPC_RNDNN);
#line 426 "../lib/number.vala"
			p = (guint64) n;
#line 1765 "number.c"
		} else {
			Number* _tmp3_;
#line 428 "../lib/number.vala"
			number_set_error (_ ("The zeroth root of a number is undefined"));
#line 429 "../lib/number.vala"
			_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 429 "../lib/number.vala"
			result = _tmp3_;
#line 429 "../lib/number.vala"
			_g_object_unref0 (z);
#line 429 "../lib/number.vala"
			return result;
#line 1778 "number.c"
		}
	}
#line 432 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 1783 "number.c"
		gboolean _tmp5_ = FALSE;
#line 432 "../lib/number.vala"
		if (!number_is_negative (self)) {
#line 432 "../lib/number.vala"
			_tmp5_ = TRUE;
#line 1789 "number.c"
		} else {
#line 432 "../lib/number.vala"
			_tmp5_ = (p & 1) == ((guint64) 1);
#line 1793 "number.c"
		}
#line 432 "../lib/number.vala"
		_tmp4_ = _tmp5_;
#line 1797 "number.c"
	} else {
#line 432 "../lib/number.vala"
		_tmp4_ = FALSE;
#line 1801 "number.c"
	}
#line 432 "../lib/number.vala"
	if (_tmp4_) {
#line 1805 "number.c"
		Number* _tmp6_;
		MPFRRealRef* _tmp7_;
		Number* _tmp8_;
		MPFRRealRef* _tmp9_;
		Number* _tmp10_;
		MPFRRealRef* _tmp11_;
#line 434 "../lib/number.vala"
		_tmp6_ = z;
#line 434 "../lib/number.vala"
		_tmp7_ = mpc_realref (&_tmp6_->priv->num);
#line 434 "../lib/number.vala"
		_tmp8_ = z;
#line 434 "../lib/number.vala"
		_tmp9_ = mpc_realref (&_tmp8_->priv->num);
#line 434 "../lib/number.vala"
		mpfr_root (&_tmp7_->val, &_tmp9_->val, (gulong) p, MPFR_RNDN);
#line 435 "../lib/number.vala"
		_tmp10_ = z;
#line 435 "../lib/number.vala"
		_tmp11_ = mpc_imagref (&_tmp10_->priv->num);
#line 435 "../lib/number.vala"
		mpfr_set_zero (&_tmp11_->val, MPFR_RNDN);
#line 1828 "number.c"
	} else {
		__mpfr_struct tmp = {0};
		mpfr_prec_t _tmp12_;
		mpfr_prec_t _tmp13_;
		Number* _tmp14_;
		Number* _tmp15_;
#line 437 "../lib/number.vala"
		_tmp12_ = number_get_precision ();
#line 437 "../lib/number.vala"
		_tmp13_ = _tmp12_;
#line 437 "../lib/number.vala"
		mpfr_init2 (&tmp, _tmp13_);
#line 438 "../lib/number.vala"
		mpfr_set_ui (&tmp, (gulong) p, MPFR_RNDN);
#line 439 "../lib/number.vala"
		mpfr_ui_div (&tmp, (gulong) 1, &tmp, MPFR_RNDN);
#line 440 "../lib/number.vala"
		_tmp14_ = z;
#line 440 "../lib/number.vala"
		_tmp15_ = z;
#line 440 "../lib/number.vala"
		mpc_pow_fr (&_tmp14_->priv->num, &_tmp15_->priv->num, &tmp, MPC_RNDNN);
#line 432 "../lib/number.vala"
		mpfr_clear (&tmp);
#line 1853 "number.c"
	}
#line 442 "../lib/number.vala"
	result = z;
#line 442 "../lib/number.vala"
	return result;
#line 1859 "number.c"
}

Number*
number_sqrt (Number* self)
{
	Number* result = NULL;
	Number* _tmp0_;
#line 446 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 448 "../lib/number.vala"
	_tmp0_ = number_root (self, (gint64) 2);
#line 448 "../lib/number.vala"
	result = _tmp0_;
#line 448 "../lib/number.vala"
	return result;
#line 1875 "number.c"
}

Number*
number_ln (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_ = FALSE;
#line 452 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 455 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 1890 "number.c"
		Number* _tmp0_;
#line 458 "../lib/number.vala"
		number_set_error (_ ("Logarithm of zero is undefined"));
#line 459 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 459 "../lib/number.vala"
		result = _tmp0_;
#line 459 "../lib/number.vala"
		return result;
#line 1900 "number.c"
	}
#line 471 "../lib/number.vala"
	_tmp1_ = number_new ();
#line 471 "../lib/number.vala"
	z = _tmp1_;
#line 472 "../lib/number.vala"
	_tmp2_ = z;
#line 472 "../lib/number.vala"
	mpc_log (&_tmp2_->priv->num, &self->priv->num, MPC_RNDNN);
#line 476 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 476 "../lib/number.vala"
		_tmp3_ = number_is_negative (self);
#line 1914 "number.c"
	} else {
#line 476 "../lib/number.vala"
		_tmp3_ = FALSE;
#line 1918 "number.c"
	}
#line 476 "../lib/number.vala"
	if (_tmp3_) {
#line 1922 "number.c"
		Number* _tmp4_;
		MPFRRealRef* _tmp5_;
		Number* _tmp6_;
		MPFRRealRef* _tmp7_;
#line 477 "../lib/number.vala"
		_tmp4_ = z;
#line 477 "../lib/number.vala"
		_tmp5_ = mpc_imagref (&_tmp4_->priv->num);
#line 477 "../lib/number.vala"
		_tmp6_ = z;
#line 477 "../lib/number.vala"
		_tmp7_ = mpc_imagref (&_tmp6_->priv->num);
#line 477 "../lib/number.vala"
		mpfr_abs (&_tmp5_->val, &_tmp7_->val, MPFR_RNDN);
#line 1937 "number.c"
	}
#line 479 "../lib/number.vala"
	result = z;
#line 479 "../lib/number.vala"
	return result;
#line 1943 "number.c"
}

Number*
number_logarithm (Number* self,
                  gint64 n)
{
	Number* result = NULL;
	Number* t1 = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
#line 483 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 486 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 1964 "number.c"
		Number* _tmp0_;
#line 489 "../lib/number.vala"
		number_set_error (_ ("Logarithm of zero is undefined"));
#line 490 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 490 "../lib/number.vala"
		result = _tmp0_;
#line 490 "../lib/number.vala"
		return result;
#line 1974 "number.c"
	}
#line 494 "../lib/number.vala"
	_tmp1_ = number_new_integer (n, (gint64) 0);
#line 494 "../lib/number.vala"
	t1 = _tmp1_;
#line 495 "../lib/number.vala"
	_tmp2_ = number_ln (self);
#line 495 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 495 "../lib/number.vala"
	_tmp4_ = t1;
#line 495 "../lib/number.vala"
	_tmp5_ = number_ln (_tmp4_);
#line 495 "../lib/number.vala"
	_tmp6_ = _tmp5_;
#line 495 "../lib/number.vala"
	_tmp7_ = number_divide (_tmp3_, _tmp6_);
#line 495 "../lib/number.vala"
	_tmp8_ = _tmp7_;
#line 495 "../lib/number.vala"
	_g_object_unref0 (_tmp6_);
#line 495 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 495 "../lib/number.vala"
	result = _tmp8_;
#line 495 "../lib/number.vala"
	_g_object_unref0 (t1);
#line 495 "../lib/number.vala"
	return result;
#line 2004 "number.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 526 "../lib/number.vala"
	return self ? g_object_ref (self) : NULL;
#line 2012 "number.c"
}

Number*
number_factorial (Number* self)
{
	Number* result = NULL;
	gint64 value = 0LL;
	Number* z = NULL;
	Number* _tmp12_;
#line 499 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 502 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 2026 "number.c"
		Number* _tmp0_;
#line 503 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 503 "../lib/number.vala"
		result = _tmp0_;
#line 503 "../lib/number.vala"
		return result;
#line 2034 "number.c"
	}
#line 504 "../lib/number.vala"
	if (!number_is_natural (self)) {
#line 2038 "number.c"
		gboolean _tmp1_ = FALSE;
		Number* tmp = NULL;
		Number* _tmp3_;
		Number* _tmp4_;
		Number* _tmp5_;
		Number* _tmp6_;
		__mpfr_struct tmp2 = {0};
		mpfr_prec_t _tmp7_;
		mpfr_prec_t _tmp8_;
		Number* _tmp9_;
		MPFRRealRef* _tmp10_;
		Number* _tmp11_;
#line 508 "../lib/number.vala"
		if (number_is_negative (self)) {
#line 508 "../lib/number.vala"
			_tmp1_ = TRUE;
#line 2055 "number.c"
		} else {
#line 508 "../lib/number.vala"
			_tmp1_ = number_is_complex (self);
#line 2059 "number.c"
		}
#line 508 "../lib/number.vala"
		if (_tmp1_) {
#line 2063 "number.c"
			Number* _tmp2_;
#line 511 "../lib/number.vala"
			number_set_error (_ ("Factorial is only defined for non-negative real numbers"));
#line 512 "../lib/number.vala"
			_tmp2_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 512 "../lib/number.vala"
			result = _tmp2_;
#line 512 "../lib/number.vala"
			return result;
#line 2073 "number.c"
		}
#line 515 "../lib/number.vala"
		_tmp3_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 515 "../lib/number.vala"
		_tmp4_ = _tmp3_;
#line 515 "../lib/number.vala"
		_tmp5_ = number_add (self, _tmp4_);
#line 515 "../lib/number.vala"
		_tmp6_ = _tmp5_;
#line 515 "../lib/number.vala"
		_g_object_unref0 (_tmp4_);
#line 515 "../lib/number.vala"
		tmp = _tmp6_;
#line 516 "../lib/number.vala"
		_tmp7_ = number_get_precision ();
#line 516 "../lib/number.vala"
		_tmp8_ = _tmp7_;
#line 516 "../lib/number.vala"
		mpfr_init2 (&tmp2, _tmp8_);
#line 519 "../lib/number.vala"
		_tmp9_ = tmp;
#line 519 "../lib/number.vala"
		_tmp10_ = mpc_realref (&_tmp9_->priv->num);
#line 519 "../lib/number.vala"
		mpfr_gamma (&tmp2, &_tmp10_->val, MPFR_RNDN);
#line 521 "../lib/number.vala"
		_tmp11_ = number_new_mpreal (&tmp2, NULL);
#line 521 "../lib/number.vala"
		result = _tmp11_;
#line 521 "../lib/number.vala"
		mpfr_clear (&tmp2);
#line 521 "../lib/number.vala"
		_g_object_unref0 (tmp);
#line 521 "../lib/number.vala"
		return result;
#line 2109 "number.c"
	}
#line 525 "../lib/number.vala"
	value = number_to_integer (self);
#line 526 "../lib/number.vala"
	_tmp12_ = _g_object_ref0 (self);
#line 526 "../lib/number.vala"
	z = _tmp12_;
#line 2117 "number.c"
	{
		gint i = 0;
#line 527 "../lib/number.vala"
		i = 2;
#line 2122 "number.c"
		{
			gboolean _tmp13_ = FALSE;
#line 527 "../lib/number.vala"
			_tmp13_ = TRUE;
#line 527 "../lib/number.vala"
			while (TRUE) {
#line 2129 "number.c"
				Number* _tmp15_;
				Number* _tmp16_;
#line 527 "../lib/number.vala"
				if (!_tmp13_) {
#line 2134 "number.c"
					gint _tmp14_;
#line 527 "../lib/number.vala"
					_tmp14_ = i;
#line 527 "../lib/number.vala"
					i = _tmp14_ + 1;
#line 2140 "number.c"
				}
#line 527 "../lib/number.vala"
				_tmp13_ = FALSE;
#line 527 "../lib/number.vala"
				if (!(((gint64) i) < value)) {
#line 527 "../lib/number.vala"
					break;
#line 2148 "number.c"
				}
#line 528 "../lib/number.vala"
				_tmp15_ = z;
#line 528 "../lib/number.vala"
				_tmp16_ = number_multiply_integer (_tmp15_, (gint64) i);
#line 528 "../lib/number.vala"
				_g_object_unref0 (z);
#line 528 "../lib/number.vala"
				z = _tmp16_;
#line 2158 "number.c"
			}
		}
	}
#line 530 "../lib/number.vala"
	result = z;
#line 530 "../lib/number.vala"
	return result;
#line 2166 "number.c"
}

Number*
number_add (Number* self,
            Number* y)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 534 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 534 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 536 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 536 "../lib/number.vala"
	z = _tmp0_;
#line 537 "../lib/number.vala"
	mpc_add (&z->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 538 "../lib/number.vala"
	result = z;
#line 538 "../lib/number.vala"
	return result;
#line 2190 "number.c"
}

Number*
number_subtract (Number* self,
                 Number* y)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 542 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 542 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 544 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 544 "../lib/number.vala"
	z = _tmp0_;
#line 545 "../lib/number.vala"
	mpc_sub (&z->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 546 "../lib/number.vala"
	result = z;
#line 546 "../lib/number.vala"
	return result;
#line 2214 "number.c"
}

Number*
number_multiply (Number* self,
                 Number* y)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 550 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 550 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 552 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 552 "../lib/number.vala"
	z = _tmp0_;
#line 553 "../lib/number.vala"
	mpc_mul (&z->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 554 "../lib/number.vala"
	result = z;
#line 554 "../lib/number.vala"
	return result;
#line 2238 "number.c"
}

Number*
number_multiply_integer (Number* self,
                         gint64 y)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 558 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 560 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 560 "../lib/number.vala"
	z = _tmp0_;
#line 561 "../lib/number.vala"
	mpc_mul_si (&z->priv->num, &self->priv->num, (glong) y, MPC_RNDNN);
#line 562 "../lib/number.vala"
	result = z;
#line 562 "../lib/number.vala"
	return result;
#line 2260 "number.c"
}

Number*
number_divide (Number* self,
               Number* y)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
#line 566 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 566 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 568 "../lib/number.vala"
	if (number_is_zero (y)) {
#line 2277 "number.c"
		Number* _tmp0_;
#line 571 "../lib/number.vala"
		number_set_error (_ ("Division by zero is undefined"));
#line 572 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 572 "../lib/number.vala"
		result = _tmp0_;
#line 572 "../lib/number.vala"
		return result;
#line 2287 "number.c"
	}
#line 575 "../lib/number.vala"
	_tmp1_ = number_new ();
#line 575 "../lib/number.vala"
	z = _tmp1_;
#line 576 "../lib/number.vala"
	_tmp2_ = z;
#line 576 "../lib/number.vala"
	mpc_div (&_tmp2_->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 577 "../lib/number.vala"
	result = z;
#line 577 "../lib/number.vala"
	return result;
#line 2301 "number.c"
}

Number*
number_divide_integer (Number* self,
                       gint64 y)
{
	Number* result = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
#line 581 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 583 "../lib/number.vala"
	_tmp0_ = number_new_integer (y, (gint64) 0);
#line 583 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 583 "../lib/number.vala"
	_tmp2_ = number_divide (self, _tmp1_);
#line 583 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 583 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 583 "../lib/number.vala"
	result = _tmp3_;
#line 583 "../lib/number.vala"
	return result;
#line 2329 "number.c"
}

Number*
number_modulus_divide (Number* self,
                       Number* y)
{
	Number* result = NULL;
	gboolean _tmp0_ = FALSE;
	Number* t1 = NULL;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* t2 = NULL;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* z = NULL;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	Number* _tmp13_;
#line 587 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 587 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 589 "../lib/number.vala"
	if (!number_is_integer (self)) {
#line 589 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 2361 "number.c"
	} else {
#line 589 "../lib/number.vala"
		_tmp0_ = !number_is_integer (y);
#line 2365 "number.c"
	}
#line 589 "../lib/number.vala"
	if (_tmp0_) {
#line 2369 "number.c"
		Number* _tmp1_;
#line 592 "../lib/number.vala"
		number_set_error (_ ("Modulus division is only defined for integers"));
#line 593 "../lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 593 "../lib/number.vala"
		result = _tmp1_;
#line 593 "../lib/number.vala"
		return result;
#line 2379 "number.c"
	}
#line 596 "../lib/number.vala"
	_tmp2_ = number_divide (self, y);
#line 596 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 596 "../lib/number.vala"
	_tmp4_ = number_floor (_tmp3_);
#line 596 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 596 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 596 "../lib/number.vala"
	t1 = _tmp5_;
#line 597 "../lib/number.vala"
	_tmp6_ = t1;
#line 597 "../lib/number.vala"
	_tmp7_ = number_multiply (_tmp6_, y);
#line 597 "../lib/number.vala"
	t2 = _tmp7_;
#line 598 "../lib/number.vala"
	_tmp8_ = t2;
#line 598 "../lib/number.vala"
	_tmp9_ = number_subtract (self, _tmp8_);
#line 598 "../lib/number.vala"
	z = _tmp9_;
#line 600 "../lib/number.vala"
	_tmp10_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 600 "../lib/number.vala"
	_g_object_unref0 (t1);
#line 600 "../lib/number.vala"
	t1 = _tmp10_;
#line 601 "../lib/number.vala"
	_tmp13_ = t1;
#line 601 "../lib/number.vala"
	if (number_compare (y, _tmp13_) < 0) {
#line 2415 "number.c"
		Number* _tmp14_;
		Number* _tmp15_;
#line 601 "../lib/number.vala"
		_tmp14_ = z;
#line 601 "../lib/number.vala"
		_tmp15_ = t1;
#line 601 "../lib/number.vala"
		_tmp12_ = number_compare (_tmp14_, _tmp15_) > 0;
#line 2424 "number.c"
	} else {
#line 601 "../lib/number.vala"
		_tmp12_ = FALSE;
#line 2428 "number.c"
	}
#line 601 "../lib/number.vala"
	if (_tmp12_) {
#line 601 "../lib/number.vala"
		_tmp11_ = TRUE;
#line 2434 "number.c"
	} else {
		gboolean _tmp16_ = FALSE;
		Number* _tmp17_;
#line 601 "../lib/number.vala"
		_tmp17_ = t1;
#line 601 "../lib/number.vala"
		if (number_compare (y, _tmp17_) > 0) {
#line 2442 "number.c"
			Number* _tmp18_;
			Number* _tmp19_;
#line 601 "../lib/number.vala"
			_tmp18_ = z;
#line 601 "../lib/number.vala"
			_tmp19_ = t1;
#line 601 "../lib/number.vala"
			_tmp16_ = number_compare (_tmp18_, _tmp19_) < 0;
#line 2451 "number.c"
		} else {
#line 601 "../lib/number.vala"
			_tmp16_ = FALSE;
#line 2455 "number.c"
		}
#line 601 "../lib/number.vala"
		_tmp11_ = _tmp16_;
#line 2459 "number.c"
	}
#line 601 "../lib/number.vala"
	if (_tmp11_) {
#line 2463 "number.c"
		Number* _tmp20_;
		Number* _tmp21_;
#line 602 "../lib/number.vala"
		_tmp20_ = z;
#line 602 "../lib/number.vala"
		_tmp21_ = number_add (_tmp20_, y);
#line 602 "../lib/number.vala"
		_g_object_unref0 (z);
#line 602 "../lib/number.vala"
		z = _tmp21_;
#line 2474 "number.c"
	}
#line 604 "../lib/number.vala"
	result = z;
#line 604 "../lib/number.vala"
	_g_object_unref0 (t2);
#line 604 "../lib/number.vala"
	_g_object_unref0 (t1);
#line 604 "../lib/number.vala"
	return result;
#line 2484 "number.c"
}

Number*
number_modular_exponentiation (Number* self,
                               Number* exp,
                               Number* mod)
{
	Number* result = NULL;
	Number* base_value = NULL;
	Number* _tmp0_;
	Number* exp_value = NULL;
	Number* _tmp3_;
	Number* ans = NULL;
	Number* _tmp4_;
	Number* two = NULL;
	Number* _tmp5_;
	Number* _tmp26_;
	Number* _tmp27_;
#line 608 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 608 "../lib/number.vala"
	g_return_val_if_fail (exp != NULL, NULL);
#line 608 "../lib/number.vala"
	g_return_val_if_fail (mod != NULL, NULL);
#line 610 "../lib/number.vala"
	_tmp0_ = number_copy (self);
#line 610 "../lib/number.vala"
	base_value = _tmp0_;
#line 611 "../lib/number.vala"
	if (number_is_negative (exp)) {
#line 2515 "number.c"
		Number* _tmp1_;
		Number* _tmp2_;
#line 612 "../lib/number.vala"
		_tmp1_ = base_value;
#line 612 "../lib/number.vala"
		_tmp2_ = number_reciprocal (_tmp1_);
#line 612 "../lib/number.vala"
		_g_object_unref0 (base_value);
#line 612 "../lib/number.vala"
		base_value = _tmp2_;
#line 2526 "number.c"
	}
#line 613 "../lib/number.vala"
	_tmp3_ = number_abs (exp);
#line 613 "../lib/number.vala"
	exp_value = _tmp3_;
#line 614 "../lib/number.vala"
	_tmp4_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 614 "../lib/number.vala"
	ans = _tmp4_;
#line 615 "../lib/number.vala"
	_tmp5_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 615 "../lib/number.vala"
	two = _tmp5_;
#line 616 "../lib/number.vala"
	while (TRUE) {
#line 2542 "number.c"
		Number* _tmp6_;
		gboolean is_even = FALSE;
		Number* _tmp7_;
		Number* _tmp8_;
		Number* _tmp9_;
		Number* _tmp10_;
		gboolean _tmp11_;
		Number* _tmp17_;
		Number* _tmp18_;
		Number* _tmp19_;
		Number* _tmp20_;
		Number* _tmp21_;
		Number* _tmp22_;
		Number* _tmp23_;
		Number* _tmp24_;
		Number* _tmp25_;
#line 616 "../lib/number.vala"
		_tmp6_ = exp_value;
#line 616 "../lib/number.vala"
		if (!(!number_is_zero (_tmp6_))) {
#line 616 "../lib/number.vala"
			break;
#line 2565 "number.c"
		}
#line 618 "../lib/number.vala"
		_tmp7_ = exp_value;
#line 618 "../lib/number.vala"
		_tmp8_ = two;
#line 618 "../lib/number.vala"
		_tmp9_ = number_modulus_divide (_tmp7_, _tmp8_);
#line 618 "../lib/number.vala"
		_tmp10_ = _tmp9_;
#line 618 "../lib/number.vala"
		_tmp11_ = number_is_zero (_tmp10_);
#line 618 "../lib/number.vala"
		_g_object_unref0 (_tmp10_);
#line 618 "../lib/number.vala"
		is_even = _tmp11_;
#line 619 "../lib/number.vala"
		if (!is_even) {
#line 2583 "number.c"
			Number* _tmp12_;
			Number* _tmp13_;
			Number* _tmp14_;
			Number* _tmp15_;
			Number* _tmp16_;
#line 621 "../lib/number.vala"
			_tmp12_ = ans;
#line 621 "../lib/number.vala"
			_tmp13_ = base_value;
#line 621 "../lib/number.vala"
			_tmp14_ = number_multiply (_tmp12_, _tmp13_);
#line 621 "../lib/number.vala"
			_g_object_unref0 (ans);
#line 621 "../lib/number.vala"
			ans = _tmp14_;
#line 622 "../lib/number.vala"
			_tmp15_ = ans;
#line 622 "../lib/number.vala"
			_tmp16_ = number_modulus_divide (_tmp15_, mod);
#line 622 "../lib/number.vala"
			_g_object_unref0 (ans);
#line 622 "../lib/number.vala"
			ans = _tmp16_;
#line 2607 "number.c"
		}
#line 624 "../lib/number.vala"
		_tmp17_ = base_value;
#line 624 "../lib/number.vala"
		_tmp18_ = base_value;
#line 624 "../lib/number.vala"
		_tmp19_ = number_multiply (_tmp17_, _tmp18_);
#line 624 "../lib/number.vala"
		_g_object_unref0 (base_value);
#line 624 "../lib/number.vala"
		base_value = _tmp19_;
#line 625 "../lib/number.vala"
		_tmp20_ = base_value;
#line 625 "../lib/number.vala"
		_tmp21_ = number_modulus_divide (_tmp20_, mod);
#line 625 "../lib/number.vala"
		_g_object_unref0 (base_value);
#line 625 "../lib/number.vala"
		base_value = _tmp21_;
#line 626 "../lib/number.vala"
		_tmp22_ = exp_value;
#line 626 "../lib/number.vala"
		_tmp23_ = number_divide_integer (_tmp22_, (gint64) 2);
#line 626 "../lib/number.vala"
		_tmp24_ = _tmp23_;
#line 626 "../lib/number.vala"
		_tmp25_ = number_floor (_tmp24_);
#line 626 "../lib/number.vala"
		_g_object_unref0 (exp_value);
#line 626 "../lib/number.vala"
		exp_value = _tmp25_;
#line 626 "../lib/number.vala"
		_g_object_unref0 (_tmp24_);
#line 2641 "number.c"
	}
#line 628 "../lib/number.vala"
	_tmp26_ = ans;
#line 628 "../lib/number.vala"
	_tmp27_ = number_modulus_divide (_tmp26_, mod);
#line 628 "../lib/number.vala"
	result = _tmp27_;
#line 628 "../lib/number.vala"
	_g_object_unref0 (two);
#line 628 "../lib/number.vala"
	_g_object_unref0 (ans);
#line 628 "../lib/number.vala"
	_g_object_unref0 (exp_value);
#line 628 "../lib/number.vala"
	_g_object_unref0 (base_value);
#line 628 "../lib/number.vala"
	return result;
#line 2659 "number.c"
}

Number*
number_sin (Number* self,
            AngleUnit unit)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	Number* _tmp3_;
	Number* _tmp4_;
#line 632 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 634 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 634 "../lib/number.vala"
	z = _tmp0_;
#line 635 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 2679 "number.c"
		Number* _tmp1_;
#line 636 "../lib/number.vala"
		_tmp1_ = z;
#line 636 "../lib/number.vala"
		mpc_set (&_tmp1_->priv->num, &self->priv->num, MPC_RNDNN);
#line 2685 "number.c"
	} else {
		Number* _tmp2_;
#line 638 "../lib/number.vala"
		_tmp2_ = z;
#line 638 "../lib/number.vala"
		number_mpc_to_radians (&_tmp2_->priv->num, &self->priv->num, unit);
#line 2692 "number.c"
	}
#line 639 "../lib/number.vala"
	_tmp3_ = z;
#line 639 "../lib/number.vala"
	_tmp4_ = z;
#line 639 "../lib/number.vala"
	mpc_sin (&_tmp3_->priv->num, &_tmp4_->priv->num, MPC_RNDNN);
#line 640 "../lib/number.vala"
	result = z;
#line 640 "../lib/number.vala"
	return result;
#line 2704 "number.c"
}

Number*
number_cos (Number* self,
            AngleUnit unit)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	Number* _tmp3_;
	Number* _tmp4_;
#line 644 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 646 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 646 "../lib/number.vala"
	z = _tmp0_;
#line 647 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 2724 "number.c"
		Number* _tmp1_;
#line 648 "../lib/number.vala"
		_tmp1_ = z;
#line 648 "../lib/number.vala"
		mpc_set (&_tmp1_->priv->num, &self->priv->num, MPC_RNDNN);
#line 2730 "number.c"
	} else {
		Number* _tmp2_;
#line 650 "../lib/number.vala"
		_tmp2_ = z;
#line 650 "../lib/number.vala"
		number_mpc_to_radians (&_tmp2_->priv->num, &self->priv->num, unit);
#line 2737 "number.c"
	}
#line 651 "../lib/number.vala"
	_tmp3_ = z;
#line 651 "../lib/number.vala"
	_tmp4_ = z;
#line 651 "../lib/number.vala"
	mpc_cos (&_tmp3_->priv->num, &_tmp4_->priv->num, MPC_RNDNN);
#line 652 "../lib/number.vala"
	result = z;
#line 652 "../lib/number.vala"
	return result;
#line 2749 "number.c"
}

Number*
number_tan (Number* self,
            AngleUnit unit)
{
	Number* result = NULL;
	Number* x_radians = NULL;
	Number* _tmp0_;
	Number* check = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* _tmp12_;
	Number* z = NULL;
	Number* _tmp14_;
	Number* _tmp17_;
	Number* _tmp18_;
#line 656 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 659 "../lib/number.vala"
	_tmp0_ = number_to_radians (self, unit);
#line 659 "../lib/number.vala"
	x_radians = _tmp0_;
#line 660 "../lib/number.vala"
	_tmp1_ = x_radians;
#line 660 "../lib/number.vala"
	_tmp2_ = number_new_pi ();
#line 660 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 660 "../lib/number.vala"
	_tmp4_ = number_divide_integer (_tmp3_, (gint64) 2);
#line 660 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 660 "../lib/number.vala"
	_tmp6_ = number_subtract (_tmp1_, _tmp5_);
#line 660 "../lib/number.vala"
	_tmp7_ = _tmp6_;
#line 660 "../lib/number.vala"
	_tmp8_ = number_new_pi ();
#line 660 "../lib/number.vala"
	_tmp9_ = _tmp8_;
#line 660 "../lib/number.vala"
	_tmp10_ = number_divide (_tmp7_, _tmp9_);
#line 660 "../lib/number.vala"
	_tmp11_ = _tmp10_;
#line 660 "../lib/number.vala"
	_g_object_unref0 (_tmp9_);
#line 660 "../lib/number.vala"
	_g_object_unref0 (_tmp7_);
#line 660 "../lib/number.vala"
	_g_object_unref0 (_tmp5_);
#line 660 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 660 "../lib/number.vala"
	check = _tmp11_;
#line 662 "../lib/number.vala"
	_tmp12_ = check;
#line 662 "../lib/number.vala"
	if (number_is_integer (_tmp12_)) {
#line 2818 "number.c"
		Number* _tmp13_;
#line 665 "../lib/number.vala"
		number_set_error (_ ("Tangent is undefined for angles that are multiples of π (180°) from π∕" \
"2 (90°)"));
#line 666 "../lib/number.vala"
		_tmp13_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 666 "../lib/number.vala"
		result = _tmp13_;
#line 666 "../lib/number.vala"
		_g_object_unref0 (check);
#line 666 "../lib/number.vala"
		_g_object_unref0 (x_radians);
#line 666 "../lib/number.vala"
		return result;
#line 2832 "number.c"
	}
#line 669 "../lib/number.vala"
	_tmp14_ = number_new ();
#line 669 "../lib/number.vala"
	z = _tmp14_;
#line 670 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 2840 "number.c"
		Number* _tmp15_;
#line 671 "../lib/number.vala"
		_tmp15_ = z;
#line 671 "../lib/number.vala"
		mpc_set (&_tmp15_->priv->num, &self->priv->num, MPC_RNDNN);
#line 2846 "number.c"
	} else {
		Number* _tmp16_;
#line 673 "../lib/number.vala"
		_tmp16_ = z;
#line 673 "../lib/number.vala"
		number_mpc_to_radians (&_tmp16_->priv->num, &self->priv->num, unit);
#line 2853 "number.c"
	}
#line 674 "../lib/number.vala"
	_tmp17_ = z;
#line 674 "../lib/number.vala"
	_tmp18_ = z;
#line 674 "../lib/number.vala"
	mpc_tan (&_tmp17_->priv->num, &_tmp18_->priv->num, MPC_RNDNN);
#line 675 "../lib/number.vala"
	result = z;
#line 675 "../lib/number.vala"
	_g_object_unref0 (check);
#line 675 "../lib/number.vala"
	_g_object_unref0 (x_radians);
#line 675 "../lib/number.vala"
	return result;
#line 2869 "number.c"
}

Number*
number_asin (Number* self,
             AngleUnit unit)
{
	Number* result = NULL;
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_;
	Number* z = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
#line 679 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 681 "../lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 681 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 681 "../lib/number.vala"
	_tmp3_ = number_compare (self, _tmp2_) > 0;
#line 681 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 681 "../lib/number.vala"
	if (_tmp3_) {
#line 681 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 2899 "number.c"
	} else {
		Number* _tmp4_;
		Number* _tmp5_;
#line 681 "../lib/number.vala"
		_tmp4_ = number_new_integer ((gint64) -1, (gint64) 0);
#line 681 "../lib/number.vala"
		_tmp5_ = _tmp4_;
#line 681 "../lib/number.vala"
		_tmp0_ = number_compare (self, _tmp5_) < 0;
#line 681 "../lib/number.vala"
		_g_object_unref0 (_tmp5_);
#line 2911 "number.c"
	}
#line 681 "../lib/number.vala"
	if (_tmp0_) {
#line 2915 "number.c"
		Number* _tmp6_;
#line 684 "../lib/number.vala"
		number_set_error (_ ("Inverse sine is undefined for values outside [-1, 1]"));
#line 685 "../lib/number.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 685 "../lib/number.vala"
		result = _tmp6_;
#line 685 "../lib/number.vala"
		return result;
#line 2925 "number.c"
	}
#line 688 "../lib/number.vala"
	_tmp7_ = number_new ();
#line 688 "../lib/number.vala"
	z = _tmp7_;
#line 689 "../lib/number.vala"
	_tmp8_ = z;
#line 689 "../lib/number.vala"
	mpc_asin (&_tmp8_->priv->num, &self->priv->num, MPC_RNDNN);
#line 690 "../lib/number.vala"
	_tmp9_ = z;
#line 690 "../lib/number.vala"
	if (!number_is_complex (_tmp9_)) {
#line 2939 "number.c"
		Number* _tmp10_;
		Number* _tmp11_;
#line 691 "../lib/number.vala"
		_tmp10_ = z;
#line 691 "../lib/number.vala"
		_tmp11_ = z;
#line 691 "../lib/number.vala"
		number_mpc_from_radians (&_tmp10_->priv->num, &_tmp11_->priv->num, unit);
#line 2948 "number.c"
	}
#line 692 "../lib/number.vala"
	result = z;
#line 692 "../lib/number.vala"
	return result;
#line 2954 "number.c"
}

Number*
number_acos (Number* self,
             AngleUnit unit)
{
	Number* result = NULL;
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_;
	Number* z = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
#line 696 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 698 "../lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 698 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 698 "../lib/number.vala"
	_tmp3_ = number_compare (self, _tmp2_) > 0;
#line 698 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 698 "../lib/number.vala"
	if (_tmp3_) {
#line 698 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 2984 "number.c"
	} else {
		Number* _tmp4_;
		Number* _tmp5_;
#line 698 "../lib/number.vala"
		_tmp4_ = number_new_integer ((gint64) -1, (gint64) 0);
#line 698 "../lib/number.vala"
		_tmp5_ = _tmp4_;
#line 698 "../lib/number.vala"
		_tmp0_ = number_compare (self, _tmp5_) < 0;
#line 698 "../lib/number.vala"
		_g_object_unref0 (_tmp5_);
#line 2996 "number.c"
	}
#line 698 "../lib/number.vala"
	if (_tmp0_) {
#line 3000 "number.c"
		Number* _tmp6_;
#line 701 "../lib/number.vala"
		number_set_error (_ ("Inverse cosine is undefined for values outside [-1, 1]"));
#line 702 "../lib/number.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 702 "../lib/number.vala"
		result = _tmp6_;
#line 702 "../lib/number.vala"
		return result;
#line 3010 "number.c"
	}
#line 705 "../lib/number.vala"
	_tmp7_ = number_new ();
#line 705 "../lib/number.vala"
	z = _tmp7_;
#line 706 "../lib/number.vala"
	_tmp8_ = z;
#line 706 "../lib/number.vala"
	mpc_acos (&_tmp8_->priv->num, &self->priv->num, MPC_RNDNN);
#line 707 "../lib/number.vala"
	_tmp9_ = z;
#line 707 "../lib/number.vala"
	if (!number_is_complex (_tmp9_)) {
#line 3024 "number.c"
		Number* _tmp10_;
		Number* _tmp11_;
#line 708 "../lib/number.vala"
		_tmp10_ = z;
#line 708 "../lib/number.vala"
		_tmp11_ = z;
#line 708 "../lib/number.vala"
		number_mpc_from_radians (&_tmp10_->priv->num, &_tmp11_->priv->num, unit);
#line 3033 "number.c"
	}
#line 709 "../lib/number.vala"
	result = z;
#line 709 "../lib/number.vala"
	return result;
#line 3039 "number.c"
}

Number*
number_atan (Number* self,
             AngleUnit unit)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
#line 713 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 715 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 715 "../lib/number.vala"
	z = _tmp0_;
#line 716 "../lib/number.vala"
	_tmp1_ = z;
#line 716 "../lib/number.vala"
	mpc_atan (&_tmp1_->priv->num, &self->priv->num, MPC_RNDNN);
#line 717 "../lib/number.vala"
	_tmp2_ = z;
#line 717 "../lib/number.vala"
	if (!number_is_complex (_tmp2_)) {
#line 3065 "number.c"
		Number* _tmp3_;
		Number* _tmp4_;
#line 718 "../lib/number.vala"
		_tmp3_ = z;
#line 718 "../lib/number.vala"
		_tmp4_ = z;
#line 718 "../lib/number.vala"
		number_mpc_from_radians (&_tmp3_->priv->num, &_tmp4_->priv->num, unit);
#line 3074 "number.c"
	}
#line 719 "../lib/number.vala"
	result = z;
#line 719 "../lib/number.vala"
	return result;
#line 3080 "number.c"
}

Number*
number_sinh (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 723 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 725 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 725 "../lib/number.vala"
	z = _tmp0_;
#line 726 "../lib/number.vala"
	mpc_sinh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 727 "../lib/number.vala"
	result = z;
#line 727 "../lib/number.vala"
	return result;
#line 3101 "number.c"
}

Number*
number_cosh (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 731 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 733 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 733 "../lib/number.vala"
	z = _tmp0_;
#line 734 "../lib/number.vala"
	mpc_cosh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 735 "../lib/number.vala"
	result = z;
#line 735 "../lib/number.vala"
	return result;
#line 3122 "number.c"
}

Number*
number_tanh (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 739 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 741 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 741 "../lib/number.vala"
	z = _tmp0_;
#line 742 "../lib/number.vala"
	mpc_tanh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 743 "../lib/number.vala"
	result = z;
#line 743 "../lib/number.vala"
	return result;
#line 3143 "number.c"
}

Number*
number_asinh (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 747 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 749 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 749 "../lib/number.vala"
	z = _tmp0_;
#line 750 "../lib/number.vala"
	mpc_asinh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 751 "../lib/number.vala"
	result = z;
#line 751 "../lib/number.vala"
	return result;
#line 3164 "number.c"
}

Number*
number_acosh (Number* self)
{
	Number* result = NULL;
	Number* t = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* z = NULL;
	Number* _tmp3_;
	Number* _tmp4_;
#line 755 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 758 "../lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 758 "../lib/number.vala"
	t = _tmp0_;
#line 759 "../lib/number.vala"
	_tmp1_ = t;
#line 759 "../lib/number.vala"
	if (number_compare (self, _tmp1_) < 0) {
#line 3187 "number.c"
		Number* _tmp2_;
#line 762 "../lib/number.vala"
		number_set_error (_ ("Inverse hyperbolic cosine is undefined for values less than one"));
#line 763 "../lib/number.vala"
		_tmp2_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 763 "../lib/number.vala"
		result = _tmp2_;
#line 763 "../lib/number.vala"
		_g_object_unref0 (t);
#line 763 "../lib/number.vala"
		return result;
#line 3199 "number.c"
	}
#line 766 "../lib/number.vala"
	_tmp3_ = number_new ();
#line 766 "../lib/number.vala"
	z = _tmp3_;
#line 767 "../lib/number.vala"
	_tmp4_ = z;
#line 767 "../lib/number.vala"
	mpc_acosh (&_tmp4_->priv->num, &self->priv->num, MPC_RNDNN);
#line 768 "../lib/number.vala"
	result = z;
#line 768 "../lib/number.vala"
	_g_object_unref0 (t);
#line 768 "../lib/number.vala"
	return result;
#line 3215 "number.c"
}

Number*
number_atanh (Number* self)
{
	Number* result = NULL;
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_;
	Number* z = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
#line 772 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 775 "../lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 775 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 775 "../lib/number.vala"
	_tmp3_ = number_compare (self, _tmp2_) >= 0;
#line 775 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 775 "../lib/number.vala"
	if (_tmp3_) {
#line 775 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 3243 "number.c"
	} else {
		Number* _tmp4_;
		Number* _tmp5_;
#line 775 "../lib/number.vala"
		_tmp4_ = number_new_integer ((gint64) -1, (gint64) 0);
#line 775 "../lib/number.vala"
		_tmp5_ = _tmp4_;
#line 775 "../lib/number.vala"
		_tmp0_ = number_compare (self, _tmp5_) <= 0;
#line 775 "../lib/number.vala"
		_g_object_unref0 (_tmp5_);
#line 3255 "number.c"
	}
#line 775 "../lib/number.vala"
	if (_tmp0_) {
#line 3259 "number.c"
		Number* _tmp6_;
#line 778 "../lib/number.vala"
		number_set_error (_ ("Inverse hyperbolic tangent is undefined for values outside [-1, 1]"));
#line 779 "../lib/number.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 779 "../lib/number.vala"
		result = _tmp6_;
#line 779 "../lib/number.vala"
		return result;
#line 3269 "number.c"
	}
#line 782 "../lib/number.vala"
	_tmp7_ = number_new ();
#line 782 "../lib/number.vala"
	z = _tmp7_;
#line 783 "../lib/number.vala"
	_tmp8_ = z;
#line 783 "../lib/number.vala"
	mpc_atanh (&_tmp8_->priv->num, &self->priv->num, MPC_RNDNN);
#line 784 "../lib/number.vala"
	result = z;
#line 784 "../lib/number.vala"
	return result;
#line 3283 "number.c"
}

static gint
__lambda4_ (Number* self,
            gint v1,
            gint v2)
{
	gint result = 0;
#line 797 "../lib/number.vala"
	result = v1 & v2;
#line 797 "../lib/number.vala"
	return result;
#line 3296 "number.c"
}

static gint
___lambda4__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda4_ ((Number*) self, v1, v2);
#line 797 "../lib/number.vala"
	return result;
#line 3308 "number.c"
}

Number*
number_and (Number* self,
            Number* y)
{
	Number* result = NULL;
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
#line 788 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 788 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 790 "../lib/number.vala"
	if (!number_is_positive_integer (self)) {
#line 790 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 3326 "number.c"
	} else {
#line 791 "../lib/number.vala"
		_tmp0_ = !number_is_positive_integer (y);
#line 3330 "number.c"
	}
#line 790 "../lib/number.vala"
	if (_tmp0_) {
#line 794 "../lib/number.vala"
		number_set_error (_ ("Boolean AND is only defined for positive integers"));
#line 3336 "number.c"
	}
#line 797 "../lib/number.vala"
	_tmp1_ = number_bitwise (self, y, ___lambda4__bitwise_func, self, 0);
#line 797 "../lib/number.vala"
	result = _tmp1_;
#line 797 "../lib/number.vala"
	return result;
#line 3344 "number.c"
}

static gint
__lambda5_ (Number* self,
            gint v1,
            gint v2)
{
	gint result = 0;
#line 809 "../lib/number.vala"
	result = v1 | v2;
#line 809 "../lib/number.vala"
	return result;
#line 3357 "number.c"
}

static gint
___lambda5__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda5_ ((Number*) self, v1, v2);
#line 809 "../lib/number.vala"
	return result;
#line 3369 "number.c"
}

Number*
number_or (Number* self,
           Number* y)
{
	Number* result = NULL;
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
#line 801 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 801 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 803 "../lib/number.vala"
	if (!number_is_positive_integer (self)) {
#line 803 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 3387 "number.c"
	} else {
#line 803 "../lib/number.vala"
		_tmp0_ = !number_is_positive_integer (y);
#line 3391 "number.c"
	}
#line 803 "../lib/number.vala"
	if (_tmp0_) {
#line 806 "../lib/number.vala"
		number_set_error (_ ("Boolean OR is only defined for positive integers"));
#line 3397 "number.c"
	}
#line 809 "../lib/number.vala"
	_tmp1_ = number_bitwise (self, y, ___lambda5__bitwise_func, self, 0);
#line 809 "../lib/number.vala"
	result = _tmp1_;
#line 809 "../lib/number.vala"
	return result;
#line 3405 "number.c"
}

static gint
__lambda6_ (Number* self,
            gint v1,
            gint v2)
{
	gint result = 0;
#line 821 "../lib/number.vala"
	result = v1 ^ v2;
#line 821 "../lib/number.vala"
	return result;
#line 3418 "number.c"
}

static gint
___lambda6__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda6_ ((Number*) self, v1, v2);
#line 821 "../lib/number.vala"
	return result;
#line 3430 "number.c"
}

Number*
number_xor (Number* self,
            Number* y)
{
	Number* result = NULL;
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
#line 813 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 813 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 815 "../lib/number.vala"
	if (!number_is_positive_integer (self)) {
#line 815 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 3448 "number.c"
	} else {
#line 815 "../lib/number.vala"
		_tmp0_ = !number_is_positive_integer (y);
#line 3452 "number.c"
	}
#line 815 "../lib/number.vala"
	if (_tmp0_) {
#line 818 "../lib/number.vala"
		number_set_error (_ ("Boolean XOR is only defined for positive integers"));
#line 3458 "number.c"
	}
#line 821 "../lib/number.vala"
	_tmp1_ = number_bitwise (self, y, ___lambda6__bitwise_func, self, 0);
#line 821 "../lib/number.vala"
	result = _tmp1_;
#line 821 "../lib/number.vala"
	return result;
#line 3466 "number.c"
}

static gint
__lambda7_ (Number* self,
            gint v1,
            gint v2)
{
	gint result = 0;
#line 833 "../lib/number.vala"
	result = v1 ^ 0xF;
#line 833 "../lib/number.vala"
	return result;
#line 3479 "number.c"
}

static gint
___lambda7__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda7_ ((Number*) self, v1, v2);
#line 833 "../lib/number.vala"
	return result;
#line 3491 "number.c"
}

Number*
number_not (Number* self,
            gint wordlen)
{
	Number* result = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
#line 825 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 827 "../lib/number.vala"
	if (!number_is_positive_integer (self)) {
#line 830 "../lib/number.vala"
		number_set_error (_ ("Boolean NOT is only defined for positive integers"));
#line 3509 "number.c"
	}
#line 833 "../lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 833 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 833 "../lib/number.vala"
	_tmp2_ = number_bitwise (self, _tmp1_, ___lambda7__bitwise_func, self, wordlen);
#line 833 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 833 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 833 "../lib/number.vala"
	result = _tmp3_;
#line 833 "../lib/number.vala"
	return result;
#line 3525 "number.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1395 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1395 "glib-2.0.vapi"
	end = _tmp0_;
#line 1396 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1396 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1397 "glib-2.0.vapi"
		result = maxlen;
#line 1397 "glib-2.0.vapi"
		return result;
#line 3548 "number.c"
	} else {
		gchar* _tmp2_;
#line 1399 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1399 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1399 "glib-2.0.vapi"
		return result;
#line 3557 "number.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
#line 1406 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1408 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 3576 "number.c"
	} else {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 3580 "number.c"
	}
#line 1408 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1410 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 3586 "number.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1412 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1412 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1412 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 3596 "number.c"
	}
#line 1415 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1416 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1417 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 3604 "number.c"
	} else {
#line 1419 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 3608 "number.c"
	}
#line 1421 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1422 "glib-2.0.vapi"
		len = string_length - offset;
#line 3614 "number.c"
	}
#line 1424 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1425 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1425 "glib-2.0.vapi"
	result = _tmp3_;
#line 1425 "glib-2.0.vapi"
	return result;
#line 3624 "number.c"
}

Number*
number_mask (Number* self,
             Number* x,
             gint wordlen)
{
	Number* result = NULL;
	gchar* text = NULL;
	gchar* _tmp0_;
	gint len = 0;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint offset = 0;
	gint _tmp4_ = 0;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
#line 837 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 837 "../lib/number.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 840 "../lib/number.vala"
	_tmp0_ = number_to_hex_string (x);
#line 840 "../lib/number.vala"
	text = _tmp0_;
#line 841 "../lib/number.vala"
	_tmp1_ = text;
#line 841 "../lib/number.vala"
	_tmp2_ = strlen (_tmp1_);
#line 841 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 841 "../lib/number.vala"
	len = _tmp3_;
#line 842 "../lib/number.vala"
	offset = wordlen / 4;
#line 843 "../lib/number.vala"
	if (len > offset) {
#line 843 "../lib/number.vala"
		_tmp4_ = ((gint) len) - offset;
#line 3668 "number.c"
	} else {
#line 843 "../lib/number.vala"
		_tmp4_ = 0;
#line 3672 "number.c"
	}
#line 843 "../lib/number.vala"
	offset = _tmp4_;
#line 844 "../lib/number.vala"
	_tmp5_ = text;
#line 844 "../lib/number.vala"
	_tmp6_ = string_substring (_tmp5_, (glong) offset, (glong) -1);
#line 844 "../lib/number.vala"
	_tmp7_ = _tmp6_;
#line 844 "../lib/number.vala"
	_tmp8_ = mp_set_from_string (_tmp7_, 16);
#line 844 "../lib/number.vala"
	_tmp9_ = _tmp8_;
#line 844 "../lib/number.vala"
	_g_free0 (_tmp7_);
#line 844 "../lib/number.vala"
	result = _tmp9_;
#line 844 "../lib/number.vala"
	_g_free0 (text);
#line 844 "../lib/number.vala"
	return result;
#line 3694 "number.c"
}

Number*
number_shift (Number* self,
              gint count)
{
	Number* result = NULL;
#line 848 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 850 "../lib/number.vala"
	if (!number_is_integer (self)) {
#line 3706 "number.c"
		Number* _tmp0_;
#line 853 "../lib/number.vala"
		number_set_error (_ ("Shift is only possible on integer values"));
#line 854 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 854 "../lib/number.vala"
		result = _tmp0_;
#line 854 "../lib/number.vala"
		return result;
#line 3716 "number.c"
	}
#line 857 "../lib/number.vala"
	if (count >= 0) {
#line 3720 "number.c"
		gint multiplier = 0;
		Number* _tmp3_;
#line 859 "../lib/number.vala"
		multiplier = 1;
#line 3725 "number.c"
		{
			gint i = 0;
#line 860 "../lib/number.vala"
			i = 0;
#line 3730 "number.c"
			{
				gboolean _tmp1_ = FALSE;
#line 860 "../lib/number.vala"
				_tmp1_ = TRUE;
#line 860 "../lib/number.vala"
				while (TRUE) {
#line 860 "../lib/number.vala"
					if (!_tmp1_) {
#line 3739 "number.c"
						gint _tmp2_;
#line 860 "../lib/number.vala"
						_tmp2_ = i;
#line 860 "../lib/number.vala"
						i = _tmp2_ + 1;
#line 3745 "number.c"
					}
#line 860 "../lib/number.vala"
					_tmp1_ = FALSE;
#line 860 "../lib/number.vala"
					if (!(i < count)) {
#line 860 "../lib/number.vala"
						break;
#line 3753 "number.c"
					}
#line 861 "../lib/number.vala"
					multiplier = multiplier * 2;
#line 3757 "number.c"
				}
			}
		}
#line 862 "../lib/number.vala"
		_tmp3_ = number_multiply_integer (self, (gint64) multiplier);
#line 862 "../lib/number.vala"
		result = _tmp3_;
#line 862 "../lib/number.vala"
		return result;
#line 3767 "number.c"
	} else {
		gint multiplier = 0;
		Number* _tmp6_;
		Number* _tmp7_;
		Number* _tmp8_;
		Number* _tmp9_;
#line 866 "../lib/number.vala"
		multiplier = 1;
#line 3776 "number.c"
		{
			gint i = 0;
#line 867 "../lib/number.vala"
			i = 0;
#line 3781 "number.c"
			{
				gboolean _tmp4_ = FALSE;
#line 867 "../lib/number.vala"
				_tmp4_ = TRUE;
#line 867 "../lib/number.vala"
				while (TRUE) {
#line 867 "../lib/number.vala"
					if (!_tmp4_) {
#line 3790 "number.c"
						gint _tmp5_;
#line 867 "../lib/number.vala"
						_tmp5_ = i;
#line 867 "../lib/number.vala"
						i = _tmp5_ + 1;
#line 3796 "number.c"
					}
#line 867 "../lib/number.vala"
					_tmp4_ = FALSE;
#line 867 "../lib/number.vala"
					if (!(i < (-count))) {
#line 867 "../lib/number.vala"
						break;
#line 3804 "number.c"
					}
#line 868 "../lib/number.vala"
					multiplier = multiplier * 2;
#line 3808 "number.c"
				}
			}
		}
#line 869 "../lib/number.vala"
		_tmp6_ = number_divide_integer (self, (gint64) multiplier);
#line 869 "../lib/number.vala"
		_tmp7_ = _tmp6_;
#line 869 "../lib/number.vala"
		_tmp8_ = number_floor (_tmp7_);
#line 869 "../lib/number.vala"
		_tmp9_ = _tmp8_;
#line 869 "../lib/number.vala"
		_g_object_unref0 (_tmp7_);
#line 869 "../lib/number.vala"
		result = _tmp9_;
#line 869 "../lib/number.vala"
		return result;
#line 3826 "number.c"
	}
}

static gint
__lambda8_ (Number* self,
            gint v1,
            gint v2)
{
	gint result = 0;
#line 876 "../lib/number.vala"
	result = v1 ^ v2;
#line 876 "../lib/number.vala"
	return result;
#line 3840 "number.c"
}

static gint
___lambda8__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda8_ ((Number*) self, v1, v2);
#line 876 "../lib/number.vala"
	return result;
#line 3852 "number.c"
}

Number*
number_ones_complement (Number* self,
                        gint wordlen)
{
	Number* result = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
#line 874 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 876 "../lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 876 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 876 "../lib/number.vala"
	_tmp2_ = number_bitwise (self, _tmp1_, ___lambda8__bitwise_func, self, wordlen);
#line 876 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 876 "../lib/number.vala"
	_tmp4_ = number_not (_tmp3_, wordlen);
#line 876 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 876 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 876 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 876 "../lib/number.vala"
	result = _tmp5_;
#line 876 "../lib/number.vala"
	return result;
#line 3888 "number.c"
}

Number*
number_twos_complement (Number* self,
                        gint wordlen)
{
	Number* result = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
#line 880 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 882 "../lib/number.vala"
	_tmp0_ = number_ones_complement (self, wordlen);
#line 882 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 882 "../lib/number.vala"
	_tmp2_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 882 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 882 "../lib/number.vala"
	_tmp4_ = number_add (_tmp1_, _tmp3_);
#line 882 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 882 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 882 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 882 "../lib/number.vala"
	result = _tmp5_;
#line 882 "../lib/number.vala"
	return result;
#line 3924 "number.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 916 "../lib/number.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 3932 "number.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 916 "../lib/number.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 3940 "number.c"
}

GList*
number_factorize (Number* self)
{
	GList* result = NULL;
	GList* factors = NULL;
	Number* value = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	gboolean _tmp7_;
	guint64 num = 0ULL;
	Number* int_max = NULL;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* divisor = NULL;
	Number* _tmp18_;
	Number* _tmp27_;
	Number* root = NULL;
	Number* _tmp28_;
	Number* _tmp29_;
	Number* _tmp48_;
	Number* _tmp49_;
	Number* _tmp50_;
	gboolean _tmp51_;
#line 886 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 888 "../lib/number.vala"
	factors = NULL;
#line 890 "../lib/number.vala"
	_tmp0_ = number_abs (self);
#line 890 "../lib/number.vala"
	value = _tmp0_;
#line 892 "../lib/number.vala"
	_tmp1_ = value;
#line 892 "../lib/number.vala"
	if (number_is_zero (_tmp1_)) {
#line 3982 "number.c"
		Number* _tmp2_;
		Number* _tmp3_;
#line 894 "../lib/number.vala"
		_tmp2_ = value;
#line 894 "../lib/number.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 894 "../lib/number.vala"
		factors = g_list_append (factors, _tmp3_);
#line 895 "../lib/number.vala"
		result = factors;
#line 895 "../lib/number.vala"
		_g_object_unref0 (value);
#line 895 "../lib/number.vala"
		return result;
#line 3997 "number.c"
	}
#line 898 "../lib/number.vala"
	_tmp4_ = value;
#line 898 "../lib/number.vala"
	_tmp5_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 898 "../lib/number.vala"
	_tmp6_ = _tmp5_;
#line 898 "../lib/number.vala"
	_tmp7_ = number_equals (_tmp4_, _tmp6_);
#line 898 "../lib/number.vala"
	_g_object_unref0 (_tmp6_);
#line 898 "../lib/number.vala"
	if (_tmp7_) {
#line 4011 "number.c"
		Number* _tmp8_;
#line 900 "../lib/number.vala"
		_tmp8_ = _g_object_ref0 (self);
#line 900 "../lib/number.vala"
		factors = g_list_append (factors, _tmp8_);
#line 901 "../lib/number.vala"
		result = factors;
#line 901 "../lib/number.vala"
		_g_object_unref0 (value);
#line 901 "../lib/number.vala"
		return result;
#line 4023 "number.c"
	}
#line 906 "../lib/number.vala"
	num = (guint64) 1;
#line 907 "../lib/number.vala"
	num = num << 63;
#line 908 "../lib/number.vala"
	num = num + (num - 1);
#line 909 "../lib/number.vala"
	_tmp9_ = number_new_unsigned_integer (num, (guint64) 0);
#line 909 "../lib/number.vala"
	int_max = _tmp9_;
#line 911 "../lib/number.vala"
	_tmp10_ = value;
#line 911 "../lib/number.vala"
	_tmp11_ = int_max;
#line 911 "../lib/number.vala"
	if (number_compare (_tmp10_, _tmp11_) <= 0) {
#line 4041 "number.c"
		GList* factors_int64 = NULL;
		Number* _tmp12_;
		GList* _tmp13_;
#line 913 "../lib/number.vala"
		_tmp12_ = value;
#line 913 "../lib/number.vala"
		_tmp13_ = number_factorize_uint64 (self, number_to_unsigned_integer (_tmp12_));
#line 913 "../lib/number.vala"
		factors_int64 = _tmp13_;
#line 914 "../lib/number.vala"
		if (number_is_negative (self)) {
#line 4053 "number.c"
			GList* _tmp14_;
			GList* _tmp15_;
			gconstpointer _tmp16_;
			Number* _tmp17_;
#line 915 "../lib/number.vala"
			_tmp14_ = factors_int64;
#line 915 "../lib/number.vala"
			_tmp15_ = factors_int64;
#line 915 "../lib/number.vala"
			_tmp16_ = _tmp15_->data;
#line 915 "../lib/number.vala"
			_tmp17_ = number_invert_sign ((Number*) _tmp16_);
#line 915 "../lib/number.vala"
			_g_object_unref0 (_tmp14_->data);
#line 915 "../lib/number.vala"
			_tmp14_->data = _tmp17_;
#line 4070 "number.c"
		}
#line 916 "../lib/number.vala"
		result = factors_int64;
#line 916 "../lib/number.vala"
		_g_object_unref0 (int_max);
#line 916 "../lib/number.vala"
		_g_object_unref0 (value);
#line 916 "../lib/number.vala"
		(factors == NULL) ? NULL : (factors = (_g_list_free__g_object_unref0_ (factors), NULL));
#line 916 "../lib/number.vala"
		return result;
#line 4082 "number.c"
	}
#line 919 "../lib/number.vala"
	_tmp18_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 919 "../lib/number.vala"
	divisor = _tmp18_;
#line 920 "../lib/number.vala"
	while (TRUE) {
#line 4090 "number.c"
		Number* tmp = NULL;
		Number* _tmp19_;
		Number* _tmp20_;
		Number* _tmp21_;
		Number* _tmp22_;
#line 922 "../lib/number.vala"
		_tmp19_ = value;
#line 922 "../lib/number.vala"
		_tmp20_ = divisor;
#line 922 "../lib/number.vala"
		_tmp21_ = number_divide (_tmp19_, _tmp20_);
#line 922 "../lib/number.vala"
		tmp = _tmp21_;
#line 923 "../lib/number.vala"
		_tmp22_ = tmp;
#line 923 "../lib/number.vala"
		if (number_is_integer (_tmp22_)) {
#line 4108 "number.c"
			Number* _tmp23_;
			Number* _tmp24_;
			Number* _tmp25_;
			Number* _tmp26_;
#line 925 "../lib/number.vala"
			_tmp23_ = tmp;
#line 925 "../lib/number.vala"
			_tmp24_ = _g_object_ref0 (_tmp23_);
#line 925 "../lib/number.vala"
			_g_object_unref0 (value);
#line 925 "../lib/number.vala"
			value = _tmp24_;
#line 926 "../lib/number.vala"
			_tmp25_ = divisor;
#line 926 "../lib/number.vala"
			_tmp26_ = _g_object_ref0 (_tmp25_);
#line 926 "../lib/number.vala"
			factors = g_list_append (factors, _tmp26_);
#line 4127 "number.c"
		} else {
#line 929 "../lib/number.vala"
			_g_object_unref0 (tmp);
#line 929 "../lib/number.vala"
			break;
#line 4133 "number.c"
		}
#line 920 "../lib/number.vala"
		_g_object_unref0 (tmp);
#line 4137 "number.c"
	}
#line 932 "../lib/number.vala"
	_tmp27_ = number_new_integer ((gint64) 3, (gint64) 0);
#line 932 "../lib/number.vala"
	_g_object_unref0 (divisor);
#line 932 "../lib/number.vala"
	divisor = _tmp27_;
#line 933 "../lib/number.vala"
	_tmp28_ = value;
#line 933 "../lib/number.vala"
	_tmp29_ = number_sqrt (_tmp28_);
#line 933 "../lib/number.vala"
	root = _tmp29_;
#line 934 "../lib/number.vala"
	while (TRUE) {
#line 4153 "number.c"
		Number* _tmp30_;
		Number* _tmp31_;
		Number* tmp = NULL;
		Number* _tmp32_;
		Number* _tmp33_;
		Number* _tmp34_;
		Number* _tmp35_;
#line 934 "../lib/number.vala"
		_tmp30_ = divisor;
#line 934 "../lib/number.vala"
		_tmp31_ = root;
#line 934 "../lib/number.vala"
		if (!(number_compare (_tmp30_, _tmp31_) <= 0)) {
#line 934 "../lib/number.vala"
			break;
#line 4169 "number.c"
		}
#line 936 "../lib/number.vala"
		_tmp32_ = value;
#line 936 "../lib/number.vala"
		_tmp33_ = divisor;
#line 936 "../lib/number.vala"
		_tmp34_ = number_divide (_tmp32_, _tmp33_);
#line 936 "../lib/number.vala"
		tmp = _tmp34_;
#line 937 "../lib/number.vala"
		_tmp35_ = tmp;
#line 937 "../lib/number.vala"
		if (number_is_integer (_tmp35_)) {
#line 4183 "number.c"
			Number* _tmp36_;
			Number* _tmp37_;
			Number* _tmp38_;
			Number* _tmp39_;
			Number* _tmp40_;
			Number* _tmp41_;
#line 939 "../lib/number.vala"
			_tmp36_ = tmp;
#line 939 "../lib/number.vala"
			_tmp37_ = _g_object_ref0 (_tmp36_);
#line 939 "../lib/number.vala"
			_g_object_unref0 (value);
#line 939 "../lib/number.vala"
			value = _tmp37_;
#line 940 "../lib/number.vala"
			_tmp38_ = value;
#line 940 "../lib/number.vala"
			_tmp39_ = number_sqrt (_tmp38_);
#line 940 "../lib/number.vala"
			_g_object_unref0 (root);
#line 940 "../lib/number.vala"
			root = _tmp39_;
#line 941 "../lib/number.vala"
			_tmp40_ = divisor;
#line 941 "../lib/number.vala"
			_tmp41_ = _g_object_ref0 (_tmp40_);
#line 941 "../lib/number.vala"
			factors = g_list_append (factors, _tmp41_);
#line 4212 "number.c"
		} else {
			Number* _tmp42_;
			Number* _tmp43_;
			Number* _tmp44_;
			Number* _tmp45_;
			Number* _tmp46_;
			Number* _tmp47_;
#line 945 "../lib/number.vala"
			_tmp42_ = divisor;
#line 945 "../lib/number.vala"
			_tmp43_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 945 "../lib/number.vala"
			_tmp44_ = _tmp43_;
#line 945 "../lib/number.vala"
			_tmp45_ = number_add (_tmp42_, _tmp44_);
#line 945 "../lib/number.vala"
			_g_object_unref0 (tmp);
#line 945 "../lib/number.vala"
			tmp = _tmp45_;
#line 945 "../lib/number.vala"
			_g_object_unref0 (_tmp44_);
#line 946 "../lib/number.vala"
			_tmp46_ = tmp;
#line 946 "../lib/number.vala"
			_tmp47_ = _g_object_ref0 (_tmp46_);
#line 946 "../lib/number.vala"
			_g_object_unref0 (divisor);
#line 946 "../lib/number.vala"
			divisor = _tmp47_;
#line 4242 "number.c"
		}
#line 934 "../lib/number.vala"
		_g_object_unref0 (tmp);
#line 4246 "number.c"
	}
#line 950 "../lib/number.vala"
	_tmp48_ = value;
#line 950 "../lib/number.vala"
	_tmp49_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 950 "../lib/number.vala"
	_tmp50_ = _tmp49_;
#line 950 "../lib/number.vala"
	_tmp51_ = number_compare (_tmp48_, _tmp50_) > 0;
#line 950 "../lib/number.vala"
	_g_object_unref0 (_tmp50_);
#line 950 "../lib/number.vala"
	if (_tmp51_) {
#line 4260 "number.c"
		Number* _tmp52_;
		Number* _tmp53_;
#line 951 "../lib/number.vala"
		_tmp52_ = value;
#line 951 "../lib/number.vala"
		_tmp53_ = _g_object_ref0 (_tmp52_);
#line 951 "../lib/number.vala"
		factors = g_list_append (factors, _tmp53_);
#line 4269 "number.c"
	}
#line 953 "../lib/number.vala"
	if (number_is_negative (self)) {
#line 4273 "number.c"
		GList* _tmp54_;
		GList* _tmp55_;
		gconstpointer _tmp56_;
		Number* _tmp57_;
#line 954 "../lib/number.vala"
		_tmp54_ = factors;
#line 954 "../lib/number.vala"
		_tmp55_ = factors;
#line 954 "../lib/number.vala"
		_tmp56_ = _tmp55_->data;
#line 954 "../lib/number.vala"
		_tmp57_ = number_invert_sign ((Number*) _tmp56_);
#line 954 "../lib/number.vala"
		_g_object_unref0 (_tmp54_->data);
#line 954 "../lib/number.vala"
		_tmp54_->data = _tmp57_;
#line 4290 "number.c"
	}
#line 956 "../lib/number.vala"
	result = factors;
#line 956 "../lib/number.vala"
	_g_object_unref0 (root);
#line 956 "../lib/number.vala"
	_g_object_unref0 (divisor);
#line 956 "../lib/number.vala"
	_g_object_unref0 (int_max);
#line 956 "../lib/number.vala"
	_g_object_unref0 (value);
#line 956 "../lib/number.vala"
	return result;
#line 4304 "number.c"
}

GList*
number_factorize_uint64 (Number* self,
                         guint64 n)
{
	GList* result = NULL;
	GList* factors = NULL;
#line 959 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 961 "../lib/number.vala"
	factors = NULL;
#line 962 "../lib/number.vala"
	while (TRUE) {
#line 4319 "number.c"
		Number* _tmp0_;
#line 962 "../lib/number.vala"
		if (!((n % 2) == ((guint64) 0))) {
#line 962 "../lib/number.vala"
			break;
#line 4325 "number.c"
		}
#line 964 "../lib/number.vala"
		n = n / 2;
#line 965 "../lib/number.vala"
		_tmp0_ = number_new_unsigned_integer ((guint64) 2, (guint64) 0);
#line 965 "../lib/number.vala"
		factors = g_list_append (factors, _tmp0_);
#line 4333 "number.c"
	}
	{
		guint64 divisor = 0ULL;
#line 968 "../lib/number.vala"
		divisor = (guint64) 3;
#line 4339 "number.c"
		{
			gboolean _tmp1_ = FALSE;
#line 968 "../lib/number.vala"
			_tmp1_ = TRUE;
#line 968 "../lib/number.vala"
			while (TRUE) {
#line 968 "../lib/number.vala"
				if (!_tmp1_) {
#line 968 "../lib/number.vala"
					divisor = divisor + 2;
#line 4350 "number.c"
				}
#line 968 "../lib/number.vala"
				_tmp1_ = FALSE;
#line 968 "../lib/number.vala"
				if (!(divisor <= (n / divisor))) {
#line 968 "../lib/number.vala"
					break;
#line 4358 "number.c"
				}
#line 970 "../lib/number.vala"
				while (TRUE) {
#line 4362 "number.c"
					Number* _tmp2_;
#line 970 "../lib/number.vala"
					if (!((n % divisor) == ((guint64) 0))) {
#line 970 "../lib/number.vala"
						break;
#line 4368 "number.c"
					}
#line 972 "../lib/number.vala"
					n = n / divisor;
#line 973 "../lib/number.vala"
					_tmp2_ = number_new_unsigned_integer (divisor, (guint64) 0);
#line 973 "../lib/number.vala"
					factors = g_list_append (factors, _tmp2_);
#line 4376 "number.c"
				}
			}
		}
	}
#line 977 "../lib/number.vala"
	if (n > ((guint64) 1)) {
#line 4383 "number.c"
		Number* _tmp3_;
#line 978 "../lib/number.vala"
		_tmp3_ = number_new_unsigned_integer (n, (guint64) 0);
#line 978 "../lib/number.vala"
		factors = g_list_append (factors, _tmp3_);
#line 4389 "number.c"
	}
#line 979 "../lib/number.vala"
	result = factors;
#line 979 "../lib/number.vala"
	return result;
#line 4395 "number.c"
}

static Number*
number_copy (Number* self)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 982 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 984 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 984 "../lib/number.vala"
	z = _tmp0_;
#line 985 "../lib/number.vala"
	mpc_set (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 986 "../lib/number.vala"
	result = z;
#line 986 "../lib/number.vala"
	return result;
#line 4416 "number.c"
}

static gboolean
_mpc_equal (const __mpc_struct * s1,
            const __mpc_struct * s2)
{
#line 997 "../lib/number.vala"
	if (s1 == s2) {
#line 997 "../lib/number.vala"
		return TRUE;
#line 4427 "number.c"
	}
#line 997 "../lib/number.vala"
	if (s1 == NULL) {
#line 997 "../lib/number.vala"
		return FALSE;
#line 4433 "number.c"
	}
#line 997 "../lib/number.vala"
	if (s2 == NULL) {
#line 997 "../lib/number.vala"
		return FALSE;
#line 4439 "number.c"
	}
#line 997 "../lib/number.vala"
	return FALSE;
#line 4443 "number.c"
}

static void
number_mpc_from_radians (__mpc_struct* res,
                         __mpc_struct* op,
                         AngleUnit unit)
{
	gint i = 0;
	__mpfr_struct scale = {0};
	mpfr_prec_t _tmp1_;
	mpfr_prec_t _tmp2_;
	__mpc_struct _tmp3_;
#line 989 "../lib/number.vala"
	g_return_if_fail (res != NULL);
#line 989 "../lib/number.vala"
	g_return_if_fail (op != NULL);
#line 993 "../lib/number.vala"
	switch (unit) {
#line 4462 "number.c"
		default:
#line 993 "../lib/number.vala"
		case ANGLE_UNIT_RADIANS:
#line 4466 "number.c"
		{
#line 997 "../lib/number.vala"
			if (_mpc_equal (res, op) != TRUE) {
#line 4470 "number.c"
				__mpc_struct _tmp0_;
#line 998 "../lib/number.vala"
				_tmp0_ = *op;
#line 998 "../lib/number.vala"
				mpc_set (res, &_tmp0_, MPC_RNDNN);
#line 4476 "number.c"
			}
#line 999 "../lib/number.vala"
			return;
#line 4480 "number.c"
		}
#line 993 "../lib/number.vala"
		case ANGLE_UNIT_DEGREES:
#line 4484 "number.c"
		{
#line 1002 "../lib/number.vala"
			i = 180;
#line 1003 "../lib/number.vala"
			break;
#line 4490 "number.c"
		}
#line 993 "../lib/number.vala"
		case ANGLE_UNIT_GRADIANS:
#line 4494 "number.c"
		{
#line 1006 "../lib/number.vala"
			i = 200;
#line 1007 "../lib/number.vala"
			break;
#line 4500 "number.c"
		}
	}
#line 1010 "../lib/number.vala"
	_tmp1_ = number_get_precision ();
#line 1010 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 1010 "../lib/number.vala"
	mpfr_init2 (&scale, _tmp2_);
#line 1011 "../lib/number.vala"
	mpfr_const_pi (&scale, MPFR_RNDN);
#line 1012 "../lib/number.vala"
	mpfr_si_div (&scale, (glong) i, &scale, MPFR_RNDN);
#line 1013 "../lib/number.vala"
	_tmp3_ = *op;
#line 1013 "../lib/number.vala"
	mpc_mul_fr (res, &_tmp3_, &scale, MPC_RNDNN);
#line 989 "../lib/number.vala"
	mpfr_clear (&scale);
#line 4519 "number.c"
}

static void
number_mpc_to_radians (__mpc_struct* res,
                       __mpc_struct* op,
                       AngleUnit unit)
{
	gint i = 0;
	__mpfr_struct scale = {0};
	mpfr_prec_t _tmp1_;
	mpfr_prec_t _tmp2_;
	__mpc_struct _tmp3_;
#line 1016 "../lib/number.vala"
	g_return_if_fail (res != NULL);
#line 1016 "../lib/number.vala"
	g_return_if_fail (op != NULL);
#line 1020 "../lib/number.vala"
	switch (unit) {
#line 4538 "number.c"
		default:
#line 1020 "../lib/number.vala"
		case ANGLE_UNIT_RADIANS:
#line 4542 "number.c"
		{
#line 1024 "../lib/number.vala"
			if (_mpc_equal (res, op) != TRUE) {
#line 4546 "number.c"
				__mpc_struct _tmp0_;
#line 1025 "../lib/number.vala"
				_tmp0_ = *op;
#line 1025 "../lib/number.vala"
				mpc_set (res, &_tmp0_, MPC_RNDNN);
#line 4552 "number.c"
			}
#line 1026 "../lib/number.vala"
			return;
#line 4556 "number.c"
		}
#line 1020 "../lib/number.vala"
		case ANGLE_UNIT_DEGREES:
#line 4560 "number.c"
		{
#line 1029 "../lib/number.vala"
			i = 180;
#line 1030 "../lib/number.vala"
			break;
#line 4566 "number.c"
		}
#line 1020 "../lib/number.vala"
		case ANGLE_UNIT_GRADIANS:
#line 4570 "number.c"
		{
#line 1033 "../lib/number.vala"
			i = 200;
#line 1034 "../lib/number.vala"
			break;
#line 4576 "number.c"
		}
	}
#line 1036 "../lib/number.vala"
	_tmp1_ = number_get_precision ();
#line 1036 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 1036 "../lib/number.vala"
	mpfr_init2 (&scale, _tmp2_);
#line 1037 "../lib/number.vala"
	mpfr_const_pi (&scale, MPFR_RNDN);
#line 1038 "../lib/number.vala"
	mpfr_div_si (&scale, &scale, (glong) i, MPFR_RNDN);
#line 1039 "../lib/number.vala"
	_tmp3_ = *op;
#line 1039 "../lib/number.vala"
	mpc_mul_fr (res, &_tmp3_, &scale, MPC_RNDNN);
#line 1016 "../lib/number.vala"
	mpfr_clear (&scale);
#line 4595 "number.c"
}

static Number*
number_to_radians (Number* self,
                   AngleUnit unit)
{
	Number* result = NULL;
	Number* z = NULL;
	Number* _tmp0_;
#line 1043 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1045 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 1045 "../lib/number.vala"
	z = _tmp0_;
#line 1046 "../lib/number.vala"
	number_mpc_to_radians (&z->priv->num, &self->priv->num, unit);
#line 1047 "../lib/number.vala"
	result = z;
#line 1047 "../lib/number.vala"
	return result;
#line 4617 "number.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 4634 "number.c"
}

static Number*
number_bitwise (Number* self,
                Number* y,
                BitwiseFunc bitwise_operator,
                gpointer bitwise_operator_target,
                gint wordlen)
{
	Number* result = NULL;
	gchar* text1 = NULL;
	gchar* _tmp0_;
	gchar* text2 = NULL;
	gchar* _tmp1_;
	gint offset1 = 0;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint offset2 = 0;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint offset_out = 0;
	gboolean _tmp9_ = FALSE;
	gchar* text_out = NULL;
	gchar* _tmp12_;
	gint text_out_length1;
	gint _text_out_size_;
	gchar* _tmp22_;
	gint _tmp22__length1;
	Number* _tmp23_;
#line 1050 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1050 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 1052 "../lib/number.vala"
	_tmp0_ = number_to_hex_string (self);
#line 1052 "../lib/number.vala"
	text1 = _tmp0_;
#line 1053 "../lib/number.vala"
	_tmp1_ = number_to_hex_string (y);
#line 1053 "../lib/number.vala"
	text2 = _tmp1_;
#line 1054 "../lib/number.vala"
	_tmp2_ = text1;
#line 1054 "../lib/number.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1054 "../lib/number.vala"
	_tmp4_ = _tmp3_;
#line 1054 "../lib/number.vala"
	offset1 = _tmp4_ - 1;
#line 1055 "../lib/number.vala"
	_tmp5_ = text2;
#line 1055 "../lib/number.vala"
	_tmp6_ = strlen (_tmp5_);
#line 1055 "../lib/number.vala"
	_tmp7_ = _tmp6_;
#line 1055 "../lib/number.vala"
	offset2 = _tmp7_ - 1;
#line 1056 "../lib/number.vala"
	offset_out = (wordlen / 4) - 1;
#line 1057 "../lib/number.vala"
	if (offset_out <= 0) {
#line 4698 "number.c"
		gint _tmp8_ = 0;
#line 1058 "../lib/number.vala"
		if (offset1 > offset2) {
#line 1058 "../lib/number.vala"
			_tmp8_ = offset1;
#line 4704 "number.c"
		} else {
#line 1058 "../lib/number.vala"
			_tmp8_ = offset2;
#line 4708 "number.c"
		}
#line 1058 "../lib/number.vala"
		offset_out = _tmp8_;
#line 4712 "number.c"
	}
#line 1059 "../lib/number.vala"
	if (offset_out > 0) {
#line 4716 "number.c"
		gboolean _tmp10_ = FALSE;
#line 1059 "../lib/number.vala"
		if (offset_out < offset1) {
#line 1059 "../lib/number.vala"
			_tmp10_ = TRUE;
#line 4722 "number.c"
		} else {
#line 1059 "../lib/number.vala"
			_tmp10_ = offset_out < offset2;
#line 4726 "number.c"
		}
#line 1059 "../lib/number.vala"
		_tmp9_ = _tmp10_;
#line 4730 "number.c"
	} else {
#line 1059 "../lib/number.vala"
		_tmp9_ = FALSE;
#line 4734 "number.c"
	}
#line 1059 "../lib/number.vala"
	if (_tmp9_) {
#line 4738 "number.c"
		Number* _tmp11_;
#line 1061 "../lib/number.vala"
		number_set_error ("Overflow. Try a bigger word size");
#line 1062 "../lib/number.vala"
		_tmp11_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1062 "../lib/number.vala"
		result = _tmp11_;
#line 1062 "../lib/number.vala"
		_g_free0 (text2);
#line 1062 "../lib/number.vala"
		_g_free0 (text1);
#line 1062 "../lib/number.vala"
		return result;
#line 4752 "number.c"
	}
#line 1065 "../lib/number.vala"
	_tmp12_ = g_new0 (gchar, offset_out + 2);
#line 1065 "../lib/number.vala"
	text_out = _tmp12_;
#line 1065 "../lib/number.vala"
	text_out_length1 = offset_out + 2;
#line 1065 "../lib/number.vala"
	_text_out_size_ = text_out_length1;
#line 4762 "number.c"
	{
		gchar* _tmp13_;
		gint _tmp13__length1;
		gboolean _tmp14_ = FALSE;
#line 1068 "../lib/number.vala"
		_tmp13_ = text_out;
#line 1068 "../lib/number.vala"
		_tmp13__length1 = text_out_length1;
#line 1068 "../lib/number.vala"
		_tmp13_[offset_out + 1] = '\0';
#line 1068 "../lib/number.vala"
		_tmp14_ = TRUE;
#line 1068 "../lib/number.vala"
		while (TRUE) {
#line 4777 "number.c"
			gint v1 = 0;
			gint v2 = 0;
#line 1071 "../lib/number.vala"
			static const gchar digits[16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
#line 4782 "number.c"
			gchar* _tmp20_;
			gint _tmp20__length1;
			gchar _tmp21_;
#line 1068 "../lib/number.vala"
			if (!_tmp14_) {
#line 4788 "number.c"
				gint _tmp15_;
#line 1068 "../lib/number.vala"
				_tmp15_ = offset_out;
#line 1068 "../lib/number.vala"
				offset_out = _tmp15_ - 1;
#line 4794 "number.c"
			}
#line 1068 "../lib/number.vala"
			_tmp14_ = FALSE;
#line 1068 "../lib/number.vala"
			if (!(offset_out >= 0)) {
#line 1068 "../lib/number.vala"
				break;
#line 4802 "number.c"
			}
#line 1070 "../lib/number.vala"
			v1 = 0;
#line 1070 "../lib/number.vala"
			v2 = 0;
#line 1073 "../lib/number.vala"
			if (offset1 >= 0) {
#line 4810 "number.c"
				const gchar* _tmp16_;
				gint _tmp17_;
#line 1075 "../lib/number.vala"
				_tmp16_ = text1;
#line 1075 "../lib/number.vala"
				v1 = number_hex_to_int (self, string_get (_tmp16_, (glong) offset1));
#line 1076 "../lib/number.vala"
				_tmp17_ = offset1;
#line 1076 "../lib/number.vala"
				offset1 = _tmp17_ - 1;
#line 4821 "number.c"
			}
#line 1078 "../lib/number.vala"
			if (offset2 >= 0) {
#line 4825 "number.c"
				const gchar* _tmp18_;
				gint _tmp19_;
#line 1080 "../lib/number.vala"
				_tmp18_ = text2;
#line 1080 "../lib/number.vala"
				v2 = number_hex_to_int (self, string_get (_tmp18_, (glong) offset2));
#line 1081 "../lib/number.vala"
				_tmp19_ = offset2;
#line 1081 "../lib/number.vala"
				offset2 = _tmp19_ - 1;
#line 4836 "number.c"
			}
#line 1083 "../lib/number.vala"
			_tmp20_ = text_out;
#line 1083 "../lib/number.vala"
			_tmp20__length1 = text_out_length1;
#line 1083 "../lib/number.vala"
			_tmp21_ = digits[bitwise_operator (v1, v2, bitwise_operator_target)];
#line 1083 "../lib/number.vala"
			_tmp20_[offset_out] = _tmp21_;
#line 4846 "number.c"
		}
	}
#line 1086 "../lib/number.vala"
	_tmp22_ = text_out;
#line 1086 "../lib/number.vala"
	_tmp22__length1 = text_out_length1;
#line 1086 "../lib/number.vala"
	_tmp23_ = mp_set_from_string ((const gchar*) _tmp22_, 16);
#line 1086 "../lib/number.vala"
	result = _tmp23_;
#line 1086 "../lib/number.vala"
	text_out = (g_free (text_out), NULL);
#line 1086 "../lib/number.vala"
	_g_free0 (text2);
#line 1086 "../lib/number.vala"
	_g_free0 (text1);
#line 1086 "../lib/number.vala"
	return result;
#line 4865 "number.c"
}

static gint
number_hex_to_int (Number* self,
                   gchar digit)
{
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 1089 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1091 "../lib/number.vala"
	if (digit >= '0') {
#line 1091 "../lib/number.vala"
		_tmp0_ = digit <= '9';
#line 4882 "number.c"
	} else {
#line 1091 "../lib/number.vala"
		_tmp0_ = FALSE;
#line 4886 "number.c"
	}
#line 1091 "../lib/number.vala"
	if (_tmp0_) {
#line 1092 "../lib/number.vala"
		result = (gint) (digit - '0');
#line 1092 "../lib/number.vala"
		return result;
#line 4894 "number.c"
	}
#line 1093 "../lib/number.vala"
	if (digit >= 'A') {
#line 1093 "../lib/number.vala"
		_tmp1_ = digit <= 'F';
#line 4900 "number.c"
	} else {
#line 1093 "../lib/number.vala"
		_tmp1_ = FALSE;
#line 4904 "number.c"
	}
#line 1093 "../lib/number.vala"
	if (_tmp1_) {
#line 1094 "../lib/number.vala"
		result = (digit - 'A') + 10;
#line 1094 "../lib/number.vala"
		return result;
#line 4912 "number.c"
	}
#line 1095 "../lib/number.vala"
	if (digit >= 'a') {
#line 1095 "../lib/number.vala"
		_tmp2_ = digit <= 'f';
#line 4918 "number.c"
	} else {
#line 1095 "../lib/number.vala"
		_tmp2_ = FALSE;
#line 4922 "number.c"
	}
#line 1095 "../lib/number.vala"
	if (_tmp2_) {
#line 1096 "../lib/number.vala"
		result = (digit - 'a') + 10;
#line 1096 "../lib/number.vala"
		return result;
#line 4930 "number.c"
	}
#line 1097 "../lib/number.vala"
	result = 0;
#line 1097 "../lib/number.vala"
	return result;
#line 4936 "number.c"
}

static gchar*
number_to_hex_string (Number* self)
{
	gchar* result = NULL;
	Serializer* serializer = NULL;
	Serializer* _tmp0_;
	gchar* _tmp1_;
#line 1100 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1102 "../lib/number.vala"
	_tmp0_ = serializer_new (DISPLAY_FORMAT_FIXED, 16, 0);
#line 1102 "../lib/number.vala"
	serializer = _tmp0_;
#line 1103 "../lib/number.vala"
	_tmp1_ = serializer_to_string (serializer, self);
#line 1103 "../lib/number.vala"
	result = _tmp1_;
#line 1103 "../lib/number.vala"
	_g_object_unref0 (serializer);
#line 1103 "../lib/number.vala"
	return result;
#line 4960 "number.c"
}

Number*
number_construct (GType object_type)
{
	Number * self = NULL;
#line 41 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 41 "../lib/number.vala"
	return self;
#line 4971 "number.c"
}

Number*
number_new (void)
{
#line 41 "../lib/number.vala"
	return number_construct (TYPE_NUMBER);
#line 4979 "number.c"
}

mpfr_prec_t
number_get_precision (void)
{
	mpfr_prec_t result;
#line 46 "../lib/number.vala"
	result = number__precision;
#line 46 "../lib/number.vala"
	return result;
#line 4990 "number.c"
}

void
number_set_precision (mpfr_prec_t value)
{
#line 46 "../lib/number.vala"
	number__precision = value;
#line 4998 "number.c"
}

const gchar*
number_get_error (void)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "../lib/number.vala"
	_tmp0_ = number__error;
#line 49 "../lib/number.vala"
	result = _tmp0_;
#line 49 "../lib/number.vala"
	return result;
#line 5012 "number.c"
}

void
number_set_error (const gchar* value)
{
	gchar* _tmp0_;
#line 49 "../lib/number.vala"
	_tmp0_ = g_strdup (value);
#line 49 "../lib/number.vala"
	_g_free0 (number__error);
#line 49 "../lib/number.vala"
	number__error = _tmp0_;
#line 5025 "number.c"
}

static void
number_class_init (NumberClass * klass,
                   gpointer klass_data)
{
#line 41 "../lib/number.vala"
	number_parent_class = g_type_class_peek_parent (klass);
#line 41 "../lib/number.vala"
	g_type_class_adjust_private_offset (klass, &Number_private_offset);
#line 41 "../lib/number.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_number_get_property;
#line 41 "../lib/number.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_number_set_property;
#line 41 "../lib/number.vala"
	G_OBJECT_CLASS (klass)->finalize = number_finalize;
#line 5042 "number.c"
}

static void
number_instance_init (Number * self,
                      gpointer klass)
{
	mpfr_prec_t _tmp0_;
	mpfr_prec_t _tmp1_;
#line 41 "../lib/number.vala"
	self->priv = number_get_instance_private (self);
#line 44 "../lib/number.vala"
	_tmp0_ = number_get_precision ();
#line 44 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 44 "../lib/number.vala"
	mpc_init2 (&self->priv->num, _tmp1_);
#line 5059 "number.c"
}

static void
number_finalize (GObject * obj)
{
	Number * self;
#line 41 "../lib/number.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NUMBER, Number);
#line 44 "../lib/number.vala"
	mpc_clear (&self->priv->num);
#line 41 "../lib/number.vala"
	G_OBJECT_CLASS (number_parent_class)->finalize (obj);
#line 5072 "number.c"
}

GType
number_get_type (void)
{
	static volatile gsize number_type_id__volatile = 0;
	if (g_once_init_enter (&number_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NumberClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) number_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Number), 0, (GInstanceInitFunc) number_instance_init, NULL };
		GType number_type_id;
		number_type_id = g_type_register_static (G_TYPE_OBJECT, "Number", &g_define_type_info, 0);
		Number_private_offset = g_type_add_instance_private (number_type_id, sizeof (NumberPrivate));
		g_once_init_leave (&number_type_id__volatile, number_type_id);
	}
	return number_type_id__volatile;
}

static void
_vala_number_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Number * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NUMBER, Number);
#line 41 "../lib/number.vala"
	switch (property_id) {
#line 5099 "number.c"
		default:
#line 41 "../lib/number.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../lib/number.vala"
		break;
#line 5105 "number.c"
	}
}

static void
_vala_number_set_property (GObject * object,
                           guint property_id,
                           const GValue * value,
                           GParamSpec * pspec)
{
	Number * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NUMBER, Number);
#line 41 "../lib/number.vala"
	switch (property_id) {
#line 5119 "number.c"
		default:
#line 41 "../lib/number.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../lib/number.vala"
		break;
#line 5125 "number.c"
	}
}

gint
parse_literal_prefix (const gchar* str,
                      gint* prefix_len)
{
	gint result = 0;
	gint new_base = 0;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gchar prefix = '\0';
#line 1107 "../lib/number.vala"
	g_return_val_if_fail (str != NULL, 0);
#line 1109 "../lib/number.vala"
	new_base = 0;
#line 1111 "../lib/number.vala"
	_tmp1_ = strlen (str);
#line 1111 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 1111 "../lib/number.vala"
	if (_tmp2_ < 3) {
#line 1111 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 5151 "number.c"
	} else {
#line 1111 "../lib/number.vala"
		_tmp0_ = string_get (str, (glong) 0) != '0';
#line 5155 "number.c"
	}
#line 1111 "../lib/number.vala"
	if (_tmp0_) {
#line 1112 "../lib/number.vala"
		result = new_base;
#line 1112 "../lib/number.vala"
		return result;
#line 5163 "number.c"
	}
#line 1114 "../lib/number.vala"
	prefix = g_ascii_tolower (string_get (str, (glong) 1));
#line 1116 "../lib/number.vala"
	if (prefix == 'b') {
#line 1117 "../lib/number.vala"
		new_base = 2;
#line 5171 "number.c"
	} else {
#line 1118 "../lib/number.vala"
		if (prefix == 'o') {
#line 1119 "../lib/number.vala"
			new_base = 8;
#line 5177 "number.c"
		} else {
#line 1120 "../lib/number.vala"
			if (prefix == 'x') {
#line 1121 "../lib/number.vala"
				new_base = 16;
#line 5183 "number.c"
			}
		}
	}
#line 1123 "../lib/number.vala"
	if (new_base != 0) {
#line 1124 "../lib/number.vala"
		*prefix_len = 2;
#line 5191 "number.c"
	}
#line 1126 "../lib/number.vala"
	result = new_base;
#line 1126 "../lib/number.vala"
	return result;
#line 5197 "number.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1101 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1102 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1102 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1104 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1104 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 5219 "number.c"
		gchar* _tmp2_;
#line 1105 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1105 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1105 "glib-2.0.vapi"
		return result;
#line 5227 "number.c"
	} else {
#line 1107 "glib-2.0.vapi"
		result = -1;
#line 1107 "glib-2.0.vapi"
		return result;
#line 5233 "number.c"
	}
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
#line 1199 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1200 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1201 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 5250 "number.c"
		gchar* _tmp0_;
#line 1202 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1202 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1203 "glib-2.0.vapi"
		result = TRUE;
#line 1203 "glib-2.0.vapi"
		if (c) {
#line 1203 "glib-2.0.vapi"
			*c = _vala_c;
#line 5262 "number.c"
		}
#line 1203 "glib-2.0.vapi"
		return result;
#line 5266 "number.c"
	} else {
#line 1205 "glib-2.0.vapi"
		result = FALSE;
#line 1205 "glib-2.0.vapi"
		if (c) {
#line 1205 "glib-2.0.vapi"
			*c = _vala_c;
#line 5274 "number.c"
		}
#line 1205 "glib-2.0.vapi"
		return result;
#line 5278 "number.c"
	}
#line 1199 "glib-2.0.vapi"
	if (c) {
#line 1199 "glib-2.0.vapi"
		*c = _vala_c;
#line 5284 "number.c"
	}
}

static gboolean
string_get_prev_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
#line 1238 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1239 "glib-2.0.vapi"
	if (0 < (*index)) {
#line 5299 "number.c"
		gchar* _tmp0_;
#line 1240 "glib-2.0.vapi"
		_tmp0_ = g_utf8_prev_char (((gchar*) self) + (*index));
#line 1240 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1241 "glib-2.0.vapi"
		_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1242 "glib-2.0.vapi"
		result = TRUE;
#line 1242 "glib-2.0.vapi"
		if (c) {
#line 1242 "glib-2.0.vapi"
			*c = _vala_c;
#line 5313 "number.c"
		}
#line 1242 "glib-2.0.vapi"
		return result;
#line 5317 "number.c"
	} else {
#line 1244 "glib-2.0.vapi"
		_vala_c = (gunichar) 0;
#line 1245 "glib-2.0.vapi"
		result = FALSE;
#line 1245 "glib-2.0.vapi"
		if (c) {
#line 1245 "glib-2.0.vapi"
			*c = _vala_c;
#line 5327 "number.c"
		}
#line 1245 "glib-2.0.vapi"
		return result;
#line 5331 "number.c"
	}
#line 1238 "glib-2.0.vapi"
	if (c) {
#line 1238 "glib-2.0.vapi"
		*c = _vala_c;
#line 5337 "number.c"
	}
}

Number*
mp_set_from_string (const gchar* str,
                    gint default_base)
{
	Number* result = NULL;
#line 1140 "../lib/number.vala"
	static const gunichar base_digits[10] = {8320U, 8321U, 8322U, 8323U, 8324U, 8325U, 8326U, 8327U, 8328U, 8329U};
#line 5348 "number.c"
	gint index = 0;
	gint base_prefix = 0;
	gunichar c = 0U;
	gint end = 0;
	gint number_base = 0;
	gint literal_base = 0;
	gint base_multiplier = 0;
	gint _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean negate = FALSE;
	gunichar _tmp12_ = 0U;
	Number* z = NULL;
	Number* _tmp15_;
#line 1205 "../lib/number.vala"
	static const gunichar fractions[15] = {189U, 8531U, 8532U, 188U, 190U, 8533U, 8534U, 8535U, 8536U, 8537U, 8538U, 8539U, 8540U, 8541U, 8542U};
#line 1206 "../lib/number.vala"
	static const gint numerators[15] = {1, 1, 2, 1, 3, 1, 2, 3, 4, 1, 5, 1, 3, 5, 7};
#line 1207 "../lib/number.vala"
	static const gint denominators[15] = {2, 3, 3, 4, 4, 5, 5, 5, 5, 6, 6, 8, 8, 8, 8};
#line 5369 "number.c"
	gboolean has_fraction = FALSE;
	gunichar _tmp25_ = 0U;
	gboolean _tmp26_;
#line 1134 "../lib/number.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 1136 "../lib/number.vala"
	if (string_index_of_char (str, 176U, 0) >= 0) {
#line 5377 "number.c"
		Number* _tmp0_;
#line 1137 "../lib/number.vala"
		_tmp0_ = set_from_sexagesimal (str);
#line 1137 "../lib/number.vala"
		result = _tmp0_;
#line 1137 "../lib/number.vala"
		return result;
#line 5385 "number.c"
	}
#line 1141 "../lib/number.vala"
	index = 0;
#line 1142 "../lib/number.vala"
	base_prefix = 0;
#line 1144 "../lib/number.vala"
	while (TRUE) {
#line 5393 "number.c"
		gunichar _tmp1_ = 0U;
		gboolean _tmp2_;
#line 1144 "../lib/number.vala"
		_tmp2_ = string_get_next_char (str, &index, &_tmp1_);
#line 1144 "../lib/number.vala"
		c = _tmp1_;
#line 1144 "../lib/number.vala"
		if (!_tmp2_) {
#line 1144 "../lib/number.vala"
			break;
#line 5404 "number.c"
		}
	}
#line 1145 "../lib/number.vala"
	end = index;
#line 1146 "../lib/number.vala"
	number_base = 0;
#line 1147 "../lib/number.vala"
	literal_base = 0;
#line 1148 "../lib/number.vala"
	base_multiplier = 1;
#line 1149 "../lib/number.vala"
	while (TRUE) {
#line 5417 "number.c"
		gunichar _tmp3_ = 0U;
		gboolean _tmp4_;
		gint value = 0;
#line 1149 "../lib/number.vala"
		_tmp4_ = string_get_prev_char (str, &index, &_tmp3_);
#line 1149 "../lib/number.vala"
		c = _tmp3_;
#line 1149 "../lib/number.vala"
		if (!_tmp4_) {
#line 1149 "../lib/number.vala"
			break;
#line 5429 "number.c"
		}
#line 1151 "../lib/number.vala"
		value = -1;
#line 5433 "number.c"
		{
			gint i = 0;
#line 1152 "../lib/number.vala"
			i = 0;
#line 5438 "number.c"
			{
				gboolean _tmp5_ = FALSE;
#line 1152 "../lib/number.vala"
				_tmp5_ = TRUE;
#line 1152 "../lib/number.vala"
				while (TRUE) {
#line 5445 "number.c"
					gunichar _tmp7_;
#line 1152 "../lib/number.vala"
					if (!_tmp5_) {
#line 5449 "number.c"
						gint _tmp6_;
#line 1152 "../lib/number.vala"
						_tmp6_ = i;
#line 1152 "../lib/number.vala"
						i = _tmp6_ + 1;
#line 5455 "number.c"
					}
#line 1152 "../lib/number.vala"
					_tmp5_ = FALSE;
#line 1152 "../lib/number.vala"
					if (!(i < G_N_ELEMENTS (base_digits))) {
#line 1152 "../lib/number.vala"
						break;
#line 5463 "number.c"
					}
#line 1154 "../lib/number.vala"
					_tmp7_ = base_digits[i];
#line 1154 "../lib/number.vala"
					if (c == _tmp7_) {
#line 1156 "../lib/number.vala"
						value = i;
#line 1157 "../lib/number.vala"
						break;
#line 5473 "number.c"
					}
				}
			}
		}
#line 1160 "../lib/number.vala"
		if (value < 0) {
#line 1161 "../lib/number.vala"
			break;
#line 5482 "number.c"
		}
#line 1163 "../lib/number.vala"
		end = index;
#line 1164 "../lib/number.vala"
		number_base = number_base + (value * base_multiplier);
#line 1165 "../lib/number.vala"
		base_multiplier = base_multiplier * 10;
#line 5490 "number.c"
	}
#line 1168 "../lib/number.vala"
	_tmp8_ = parse_literal_prefix (str, &base_prefix);
#line 1168 "../lib/number.vala"
	literal_base = _tmp8_;
#line 1170 "../lib/number.vala"
	if (number_base != 0) {
#line 1170 "../lib/number.vala"
		_tmp10_ = literal_base != 0;
#line 5500 "number.c"
	} else {
#line 1170 "../lib/number.vala"
		_tmp10_ = FALSE;
#line 5504 "number.c"
	}
#line 1170 "../lib/number.vala"
	if (_tmp10_) {
#line 1170 "../lib/number.vala"
		_tmp9_ = literal_base != number_base;
#line 5510 "number.c"
	} else {
#line 1170 "../lib/number.vala"
		_tmp9_ = FALSE;
#line 5514 "number.c"
	}
#line 1170 "../lib/number.vala"
	if (_tmp9_) {
#line 1171 "../lib/number.vala"
		result = NULL;
#line 1171 "../lib/number.vala"
		return result;
#line 5522 "number.c"
	}
#line 1173 "../lib/number.vala"
	if (number_base == 0) {
#line 5526 "number.c"
		gint _tmp11_ = 0;
#line 1174 "../lib/number.vala"
		if (literal_base != 0) {
#line 1174 "../lib/number.vala"
			_tmp11_ = literal_base;
#line 5532 "number.c"
		} else {
#line 1174 "../lib/number.vala"
			_tmp11_ = default_base;
#line 5536 "number.c"
		}
#line 1174 "../lib/number.vala"
		number_base = _tmp11_;
#line 5540 "number.c"
	}
#line 1177 "../lib/number.vala"
	negate = FALSE;
#line 1178 "../lib/number.vala"
	index = base_prefix;
#line 1179 "../lib/number.vala"
	string_get_next_char (str, &index, &_tmp12_);
#line 1179 "../lib/number.vala"
	c = _tmp12_;
#line 1180 "../lib/number.vala"
	if (c == ((gunichar) '+')) {
#line 1181 "../lib/number.vala"
		negate = FALSE;
#line 5554 "number.c"
	} else {
		gboolean _tmp13_ = FALSE;
#line 1182 "../lib/number.vala"
		if (c == ((gunichar) '-')) {
#line 1182 "../lib/number.vala"
			_tmp13_ = TRUE;
#line 5561 "number.c"
		} else {
#line 1182 "../lib/number.vala"
			_tmp13_ = c == 8722U;
#line 5565 "number.c"
		}
#line 1182 "../lib/number.vala"
		if (_tmp13_) {
#line 1183 "../lib/number.vala"
			negate = TRUE;
#line 5571 "number.c"
		} else {
			gunichar _tmp14_ = 0U;
#line 1185 "../lib/number.vala"
			string_get_prev_char (str, &index, &_tmp14_);
#line 1185 "../lib/number.vala"
			c = _tmp14_;
#line 5578 "number.c"
		}
	}
#line 1188 "../lib/number.vala"
	_tmp15_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1188 "../lib/number.vala"
	z = _tmp15_;
#line 1190 "../lib/number.vala"
	while (TRUE) {
#line 5587 "number.c"
		gunichar _tmp16_ = 0U;
		gboolean _tmp17_;
		gint i = 0;
		Number* _tmp19_;
		Number* _tmp20_;
		Number* _tmp21_;
		Number* _tmp22_;
		Number* _tmp23_;
		Number* _tmp24_;
#line 1190 "../lib/number.vala"
		_tmp17_ = string_get_next_char (str, &index, &_tmp16_);
#line 1190 "../lib/number.vala"
		c = _tmp16_;
#line 1190 "../lib/number.vala"
		if (!_tmp17_) {
#line 1190 "../lib/number.vala"
			break;
#line 5605 "number.c"
		}
#line 1192 "../lib/number.vala"
		i = char_val (c, number_base);
#line 1193 "../lib/number.vala"
		if (i > number_base) {
#line 1194 "../lib/number.vala"
			result = NULL;
#line 1194 "../lib/number.vala"
			_g_object_unref0 (z);
#line 1194 "../lib/number.vala"
			return result;
#line 5617 "number.c"
		}
#line 1195 "../lib/number.vala"
		if (i < 0) {
#line 5621 "number.c"
			gunichar _tmp18_ = 0U;
#line 1197 "../lib/number.vala"
			string_get_prev_char (str, &index, &_tmp18_);
#line 1197 "../lib/number.vala"
			c = _tmp18_;
#line 1198 "../lib/number.vala"
			break;
#line 5629 "number.c"
		}
#line 1201 "../lib/number.vala"
		_tmp19_ = z;
#line 1201 "../lib/number.vala"
		_tmp20_ = number_multiply_integer (_tmp19_, (gint64) number_base);
#line 1201 "../lib/number.vala"
		_tmp21_ = _tmp20_;
#line 1201 "../lib/number.vala"
		_tmp22_ = number_new_integer ((gint64) i, (gint64) 0);
#line 1201 "../lib/number.vala"
		_tmp23_ = _tmp22_;
#line 1201 "../lib/number.vala"
		_tmp24_ = number_add (_tmp21_, _tmp23_);
#line 1201 "../lib/number.vala"
		_g_object_unref0 (z);
#line 1201 "../lib/number.vala"
		z = _tmp24_;
#line 1201 "../lib/number.vala"
		_g_object_unref0 (_tmp23_);
#line 1201 "../lib/number.vala"
		_g_object_unref0 (_tmp21_);
#line 5651 "number.c"
	}
#line 1208 "../lib/number.vala"
	has_fraction = FALSE;
#line 1209 "../lib/number.vala"
	_tmp26_ = string_get_next_char (str, &index, &_tmp25_);
#line 1209 "../lib/number.vala"
	c = _tmp25_;
#line 1209 "../lib/number.vala"
	if (_tmp26_) {
#line 5661 "number.c"
		{
			gint i = 0;
#line 1211 "../lib/number.vala"
			i = 0;
#line 5666 "number.c"
			{
				gboolean _tmp27_ = FALSE;
#line 1211 "../lib/number.vala"
				_tmp27_ = TRUE;
#line 1211 "../lib/number.vala"
				while (TRUE) {
#line 5673 "number.c"
					gunichar _tmp29_;
#line 1211 "../lib/number.vala"
					if (!_tmp27_) {
#line 5677 "number.c"
						gint _tmp28_;
#line 1211 "../lib/number.vala"
						_tmp28_ = i;
#line 1211 "../lib/number.vala"
						i = _tmp28_ + 1;
#line 5683 "number.c"
					}
#line 1211 "../lib/number.vala"
					_tmp27_ = FALSE;
#line 1211 "../lib/number.vala"
					if (!(i < G_N_ELEMENTS (fractions))) {
#line 1211 "../lib/number.vala"
						break;
#line 5691 "number.c"
					}
#line 1213 "../lib/number.vala"
					_tmp29_ = fractions[i];
#line 1213 "../lib/number.vala"
					if (c == _tmp29_) {
#line 5697 "number.c"
						Number* fraction = NULL;
						gint _tmp30_;
						gint _tmp31_;
						Number* _tmp32_;
						Number* _tmp33_;
						Number* _tmp34_;
						Number* _tmp35_;
						gunichar _tmp36_ = 0U;
						gboolean _tmp37_;
#line 1215 "../lib/number.vala"
						_tmp30_ = numerators[i];
#line 1215 "../lib/number.vala"
						_tmp31_ = denominators[i];
#line 1215 "../lib/number.vala"
						_tmp32_ = number_new_fraction ((gint64) _tmp30_, (gint64) _tmp31_);
#line 1215 "../lib/number.vala"
						fraction = _tmp32_;
#line 1216 "../lib/number.vala"
						_tmp33_ = z;
#line 1216 "../lib/number.vala"
						_tmp34_ = fraction;
#line 1216 "../lib/number.vala"
						_tmp35_ = number_add (_tmp33_, _tmp34_);
#line 1216 "../lib/number.vala"
						_g_object_unref0 (z);
#line 1216 "../lib/number.vala"
						z = _tmp35_;
#line 1219 "../lib/number.vala"
						_tmp37_ = string_get_next_char (str, &index, &_tmp36_);
#line 1219 "../lib/number.vala"
						c = _tmp36_;
#line 1219 "../lib/number.vala"
						if (!_tmp37_) {
#line 1220 "../lib/number.vala"
							result = z;
#line 1220 "../lib/number.vala"
							_g_object_unref0 (fraction);
#line 1220 "../lib/number.vala"
							return result;
#line 5737 "number.c"
						} else {
#line 1222 "../lib/number.vala"
							result = NULL;
#line 1222 "../lib/number.vala"
							_g_object_unref0 (fraction);
#line 1222 "../lib/number.vala"
							_g_object_unref0 (z);
#line 1222 "../lib/number.vala"
							return result;
#line 5747 "number.c"
						}
#line 1213 "../lib/number.vala"
						_g_object_unref0 (fraction);
#line 5751 "number.c"
					}
				}
			}
		}
#line 1227 "../lib/number.vala"
		if (c == ((gunichar) '.')) {
#line 1228 "../lib/number.vala"
			has_fraction = TRUE;
#line 5760 "number.c"
		} else {
			gunichar _tmp38_ = 0U;
#line 1230 "../lib/number.vala"
			string_get_prev_char (str, &index, &_tmp38_);
#line 1230 "../lib/number.vala"
			c = _tmp38_;
#line 5767 "number.c"
		}
	}
#line 1234 "../lib/number.vala"
	if (has_fraction) {
#line 5772 "number.c"
		Number* numerator = NULL;
		Number* _tmp39_;
		Number* denominator = NULL;
		Number* _tmp40_;
		Number* _tmp52_;
		Number* _tmp53_;
		Number* _tmp54_;
		Number* _tmp55_;
		Number* _tmp56_;
		Number* _tmp57_;
#line 1236 "../lib/number.vala"
		_tmp39_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1236 "../lib/number.vala"
		numerator = _tmp39_;
#line 1237 "../lib/number.vala"
		_tmp40_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 1237 "../lib/number.vala"
		denominator = _tmp40_;
#line 1239 "../lib/number.vala"
		while (TRUE) {
#line 5793 "number.c"
			gunichar _tmp41_ = 0U;
			gboolean _tmp42_;
			gint i = 0;
			Number* _tmp44_;
			Number* _tmp45_;
			Number* _tmp46_;
			Number* _tmp47_;
			Number* _tmp48_;
			Number* _tmp49_;
			Number* _tmp50_;
			Number* _tmp51_;
#line 1239 "../lib/number.vala"
			_tmp42_ = string_get_next_char (str, &index, &_tmp41_);
#line 1239 "../lib/number.vala"
			c = _tmp41_;
#line 1239 "../lib/number.vala"
			if (!_tmp42_) {
#line 1239 "../lib/number.vala"
				break;
#line 5813 "number.c"
			}
#line 1241 "../lib/number.vala"
			i = char_val (c, number_base);
#line 1242 "../lib/number.vala"
			if (i < 0) {
#line 5819 "number.c"
				gunichar _tmp43_ = 0U;
#line 1244 "../lib/number.vala"
				string_get_prev_char (str, &index, &_tmp43_);
#line 1244 "../lib/number.vala"
				c = _tmp43_;
#line 1245 "../lib/number.vala"
				break;
#line 5827 "number.c"
			}
#line 1248 "../lib/number.vala"
			_tmp44_ = denominator;
#line 1248 "../lib/number.vala"
			_tmp45_ = number_multiply_integer (_tmp44_, (gint64) number_base);
#line 1248 "../lib/number.vala"
			_g_object_unref0 (denominator);
#line 1248 "../lib/number.vala"
			denominator = _tmp45_;
#line 1249 "../lib/number.vala"
			_tmp46_ = numerator;
#line 1249 "../lib/number.vala"
			_tmp47_ = number_multiply_integer (_tmp46_, (gint64) number_base);
#line 1249 "../lib/number.vala"
			_g_object_unref0 (numerator);
#line 1249 "../lib/number.vala"
			numerator = _tmp47_;
#line 1250 "../lib/number.vala"
			_tmp48_ = numerator;
#line 1250 "../lib/number.vala"
			_tmp49_ = number_new_integer ((gint64) i, (gint64) 0);
#line 1250 "../lib/number.vala"
			_tmp50_ = _tmp49_;
#line 1250 "../lib/number.vala"
			_tmp51_ = number_add (_tmp48_, _tmp50_);
#line 1250 "../lib/number.vala"
			_g_object_unref0 (numerator);
#line 1250 "../lib/number.vala"
			numerator = _tmp51_;
#line 1250 "../lib/number.vala"
			_g_object_unref0 (_tmp50_);
#line 5859 "number.c"
		}
#line 1253 "../lib/number.vala"
		_tmp52_ = numerator;
#line 1253 "../lib/number.vala"
		_tmp53_ = denominator;
#line 1253 "../lib/number.vala"
		_tmp54_ = number_divide (_tmp52_, _tmp53_);
#line 1253 "../lib/number.vala"
		_g_object_unref0 (numerator);
#line 1253 "../lib/number.vala"
		numerator = _tmp54_;
#line 1254 "../lib/number.vala"
		_tmp55_ = z;
#line 1254 "../lib/number.vala"
		_tmp56_ = numerator;
#line 1254 "../lib/number.vala"
		_tmp57_ = number_add (_tmp55_, _tmp56_);
#line 1254 "../lib/number.vala"
		_g_object_unref0 (z);
#line 1254 "../lib/number.vala"
		z = _tmp57_;
#line 1234 "../lib/number.vala"
		_g_object_unref0 (denominator);
#line 1234 "../lib/number.vala"
		_g_object_unref0 (numerator);
#line 5885 "number.c"
	}
#line 1257 "../lib/number.vala"
	if (index != end) {
#line 1258 "../lib/number.vala"
		result = NULL;
#line 1258 "../lib/number.vala"
		_g_object_unref0 (z);
#line 1258 "../lib/number.vala"
		return result;
#line 5895 "number.c"
	}
#line 1260 "../lib/number.vala"
	if (negate) {
#line 5899 "number.c"
		Number* _tmp58_;
		Number* _tmp59_;
#line 1261 "../lib/number.vala"
		_tmp58_ = z;
#line 1261 "../lib/number.vala"
		_tmp59_ = number_invert_sign (_tmp58_);
#line 1261 "../lib/number.vala"
		_g_object_unref0 (z);
#line 1261 "../lib/number.vala"
		z = _tmp59_;
#line 5910 "number.c"
	}
#line 1263 "../lib/number.vala"
	result = z;
#line 1263 "../lib/number.vala"
	return result;
#line 5916 "number.c"
}

gint
char_val (gunichar c,
          gint number_base)
{
	gint result = 0;
	gint value = 0;
#line 1268 "../lib/number.vala"
	if (!g_unichar_isxdigit (c)) {
#line 1269 "../lib/number.vala"
		result = -1;
#line 1269 "../lib/number.vala"
		return result;
#line 5931 "number.c"
	}
#line 1271 "../lib/number.vala"
	value = g_unichar_xdigit_value (c);
#line 1273 "../lib/number.vala"
	if (value >= number_base) {
#line 1274 "../lib/number.vala"
		result = -1;
#line 1274 "../lib/number.vala"
		return result;
#line 5941 "number.c"
	}
#line 1276 "../lib/number.vala"
	result = value;
#line 1276 "../lib/number.vala"
	return result;
#line 5947 "number.c"
}

Number*
set_from_sexagesimal (const gchar* str)
{
	Number* result = NULL;
	gint degree_index = 0;
	Number* degrees = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	gint minute_start = 0;
	gunichar c = 0U;
	gunichar _tmp5_ = 0U;
	gint minute_index = 0;
	Number* minutes = NULL;
	gchar* _tmp6_;
	gchar* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* _tmp12_;
	Number* _tmp13_;
	Number* _tmp14_;
	Number* _tmp15_;
	gint second_start = 0;
	gunichar _tmp16_ = 0U;
	gint second_index = 0;
	Number* seconds = NULL;
	gchar* _tmp17_;
	gchar* _tmp18_;
	Number* _tmp19_;
	Number* _tmp20_;
	Number* _tmp21_;
	Number* _tmp22_;
	Number* _tmp23_;
	Number* _tmp24_;
	Number* _tmp25_;
	Number* _tmp26_;
	gunichar _tmp27_ = 0U;
#line 1279 "../lib/number.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 1281 "../lib/number.vala"
	degree_index = string_index_of_char (str, 176U, 0);
#line 1282 "../lib/number.vala"
	if (degree_index < 0) {
#line 1283 "../lib/number.vala"
		result = NULL;
#line 1283 "../lib/number.vala"
		return result;
#line 6001 "number.c"
	}
#line 1284 "../lib/number.vala"
	_tmp0_ = string_substring (str, (glong) 0, (glong) degree_index);
#line 1284 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 1284 "../lib/number.vala"
	_tmp2_ = mp_set_from_string (_tmp1_, 10);
#line 1284 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 1284 "../lib/number.vala"
	_g_free0 (_tmp1_);
#line 1284 "../lib/number.vala"
	degrees = _tmp3_;
#line 1285 "../lib/number.vala"
	_tmp4_ = degrees;
#line 1285 "../lib/number.vala"
	if (_tmp4_ == NULL) {
#line 1286 "../lib/number.vala"
		result = NULL;
#line 1286 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1286 "../lib/number.vala"
		return result;
#line 6025 "number.c"
	}
#line 1287 "../lib/number.vala"
	minute_start = degree_index;
#line 1289 "../lib/number.vala"
	string_get_next_char (str, &minute_start, &_tmp5_);
#line 1289 "../lib/number.vala"
	c = _tmp5_;
#line 1291 "../lib/number.vala"
	if (string_get (str, (glong) minute_start) == '\0') {
#line 1292 "../lib/number.vala"
		result = degrees;
#line 1292 "../lib/number.vala"
		return result;
#line 6039 "number.c"
	}
#line 1293 "../lib/number.vala"
	minute_index = string_index_of_char (str, (gunichar) '\'', minute_start);
#line 1294 "../lib/number.vala"
	if (minute_index < 0) {
#line 1295 "../lib/number.vala"
		result = NULL;
#line 1295 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1295 "../lib/number.vala"
		return result;
#line 6051 "number.c"
	}
#line 1296 "../lib/number.vala"
	_tmp6_ = string_substring (str, (glong) minute_start, (glong) (minute_index - minute_start));
#line 1296 "../lib/number.vala"
	_tmp7_ = _tmp6_;
#line 1296 "../lib/number.vala"
	_tmp8_ = mp_set_from_string (_tmp7_, 10);
#line 1296 "../lib/number.vala"
	_tmp9_ = _tmp8_;
#line 1296 "../lib/number.vala"
	_g_free0 (_tmp7_);
#line 1296 "../lib/number.vala"
	minutes = _tmp9_;
#line 1297 "../lib/number.vala"
	_tmp10_ = minutes;
#line 1297 "../lib/number.vala"
	if (_tmp10_ == NULL) {
#line 1298 "../lib/number.vala"
		result = NULL;
#line 1298 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1298 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1298 "../lib/number.vala"
		return result;
#line 6077 "number.c"
	}
#line 1299 "../lib/number.vala"
	_tmp11_ = degrees;
#line 1299 "../lib/number.vala"
	_tmp12_ = minutes;
#line 1299 "../lib/number.vala"
	_tmp13_ = number_divide_integer (_tmp12_, (gint64) 60);
#line 1299 "../lib/number.vala"
	_tmp14_ = _tmp13_;
#line 1299 "../lib/number.vala"
	_tmp15_ = number_add (_tmp11_, _tmp14_);
#line 1299 "../lib/number.vala"
	_g_object_unref0 (degrees);
#line 1299 "../lib/number.vala"
	degrees = _tmp15_;
#line 1299 "../lib/number.vala"
	_g_object_unref0 (_tmp14_);
#line 1300 "../lib/number.vala"
	second_start = minute_index;
#line 1301 "../lib/number.vala"
	string_get_next_char (str, &second_start, &_tmp16_);
#line 1301 "../lib/number.vala"
	c = _tmp16_;
#line 1303 "../lib/number.vala"
	if (string_get (str, (glong) second_start) == '\0') {
#line 1304 "../lib/number.vala"
		result = degrees;
#line 1304 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1304 "../lib/number.vala"
		return result;
#line 6109 "number.c"
	}
#line 1305 "../lib/number.vala"
	second_index = string_index_of_char (str, (gunichar) '"', second_start);
#line 1306 "../lib/number.vala"
	if (second_index < 0) {
#line 1307 "../lib/number.vala"
		result = NULL;
#line 1307 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1307 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1307 "../lib/number.vala"
		return result;
#line 6123 "number.c"
	}
#line 1308 "../lib/number.vala"
	_tmp17_ = string_substring (str, (glong) second_start, (glong) (second_index - second_start));
#line 1308 "../lib/number.vala"
	_tmp18_ = _tmp17_;
#line 1308 "../lib/number.vala"
	_tmp19_ = mp_set_from_string (_tmp18_, 10);
#line 1308 "../lib/number.vala"
	_tmp20_ = _tmp19_;
#line 1308 "../lib/number.vala"
	_g_free0 (_tmp18_);
#line 1308 "../lib/number.vala"
	seconds = _tmp20_;
#line 1309 "../lib/number.vala"
	_tmp21_ = seconds;
#line 1309 "../lib/number.vala"
	if (_tmp21_ == NULL) {
#line 1310 "../lib/number.vala"
		result = NULL;
#line 1310 "../lib/number.vala"
		_g_object_unref0 (seconds);
#line 1310 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1310 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1310 "../lib/number.vala"
		return result;
#line 6151 "number.c"
	}
#line 1311 "../lib/number.vala"
	_tmp22_ = degrees;
#line 1311 "../lib/number.vala"
	_tmp23_ = seconds;
#line 1311 "../lib/number.vala"
	_tmp24_ = number_divide_integer (_tmp23_, (gint64) 3600);
#line 1311 "../lib/number.vala"
	_tmp25_ = _tmp24_;
#line 1311 "../lib/number.vala"
	_tmp26_ = number_add (_tmp22_, _tmp25_);
#line 1311 "../lib/number.vala"
	_g_object_unref0 (degrees);
#line 1311 "../lib/number.vala"
	degrees = _tmp26_;
#line 1311 "../lib/number.vala"
	_g_object_unref0 (_tmp25_);
#line 1312 "../lib/number.vala"
	string_get_next_char (str, &second_index, &_tmp27_);
#line 1312 "../lib/number.vala"
	c = _tmp27_;
#line 1315 "../lib/number.vala"
	if (string_get (str, (glong) second_index) == '\0') {
#line 1316 "../lib/number.vala"
		result = degrees;
#line 1316 "../lib/number.vala"
		_g_object_unref0 (seconds);
#line 1316 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1316 "../lib/number.vala"
		return result;
#line 6183 "number.c"
	} else {
#line 1318 "../lib/number.vala"
		result = NULL;
#line 1318 "../lib/number.vala"
		_g_object_unref0 (seconds);
#line 1318 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1318 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1318 "../lib/number.vala"
		return result;
#line 6195 "number.c"
	}
#line 1279 "../lib/number.vala"
	_g_object_unref0 (seconds);
#line 1279 "../lib/number.vala"
	_g_object_unref0 (minutes);
#line 1279 "../lib/number.vala"
	_g_object_unref0 (degrees);
#line 6203 "number.c"
}

gboolean
mp_is_overflow (Number* x,
                gint wordlen)
{
	gboolean result = FALSE;
	Number* t2 = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
#line 1322 "../lib/number.vala"
	g_return_val_if_fail (x != NULL, FALSE);
#line 1324 "../lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 1324 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 1324 "../lib/number.vala"
	_tmp2_ = number_xpowy_integer (_tmp1_, (gint64) wordlen);
#line 1324 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 1324 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 1324 "../lib/number.vala"
	t2 = _tmp3_;
#line 1325 "../lib/number.vala"
	result = number_compare (t2, x) > 0;
#line 1325 "../lib/number.vala"
	_g_object_unref0 (t2);
#line 1325 "../lib/number.vala"
	return result;
#line 6236 "number.c"
}

